#include "stdafx.h"
#include <windows.h>
#include <windowsx.h>
#include <iostream>
#include <fstream>
#include "bmp_control.h"



// RXgN^
bmp_control::bmp_control( HWND hWnd, const SIZE *pSize )
	: hTmpBMP( 0 )
	, hMDC( 0 )
	, hDC( 0 )
	, pImage( NULL )
{
	this->sImageSize = *pSize;

	HDC hDC = ::GetDC( hWnd );

	BITMAPINFO biBMP;
	ZeroMemory(&biBMP, sizeof(biBMP));
	// 32rbgŒ
	biBMP.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	biBMP.bmiHeader.biBitCount = 32;
	biBMP.bmiHeader.biPlanes = 1;
	biBMP.bmiHeader.biWidth = this->sImageSize.cx;
	biBMP.bmiHeader.biHeight = -this->sImageSize.cy;

	this->hTmpBMP = CreateDIBSection( NULL, &biBMP, DIB_RGB_COLORS, (void **)(&this->pImage), NULL, 0 );
	this->hMDC = ::CreateCompatibleDC( hDC );
	::SelectObject( this->hMDC, this->hTmpBMP );

	ReleaseDC(hWnd, hDC);
}

// fXgN^
bmp_control::~bmp_control()
{
	::DeleteObject( this->hTmpBMP );
	::DeleteDC( this->hMDC );
}

// rbg}bvۑ
void bmp_control::Save( const char *pcName )
{
	std::ofstream f;
	f.open( pcName );

	DWORD dwSizeImage = this->sImageSize.cx * this->sImageSize.cy * 4;

	// t@Cwb_
	BITMAPFILEHEADER bmfHeader = { 0 };
	bmfHeader.bfType    = *(LPWORD)"BM";
	bmfHeader.bfSize    = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + dwSizeImage;
	bmfHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	f.write( (const char*)&bmfHeader, sizeof(bmfHeader) );

	// 32rbgŒ
	BITMAPINFOHEADER bmiHeader = { 0 };
	bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmiHeader.biBitCount = 32;
	bmiHeader.biPlanes = 1;
	bmiHeader.biWidth = this->sImageSize.cx;
	bmiHeader.biHeight = -this->sImageSize.cy;
	bmiHeader.biSizeImage = dwSizeImage;
	bmiHeader.biCompression = BI_RGB;
	f.write( (const char*)&bmiHeader, sizeof(bmiHeader) );

	f.write( (const char*)this->pImage, dwSizeImage );
	f.close();
}



// rbg}bv擾
void bmp_control::GetBmpInfo( BITMAP *pOutBmp ) const
{
	if ( pOutBmp == NULL ) return;
	//HBITMAPBITMAP擾
	::GetObject( this->hTmpBMP , sizeof( BITMAP ) , pOutBmp );
}

// Cӂ̃sNZf[^擾
bmp_color *bmp_control::GetPixel( int iX, int iY )
{
	bmp_color *pPixel = (bmp_color *)this->pImage;
	return pPixel + ((this->sImageSize.cx * iY) + iX);
}

bmp_color *bmp_control::GetPixel( int iIndex )
{
	bmp_color *pPixel = (bmp_color *)this->pImage;
	return pPixel + iIndex;
}


// SẴsNZɑ΂ďs
void bmp_control::PixControl( PixControlFunc *pFunc )
{
	BITMAP bmp;
	this->GetBmpInfo( &bmp );
	LPBYTE lpSrc = this->pImage;
	
	int iNextByte = bmp.bmBitsPixel / 8;
	for( int j = 0; j < bmp.bmHeight; j++ )
	{
		for( int i = 0; i < bmp.bmWidth; i++ )
		{
			// sNZ
			// 

			pFunc( i, j, (bmp_color *)lpSrc );
#if 0
			bmp_color *pColor =(bmp_color *)lpSrc;
			pColor->b = 255;
			pColor->g = i;
			pColor->r = j;
			pColor->a = 255;
#endif
			lpSrc += iNextByte;
		}
	}
}

// C[WCӂ̐FœhԂ
void bmp_control::ClearImage( const bmp_color *pColor )
{
	HBRUSH hBrush = ::CreateSolidBrush( RGB( pColor->r, pColor->g, pColor->b) );
	::SelectObject( hDC, hBrush );
	::PatBlt( this->hMDC,      // foCXReLXg̃nh
				0,   // `̍ x W
				0,   // `̍ y W
				this->sImageSize.cx,   // `̕
				this->sImageSize.cy,  // `̍
				PATCOPY );   // X^Iy[VR[h

	DeleteObject( hBrush );
}


// bmp̃C[WŜCӂ̏ꏊɕ`
void bmp_control::BitBlt( HDC hOut, const POINT *pDistPos )
{
	::BitBlt( hOut, pDistPos->x, 
					pDistPos->y, 
					this->sImageSize.cx,
					this->sImageSize.cy,
			  this->hMDC,
					0, 0, SRCCOPY );
}

// bmp̃C[WCӂ̏ꏊɕ`
void bmp_control::BitBlt( HDC hOut, const RECT *pOutRect, const POINT *pSrcPos )
{
	if ( this->hMDC == 0 ) return;
	if ( this->hTmpBMP == 0 ) return;
	if ( pOutRect == NULL ) return;
	if ( pSrcPos == NULL ) return;

	::BitBlt( hOut, pOutRect->top, 
					pOutRect->left, 
					pOutRect->right - pOutRect->left,
					pOutRect->bottom - pOutRect->top,
			  this->hMDC,
					pSrcPos->x,
					pSrcPos->y,
					SRCCOPY );
}

