#ifndef INCLUDE_DX_SOUND_H
#define INCLUDE_DX_SOUND_H
#include <windows.h>
#include <mmsystem.h>
#include <cassert>
#include <dsound.h>


struct WAVEFORMATEX_Ctrl: public WAVEFORMATEX
{
public :
	void Init( WORD nInChannels, DWORD nInSamplesPerSec, WORD wInBitsPerSample )
	{
		ZeroMemory(this, sizeof(WAVEFORMATEX)); 
		this->wFormatTag = (WORD)WAVE_FORMAT_PCM; 
		this->nChannels = nInChannels; 
		this->nSamplesPerSec = nInSamplesPerSec; 
		this->wBitsPerSample = wInBitsPerSample; 
		this->nBlockAlign = (WORD)(this->wBitsPerSample / 8 * this->nChannels);
		this->nAvgBytesPerSec = (DWORD)(this->nSamplesPerSec * this->nBlockAlign);
	}
};

struct DSBUFFERDESC_Ctrl : public DSBUFFERDESC
{
public :
	// RXgN^
	DSBUFFERDESC_Ctrl()
	{
		ZeroMemory(this, sizeof(DSBUFFERDESC));
		this->dwSize = sizeof(DSBUFFERDESC);
	}
};


//Direct3D9t[[NNX
class dx_sound
{
private:
	HWND				hWnd;
	IDirectSound		*pSound;
	LPDIRECTSOUNDBUFFER pPrimaryBuffer;

	// RXgN^
	dx_sound();

public:

	// VOg
	static dx_sound &Instance()
	{
		static dx_sound instance;
		return instance;
	}

	// TEhfoCX擾
	IDirectSound *Device() const { return this->pSound; }

	// ^[Qbg擾
	HWND Target() const { return this->hWnd; }


	// FԍŏɂsKv܂B
	bool Init( HWND hWnd );

	// 
	void Dispose();

	// fXgN^
	~dx_sound();

};

#endif // INCLUDE_DX_SOUND_H