#include "stdafx.h"
#include "dx_sprite.h"
#include "dx_control.h"


//2D_tH[}bg
struct D3DTLVERTEX
{
    D3DXVECTOR3 position;	// W
    D3DCOLOR    color;		// _F
    FLOAT       tu, tv;		// UV
};

#define D3DFVF_2DVERTEX (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1)



//
bool dx_sprite::Init()
{
	LPDIRECT3DDEVICE9 pDevice = dx_control::Instance().Device();
	// {̓AT[g
	if ( pDevice == NULL ) return false;

	return SUCCEEDED( pDevice->CreateVertexBuffer( sizeof(D3DTLVERTEX) * 4,
										0, 
										D3DFVF_2DVERTEX, 
										D3DPOOL_DEFAULT, 
										&this->pVB, 
										NULL ) ) ? true : false ;
}

//UVlĐݒ
void dx_sprite::SetUV( const D3DXVECTOR2 *pUV )
{
	this->sUV.x = pUV->x;
	this->sUV.y = pUV->y;
	this->bUpdate = true;
}

void dx_sprite::SetSize( const D3DXVECTOR2 *pSize )
{
	this->sSize.x = pSize->x;
	this->sSize.y = pSize->y;
	this->bUpdate = true;
}



//_Zbg
bool dx_sprite::Update()
{
	if(!this->pVB) return false;

	D3DTLVERTEX	*pV = NULL;
	if ( FAILED( this->pVB->Lock( 0, 0, (void**)&pV, 0 ) ) )
		return false;

	const D3DXVECTOR3 avPosBase[] = 
	{
		D3DXVECTOR3( 0.0f, 0.0f, 0.0f ),
		D3DXVECTOR3( 1.0f, 0.0f, 0.0f ),
		D3DXVECTOR3( 1.0f, 1.0f, 0.0f ),
		D3DXVECTOR3( 0.0f, 1.0f, 0.0f ),
	};

	// _ݒ
	for ( int i = 0; i < 4; i++ )
	{
		pV[i].position.x = avPosBase[ i ].x * this->sSize.x;
		pV[i].position.y = avPosBase[ i ].y * this->sSize.y;
		pV[i].color = D3DCOLOR_ARGB( 255,255,255,255 );
		pV[i].tu = avPosBase[ i ].x;	// Ƃ肠
		pV[i].tv = avPosBase[ i ].y;	// Ƃ肠
	}

	if ( FAILED( this->pVB->Unlock() ) ) return false;

	return true;
}

//`
bool dx_sprite::Draw( const D3DXMATRIX *pmParent, D3DCOLOR Color )
{
	LPDIRECT3DDEVICE9 pDevice = dx_control::Instance().Device();
	if ( pDevice == NULL ) return false;


	if ( this->bUpdate )
	{
		this->Update();
		this->bUpdate = false;
	}


	D3DXMATRIX mView;
	D3DXMATRIX mProjection;

	// vWFNV
	D3DXMatrixOrthoOffCenterLH( &mProjection,
					0.0f,
					640.0f,		// KF{Client Width
					480.0f,		// KF{Client Hight
					0.0f,
					0.0f,
					10.0f);

	// r[|[g
	D3DXMatrixLookAtLH( &mView, 
		&D3DXVECTOR3( 0.0f, 0.0f, 0.0f ),	// _
		&D3DXVECTOR3( 0.0f, 0.0f, 1.0f ),	// ʒu
		&D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );	// UpVector


	pDevice->SetTransform( D3DTS_VIEW, &mView );
	pDevice->SetTransform( D3DTS_PROJECTION, &mProjection );

//	pDevice->SetTransform( D3DTS_WORLD, &mModel );
	pDevice->SetTransform( D3DTS_WORLD, pmParent );


	pDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );

	// At@uhIy[VH


	pDevice->SetRenderState( D3DRS_SPECULARENABLE, FALSE );

	// ȉ͑Să}eA\[Xɂ
	pDevice->SetRenderState( D3DRS_AMBIENTMATERIALSOURCE, D3DMCS_MATERIAL );
	pDevice->SetRenderState( D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_MATERIAL );
	pDevice->SetRenderState( D3DRS_EMISSIVEMATERIALSOURCE, D3DMCS_MATERIAL );

	pDevice->SetRenderState( D3DRS_COLORVERTEX, TRUE );

//	pDevice->SetRenderState( D3DRS_AMBIENT, D3DCOLOR_ARGB( 255,255,255,255 ));
	pDevice->SetRenderState( D3DRS_AMBIENT, Color );
	
	// }eAĝŃCgONɂB
	// AACgf[^͑SOFFɂB
	pDevice->SetRenderState( D3DRS_LIGHTING, TRUE );
//	pDevice->SetRenderState( D3DRS_LIGHTING, FALSE );



	pDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_MODULATE );
	pDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
	pDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_CURRENT );

	pDevice->SetSamplerState( 0, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP );
	pDevice->SetSamplerState( 0, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP );

	pDevice->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, 0 );
	pDevice->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );


	// őSẴCg񂷂悤ɂ
	for ( int i = 0; i < 6; i++ )
	{
		pDevice->LightEnable( i, FALSE );
	}

	//	pDevice->SetMaterial( );
	pDevice->SetTexture( 0, NULL );

	D3DXMATRIX mTexture;
	D3DXMatrixIdentity( &mTexture );
	pDevice->SetTransform( D3DTS_TEXTURE0, &mTexture );

	D3DMATERIAL9 sMaterial = 
	{
		{ 255.0f, 255.0f, 255.0f, 255.0f },/* Diffuse color RGBA */
		{ 255.0f, 255.0f, 255.0f, 255.0f },/* Ambient color RGB */
		{ 255.0f, 255.0f, 255.0f, 255.0f },/* Specular 'shininess' */
		{ 255.0f, 255.0f, 255.0f, 255.0f },/* Emissive color RGB */
		1.0f							   /* Sharpness if specular highlight */
	};



	pDevice->SetMaterial( &sMaterial );


	if(FAILED(pDevice->SetStreamSource( 0, this->pVB, 0, sizeof(D3DTLVERTEX) )))
		return false;

	if(FAILED(pDevice->SetFVF( D3DFVF_2DVERTEX )))
		return false;

	if( FAILED( pDevice->DrawPrimitive( D3DPT_TRIANGLEFAN, 0, 2) ))
		return false;

	return true;
}