#include "stdafx.h"
#include "glb/glbDefine.h"
#include "dx/dx_control.h"
#include "dxEventIO.h"

using namespace glb;
namespace dx
{

dxEventIO::dxEventIO()
	: ePushButton( ButtonType::Non )
	, sPointer( 0.0f, 0.0f )
	, bMovePointer( false )
	// ̏
	, eNextPushButton( ButtonType::Non )
	, sNextPointer( 0.0f, 0.0f )
	, bNextMovePointer( false )
{

}


// wmMꂽ̏
bool dxEventIO::WinProc( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch (message)
	{
	case WM_MOUSEMOVE:
		{
			this->sNextPointer.X = (float)LOWORD(lParam);
			this->sNextPointer.Y = (float)HIWORD(lParam);
			this->bNextMovePointer = true;
		}
		break;

	case WM_LBUTTONDOWN:
		this->eNextPushButton = (ButtonType::Type)(this->eNextPushButton | ButtonType::Button1);
		break;
	case WM_LBUTTONUP:
		this->eNextPushButton = (ButtonType::Type)(this->eNextPushButton & ~ButtonType::Button1);
		break;

	case WM_RBUTTONDOWN:
		this->eNextPushButton = (ButtonType::Type)(this->eNextPushButton | ButtonType::Button2);
		break;
	case WM_RBUTTONUP:
		this->eNextPushButton = (ButtonType::Type)(this->eNextPushButton & ~ButtonType::Button2);
		break;

	// Ƃ肠B
	case WM_KEYDOWN:
		this->eNextPushButton = (ButtonType::Type)(this->eNextPushButton | ButtonType::Button3);
		break;
	case WM_KEYUP:
		this->eNextPushButton = (ButtonType::Type)(this->eNextPushButton & ~ButtonType::Button3);
		break;

	// Ȃ
	default:
		return false;
	}

	return true;
}





// ͏Ԃ̍XV
void dxEventIO::Update()
{
	// {^ƃ|C^̏ԍXV
	this->ePushButton = this->eNextPushButton;
	this->sPointer = this->sNextPointer;
	this->bMovePointer = this->bNextMovePointer;
	this->bNextMovePointer = false;
}

// ݉Ă{^擾
ButtonType::Type dxEventIO::PushButton()
{
	return this->ePushButton;
}

// |C^̈ʒu擾
const glb::glbVector2 *dxEventIO::Pointer()
{
	return &this->sPointer;
}

// |C^ۂ擾
bool dxEventIO::IsMovePointer()
{
	return this->bMovePointer;
}


}
