#include "stdafx.h"
#include <windows.h>
#include "glb/glbDefine.h"
#include "dxIOManager.h"
#include "dxObject.h"
#include "dxFile.h"
#include "dxResource.h"
#include "dxEventIO.h"
#include "dxMatrix.h"
#include "dxMaterial.h"
#include "dxObjectFont.h"



using namespace glb;
using namespace evc;

namespace dx
{

	// t@C[h\`FbN
	static bool CheckLoadFileOK( const glbString *pStr )
	{
		const est::vector<unsigned char> &rBuffer = pStr->Buffer();
		switch( pStr->Format() )
		{
			case seTextFormat::Shift_Jis:
				if ( ::GetFileAttributesA( (LPCSTR)&rBuffer[0] ) == 0xffffffff )
				{
					std::string strMsg = (const char *)&rBuffer[0];
					strMsg += "ǂݍ߂܂B";
					::MessageBoxA( 0, strMsg.c_str(), "[h̎s", MB_OK );
					return false;
				}
				break;

			case seTextFormat::Utf16:
				if ( ::GetFileAttributesW( (LPCWSTR)&rBuffer[0] ) == 0xffffffff )
				{
					std::wstring strMsg = (const wchar_t *)&rBuffer[0];
					strMsg += L"ǂݍ߂܂B";
					::MessageBoxW( 0, strMsg.c_str(), L"[h̎s", MB_OK );
					return false;
				}
				break;
		}

		return true;
	}



// RXgN^
dxIOManager::dxIOManager()
	:_bUseMask(false)
{

}

// }gNX쐬
IGLMatrix *dxIOManager::CreateMatrix()
{
	return evc_new dxMatrix();
}

// Pt@C[hǗ쐬
// @param strPath		 : [hvt@C̃pX
// @param pSceneManager : vt@CV[(null=[gV[)
siFile *dxIOManager::CreateLoader( seSceneManager *pinScManager, const glb::glbString *pstrPath )
{
	return CheckLoadFileOK( pstrPath ) ? evc_new dxFile( pstrPath )
									   : null;
}


// IuWFNg쐬֌W
// 

// J[XvCg̍쐬vꂽɌĂяo܂B
siObjectColorSprite *dxIOManager::CreateColorSprite(int iElemID )
{
	return evc_new dxObjectColorSprite();
}


// eNX`XvCg̍쐬vꂽɌĂяo܂B
siObjectTextureSprite *dxIOManager::CreateTextureSprite(int iElemID )
{
	return evc_new dxObjectTextureSprite();
}


// TEh̍쐬vꂽɌĂяo܂B
siObjectSound *dxIOManager::CreateSound(int iElemID, siResourceSound *pSound )
{
	return evc_new dxObjectSound( pSound );
}

// `Ǘ쐬
siObjectFont *dxIOManager::CreateObjectFont( int iElemID )
{
	return evc_new dxObjectFont();
}


// bV`Ǘ쐬
siObjectMesh *dxIOManager::CreateMesh( int iElemID, MeshIndex::Type indexType, int iVertexCount, int iIndexCount )
{
	return evc_new dxObjectMesh( indexType, iVertexCount, iIndexCount );
}



// \[X쐬֌W
//

// eNX`\[X쐬ɌĂяo܂B
// @parama strName:̓t@CpX
// @retval null:s  !null:
siResourceTexture *dxIOManager::CraeteTextureResource(
							seSceneManager *pSceneManager, 
							const glb::glbString *pstrPath,
							const glbVector2I *pTextureSize )
{
	dxResourceTexture *pTexture = evc_new dxResourceTexture( pstrPath );
	return pTexture;
}

// TEh̃\[X쐬ɌĂяo܂B
// @parama strName:̓t@CpX
// @retval null:s  !null:
siResourceSound *dxIOManager::CraeteSoundResource(
							seSceneManager *pSceneManager,
							const glb::glbString *pstrPath )
{
	return CheckLoadFileOK( pstrPath ) ? evc_new dxResourceSound( pstrPath )
									   : null;
}


// }XN֌W
//

// V}XNo^
// }XN`悪Ă΂钼OɐV}XN̑S̗̈\}gNXƂ
// ̃\bhĂ΂܂B
// RegisterMask͐V}XNݒ肷xɌĂ΂܂B
void dxIOManager::RegisterMask( const IGLMatrix *pm, const glbVector2 *pSize )
{
	this->ClearMask();
	this->_bUseMask = true;
}

// }XN̏Iʒm܂B
// [U}XNIݒvf`悵ɌĂ΂܂B
void dxIOManager::ClearMask()
{
	if ( this->_bUseMask )
	{
		// Zobt@S
		LPDIRECT3DDEVICE9 pDevice = dx_control::Instance().Device();
		pDevice->Clear(0, NULL, D3DCLEAR_ZBUFFER, D3DCOLOR_ARGB(0,0,0,0), 1.0f, 0);
		this->_bUseMask = false;
	}
}

// fobOpo
void dxIOManager::DebugString(const glb::glbString *pstrMsg )
{
	const est::vector<unsigned char> &rBuffer = pstrMsg->Buffer();
	switch( pstrMsg->Format() )
	{
		case seTextFormat::Shift_Jis:
			::OutputDebugStringA( (LPCSTR)&rBuffer[ 0 ] );
			break;

		case seTextFormat::Utf16:
			::OutputDebugStringW( (LPCWSTR)&rBuffer[ 0 ] );
			break;
	}
}

// 
dxIOManager::~dxIOManager()
{
}



}
