#include "stdafx.h"
#include "dx/dx_control.h"
#include "dxMaterial.h"

namespace dx
{

dxMaterial::dxMaterial()
	: iMaskAlpha( 0 )
	, eDoublyType( Doubly::Normal )
	, eBlendType( Blend::NORMAL )
{
}

// Ԃ𔽉f
void dxMaterial::Apply()
{
	LPDIRECT3DDEVICE9 pDevice = dx_control::Instance().Device();

	// d˃^Cv
	switch ( this->eDoublyType )
	{
	// }XNC[W`p
	case Doubly::Mask:
		// At@eXg
		// ȏ̃At@lsNZiɂ
		pDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
		pDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATER );
		pDevice->SetRenderState( D3DRS_ALPHAREF, 255 - this->iMaskAlpha );

		// At@uh
		// `悵Ȃ
		pDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
		pDevice->SetRenderState( D3DRS_BLENDOP, D3DBLENDOP_ADD );
		pDevice->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_ZERO );
		pDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );

		// fvXeXg
		// ōi
		pDevice->SetRenderState( D3DRS_ZENABLE, TRUE );
		pDevice->SetRenderState( D3DRS_ZWRITEENABLE, TRUE );
		pDevice->SetRenderState( D3DRS_ZFUNC, D3DCMP_ALWAYS );
		break;

		// }XNKC[Wp
	case Doubly::MaskReflection:
		// At@eXg֌W
		pDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );

		// fvXeXg֌W
		pDevice->SetRenderState( D3DRS_ZENABLE, TRUE );
		pDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE );
		pDevice->SetRenderState( D3DRS_ZFUNC, D3DCMP_GREATEREQUAL );

		// uh^Cv𔽉f
		this->ApplyBlendType();
		break;

		// ʏ
	case Doubly::Normal:
		pDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
		pDevice->SetRenderState( D3DRS_ZENABLE, FALSE );

		// uh^Cv𔽉f
		this->ApplyBlendType();
		break;

	default:
		// uh^Cv𔽉f
		this->ApplyBlendType();
		break;
	}
}

// uh^Cv𔽉f
void dxMaterial::ApplyBlendType()
{
	LPDIRECT3DDEVICE9 pDevice = dx_control::Instance().Device();


	switch ( this->eBlendType )
	{
	case Blend::ADD:
		pDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
		pDevice->SetRenderState( D3DRS_BLENDOP, D3DBLENDOP_ADD );
		pDevice->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_SRCALPHA );
		pDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );
		break;

	case Blend::NON:
		pDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );
		break;

	case Blend::NORMAL:
		pDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
		pDevice->SetRenderState( D3DRS_BLENDOP, D3DBLENDOP_ADD );
		pDevice->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_SRCALPHA );
		pDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
		break;

	case Blend::XOR:
		pDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
		pDevice->SetRenderState( D3DRS_BLENDOP, D3DBLENDOP_ADD );
		pDevice->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_INVDESTCOLOR );
		pDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ZERO );
		break;
	default:
		break;
	}
}

}
