#include "stdafx.h"
#include "dxMatrix.h"



namespace dx
{

dxMatrix::dxMatrix()
{
}

dxMatrix::~dxMatrix()
{
}

void dxMatrix::SetScale(float x, float y)
{
	D3DXMatrixScaling( &this->m, x, y, 1.0f );
}
void dxMatrix::SetScale( const glbVector2 *pScale )
{
	D3DXMatrixScaling( &this->m, pScale->X, pScale->Y, 1.0f );
}

void dxMatrix::SetPos(float x, float y )
{
	D3DXMatrixTranslation( &this->m, x, y, 0.0f );
}
void dxMatrix::SetPos( const glbVector2 *pPos )
{
	D3DXMatrixTranslation( &this->m, pPos->X, pPos->Y, 0.0f );
}



#if 0
void dxMatrix::SetRotX(float x)
{
	D3DXMatrixRotationX( &this->m, x );
}

void dxMatrix::SetRotY(float y)
{
	D3DXMatrixRotationY( &this->m, y );
}
#endif

void dxMatrix::SetRotZ(float z)
{
	D3DXMatrixRotationZ( &this->m, z );
}

// eNX`}gNXpUVZbg
void dxMatrix::SetUV(float u, float v)
{
	D3DXMatrixIdentity( &this->m );
	// tB
	this->m._31 = u;
	this->m._32 = v;
}
// eNX`}gNXpUVZbg
void dxMatrix::SetUV( const glbVector2 *pUV)
{
	this->SetUV(pUV->X, pUV->Y );
}

void dxMatrix::Mul( const IGLMatrix *pm) // *=
{
	D3DXMatrixMultiply( &this->m, &(((dxMatrix *)pm)->m), &this->m );
}

void dxMatrix::MulR( const IGLMatrix *pm ) // *= : t|
{
	D3DXMatrixMultiply( &this->m, &this->m, &(((dxMatrix *)pm)->m) );
}


// Q_Ɗ|Z
glbVector2 dxMatrix::TransformCoordinate( const glbVector2 *pv ) const
{
	D3DXVECTOR2 sRet( pv->X, pv->Y );
	D3DXVec2TransformCoord( &sRet, &sRet, &this->m );
	return glbVector2 ( sRet.x, sRet.y );
}


// lRs[
void dxMatrix::Copy( const IGLMatrix *pm )
{
	this->m = ((dxMatrix *)pm)->m;
}

// t}gNXɕϊ
void dxMatrix::Invert()
{
	float fDmy;
	D3DXMatrixInverse( &this->m, &fDmy, &this->m );
}
// Pʃ}gNXɂ
void dxMatrix::Identity()
{
	D3DXMatrixIdentity( &this->m );
}

}
