#ifndef INCLUDE_DXMATRIX_H
#define INCLUDE_DXMATRIX_H
#include <d3dx9math.h>
#include "glb/IGLMatrix.h"


using namespace glb;
namespace dx
{
	class dxMatrix : public IGLMatrix
	{
	public:
		D3DXMATRIX m;

		virtual void SetScale(float x, float y);
		virtual void SetScale(const glbVector2 *pScale );

		virtual void SetPos(float x, float y);
		virtual void SetPos( const glbVector2 *pPos );

//		virtual void SetRotX(float x);
//		virtual void SetRotY(float y);
		virtual void SetRotZ(float z);

		// eNX`}gNXpUVZbg
		virtual void SetUV(float u, float v);
		virtual void SetUV( const glbVector2 *pUV );

		virtual void Mul( const IGLMatrix *pm); // *=
		virtual void MulR( const IGLMatrix *pm ); // *= : t|

		// Q_Ɗ|Z
		virtual glbVector2 TransformCoordinate( const glbVector2 *pv ) const;

		// lRs[
		virtual void Copy( const IGLMatrix *pm );
		// t}gNXɕϊ
		virtual void Invert();
		// Pʃ}gNXɂ
		virtual void Identity();

		dxMatrix();
		virtual ~dxMatrix();
	public:
		static const dxMatrix &IdentityMatrix()
		{
			static bool bUpdate = false;
			static dxMatrix IMatrix;
			if ( !bUpdate )
			{
				IMatrix.Identity();
				bUpdate = true;
			}
			return IMatrix;
		}

	};
}
#endif // INCLUDE_DXMATRIX_H
