#include "stdafx.h"
#include <windows.h>
#include <string.h>
#include <mmsystem.h>
#include <dsound.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <d3d9types.h>
#include "glb/glbDefine.h"
#include "glb/glbColor.h"
#include "dxObject.h"
#include "dxResource.h"
#include "dx/dx_sprite.h"
#include "dx/dx_control.h"
#include "dx/dx_sound.h"
#include "dxMatrix.h"
#include "evc/scene/seRootScene.h"
#include "evc/IO/siIOManager.h"
#include "evc/IO/siMaterial.h"
#include "sound/WavFormatCtrl.h"

// eXgp
#include "evc/scene/seElemManager.h"
#include "evc/seElem/seElem.h"



namespace dx
{
	// TEhʃXbh
	DWORD WINAPI SoundProc(LPVOID lpParameter);

	// x[X_f[^Xg
	const static D3DXVECTOR3 s_avPosBase[] = 
	{
		D3DXVECTOR3( 0.0f, 0.0f, 0.0f ),
		D3DXVECTOR3( 1.0f, 0.0f, 0.0f ),
		D3DXVECTOR3( 1.0f, 1.0f, 0.0f ),
		D3DXVECTOR3( 0.0f, 1.0f, 0.0f ),
	};
#if 0
	// }XN
	static void UpdateMask( const glbVector2 *pSize, const IGLMatrix *pMatrix )
	{
		// }XNIuWFNgȂ璼OɃ}XNNA

		siMaterial *pMaterial = seRootScene::Instance()->Material();
		if ( pMaterial == null ) return;

		if ( pMaterial->Doubly() == Doubly::Mask )
		{
			glbVector2 sMin( s_avPosBase[ 0 ].x, s_avPosBase[ 0 ].y );
			sMin.Mul( *pSize );
			sMin = pMatrix->TransformCoordinate( &sMin );
			glbVector2 sMax = sMin;

			for( int i = 1; i < 4; i++ )
			{
				glbVector2 sVartex( s_avPosBase[ i ].x, s_avPosBase[ i ].y );
				sVartex.Mul( *pSize );
				sVartex = pMatrix->TransformCoordinate( &sVartex );
				
				sMin.Set( min( sMin.X, sVartex.X ), min( sMin.Y, sVartex.Y ) );
				sMax.Set( max( sMax.X, sVartex.X ), max( sMax.Y, sVartex.Y ) );
			}


			// ŏɃ}XN`悷͈͂̂yobt@NA
			// 
			// fvXeXgɍiɂAZobt@݂̂XVA
			// ̏Ń}XNp̃XvCg`悵B
			// 

			D3DRECT sClearRect = 
			{ 
				(int)sMin.X, (int)sMin.Y,
				(int)(sMax.X - sMin.X),
				(int)(sMax.Y - sMin.Y),
			};
			dx_control::Instance().Device()->Clear(
							0,
							&sClearRect,
							D3DCLEAR_ZBUFFER,
							D3DCOLOR_XRGB(0,0,0), 
							1.0f, 0 );
		}
	}
#endif

	//_tH[}bg:J[p
	struct D3DVERTEX_COLOR
	{
		D3DXVECTOR3 position;	// W
		D3DCOLOR    color;		// _F

		static const int Format = (D3DFVF_XYZ | D3DFVF_DIFFUSE);
	};

	//2D_tH[}bg:eNX`p
	struct D3DVERTEX_TEXTURE
	{
		D3DXVECTOR3 position;	// W
		D3DCOLOR    color;		// _F
		FLOAT       tu, tv;		// UV

		static const int Format = (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1);
	};


	static D3DMATERIAL9 s_sMaterial = 
	{
		{ 255.0f, 255.0f, 255.0f, 255.0f },/* Diffuse color RGBA */
		{ 255.0f, 255.0f, 255.0f, 255.0f },/* Ambient color RGB */
		{   0.0f,   0.0f,   0.0f,   0.0f },/* Specular 'shininess' */
		{   0.0f,   0.0f,   0.0f,   0.0f },/* Emissive color RGB */
		0.0f							   /* Sharpness if specular highlight */
	};


	// =================================================================
	// XvCgobt@NX
	template<class T>
	class SpriteBuffer
	{
	private:
		LPDIRECT3DVERTEXBUFFER9	pVB;
		int iVertexCount;

		// foCX擾
		LPDIRECT3DDEVICE9 Device() { return dx_control::Instance().Device(); }

	public:

		// _擾
		int VertexCount() { return this->iVertexCount; }

		// RXgN^
		SpriteBuffer( int ivCount )
			: pVB( null )
			, iVertexCount(ivCount)
		{
		}

		// fXgN^
		virtual ~SpriteBuffer()
		{
			this->Dispose();
		}

		// obt@쐬
		void Create()
		{
			// ɂȂx폜
			this->Dispose();

			LPDIRECT3DDEVICE9 pDevice = this->Device();
			HRESULT hRet = pDevice->CreateVertexBuffer(
								sizeof(T) * this->iVertexCount,
								0, 
								T::Format, 
								D3DPOOL_MANAGED,
								// D3DPOOL_DEFAULT, 
								&this->pVB, 
								NULL );
			assert( SUCCEEDED( hRet ) );
		}


		// SĂ̒_f[^ɑ΂ďs
		bool DoAll( deAction2<int, T*> *pFunc )
		{
			if(!this->pVB) return false;

			T *pV = this->BeginEditVertex();
			assert( pV != null );

			// _ݒ
			for ( int i = 0; i < this->iVertexCount; i++ )
			{
				(*pFunc)( i, &pV[i] );
			}

			this->EndEditVertex();
			return true;
		}

		// _ҏWJn
		T *BeginEditVertex()
		{
			if(!this->pVB) return null;

			T *pV = null;
			HRESULT h = this->pVB->Lock(0, 0, (void**)&pV, 0);
			assert(SUCCEEDED(h));

			return pV;
		}

		// _ҏWI
		void EndEditVertex()
		{
			HRESULT h = this->pVB->Unlock();
			assert(SUCCEEDED(h));
		}


		// 
		void Dispose()
		{
			if ( this->pVB != null )
			{
				this->pVB->Release();
				this->pVB = null;
			}
		}

		// `
		void Draw( const IGLMatrix *pmParent, const glbColor *pColor )
		{
			LPDIRECT3DDEVICE9 pDevice = this->Device();
			assert(pDevice != NULL);

			// }gNX̐ݒ
			pDevice->SetTransform( D3DTS_WORLD, &(((dxMatrix *)pmParent)->m) );

			// obt@ݒ
			this->Register(pColor);

			// `
			HRESULT hRet = pDevice->DrawPrimitive( D3DPT_TRIANGLEFAN, 0, 2);
			assert( SUCCEEDED( hRet ) );
		}

		// obt@ݒ
		void Register( const glbColor *pColor )
		{
			LPDIRECT3DDEVICE9 pDevice = this->Device();
			assert(pDevice != NULL);

			// }eAJ[ݒ
			D3DCOLORVALUE c = { (float)pColor->R * (1.0f / 255.0f),
								(float)pColor->G * (1.0f / 255.0f),
								(float)pColor->B * (1.0f / 255.0f), 
								(float)pColor->A * (1.0f / 255.0f) };
			s_sMaterial.Diffuse = s_sMaterial.Ambient = c;
			pDevice->SetMaterial( &s_sMaterial );


			// _ݒ
			HRESULT hRet = pDevice->SetStreamSource( 0, this->pVB, 0, sizeof(T) );
			assert( SUCCEEDED( hRet ) );

			hRet = pDevice->SetFVF( T::Format );
			assert( SUCCEEDED( hRet ) );
		}
	};


	class ColorBuffer : public SpriteBuffer<D3DVERTEX_COLOR>
	{
	public:
		ColorBuffer(int iv) : SpriteBuffer<D3DVERTEX_COLOR>(iv){}
	};
	class TextureBuffer : public SpriteBuffer<D3DVERTEX_TEXTURE>
	{
	public:
		TextureBuffer(int iv) : SpriteBuffer<D3DVERTEX_TEXTURE>(iv){}
	};

	// =================================================================
	// Indexobt@NX(gCAOXg)
	template<class T>
	class dxIndexBuffer
	{
	private:
		LPDIRECT3DINDEXBUFFER9	pIB;	// indexobt@
		int iIndexCount;				// index
		SpriteBuffer<T>		Vertex;		// _ǗNX
		int iPrimCount;					// \v~eBu

		// foCX擾
		LPDIRECT3DDEVICE9 Device() { return dx_control::Instance().Device(); }

	public:
		// index擾
		int IndexCount() { return this->iIndexCount; }

		// _obt@擾
		SpriteBuffer<T> &VertexBuffer() { return this->Vertex; }


		// RXgN^
		dxIndexBuffer( int iVCount, int iICount )
			: pIB( null )
			, iIndexCount(iICount)
			, Vertex( iVCount )
		{
		}

		// fXgN^
		virtual ~dxIndexBuffer()
		{
			this->Dispose();
		}

		// obt@쐬
		void Create()
		{
			// ɂȂx폜
			this->Dispose();

			// _̍쐬
			this->Vertex.Create();

			HRESULT hRet = this->Device()->CreateIndexBuffer(
						sizeof(WORD) * this->iIndexCount,
						0,
						D3DFMT_INDEX16, 
						D3DPOOL_MANAGED,
						&this->pIB,
						NULL);

			// gCAOXgŒ
			this->iPrimCount = this->iIndexCount / 3;

			assert( SUCCEEDED( hRet ) );
		}


		// 
		void Dispose()
		{
			this->Vertex.Dispose();

			if ( this->pIB != null )
			{
				this->pIB->Release();
				this->pIB = null;
			}
		}

		// indexf[^o^
		void SetData( const est::vector<short> &id )
		{
			assert(id.size() == this->iIndexCount);

			short	*pIndex;
			HRESULT h = this->pIB->Lock(0, 0, (void**)&pIndex, 0 );
			assert(SUCCEEDED(h));
			memcpy( pIndex, &id[0], sizeof(short) * id.size() );
			this->pIB->Unlock();
		}

		// `
		void Draw( const IGLMatrix *pmParent, const glbColor *pColor )
		{
			LPDIRECT3DDEVICE9 pDevice = this->Device();
			assert(pDevice != NULL);

			// }gNX̐ݒ
			pDevice->SetTransform( D3DTS_WORLD, &(((dxMatrix *)pmParent)->m) );

			// _f[^̐ݒ
			this->Vertex.Register(pColor);

			HRESULT hRet = pDevice->SetIndices( this->pIB );
			assert( SUCCEEDED( hRet ) );

			// `
			hRet = pDevice->DrawIndexedPrimitive(
								D3DPT_TRIANGLELIST,
								0, 
								0,
								this->Vertex.VertexCount(),
								0,
								this->iPrimCount );
			assert( SUCCEEDED( hRet ) );
		}
	};


	class TextureIndexBuffer : public dxIndexBuffer<D3DVERTEX_TEXTURE>
	{
	public :
		TextureIndexBuffer( int iv, int ii )
			: dxIndexBuffer<D3DVERTEX_TEXTURE>( iv, ii ){}
	};


	// =================================================================
	// J[XvCg`Ǘ
	// 
	dxObjectColorSprite::dxObjectColorSprite()
		: sSize( 0.0f, 0.0f )
		, bUpdate( false )
	{
		this->pBuffer = evc_new ColorBuffer(4);
		this->pBuffer->Create();
	}


	// TCYXVꂽ
	void dxObjectColorSprite::UpdateSize(const glbVector2 *pSize )
	{
		this->sSize.Set( *pSize );
		this->bUpdate = true;
	}


	// `v
	void dxObjectColorSprite::Draw( int iElemID, 
				const IGLMatrix *pmParent, const glbColor *pColor )
	{
		if ( this->bUpdate )
		{
			this->Update();
			this->bUpdate = false;
		}


		// }XN
//		UpdateMask( &this->sSize, pmParent );

		// eNX`𖢎gpԂɂ
		dxResourceTexture::Clear();
		this->pBuffer->Draw( pmParent, pColor );
	}


	//_Zbg
	bool dxObjectColorSprite::Update()
	{
		// _ݒ菈
		struct func : public deAction2<int, D3DVERTEX_COLOR*>
		{
			const glbVector2 *sSize;
			func( const glbVector2 *sInSize ) : sSize( sInSize ) {}
			void operator()( int iIndex, D3DVERTEX_COLOR *ptData )
			{
				// _ݒ
				ptData->position.x = s_avPosBase[ iIndex ].x * this->sSize->X;
				ptData->position.y = s_avPosBase[ iIndex ].y * this->sSize->Y;
				ptData->color = D3DCOLOR_ARGB( 255,255,255,255 );
			}
		};

		return this->pBuffer->DoAll( &func( &this->sSize ) );
	}

	// 
	dxObjectColorSprite::~dxObjectColorSprite()
	{
		if ( this->pBuffer != null )
		{
			delete this->pBuffer;
			this->pBuffer = null;
		}
	}





	// =================================================================
	// eNX`XvCg`Ǘ
	// 



	// RXgN^
	dxObjectTextureSprite::dxObjectTextureSprite()
		: pTexture( null )
		, sSize( 0.0f, 0.0f )
		, sUV( 0.0f, 0.0f )
		, sTextureSize( 0, 0 )
		, bUpdate( false )
	{
		this->pBuffer = evc_new TextureBuffer(4);
		this->pBuffer->Create();
	}


	// eNX`XVꂽ
	void dxObjectTextureSprite::UpdateTexture( IDirect3DTexture9 *pInTexture, const glbVector2I *pSize )
	{
		if ( pInTexture == null )
		{
			this->pTexture = null;
			this->sTextureSize.Set( 0, 0 );
			return;
		}

		this->pTexture = pInTexture;
		this->sTextureSize = *pSize;
	}

	// eNX`XVꂽ
	void dxObjectTextureSprite::UpdateTexture( siResourceTexture *pInTexture )
	{
		if ( pInTexture == null )
		{
			this->pTexture = null;
			this->sTextureSize.Set( 0, 0 );
			return;
		}
		dxResourceTexture *pTexResource = static_cast<dxResourceTexture *>(pInTexture);
		this->pTexture = pTexResource->Texture();
		this->sTextureSize = *pTexResource->TextureSize();
	}

	// TCYXVꂽ
	void dxObjectTextureSprite::UpdateSize( const glbVector2 *pSize )
	{
		this->sSize.Set( *pSize );
		this->bUpdate = true;
	}

	// UVXVꂽ
	void dxObjectTextureSprite::UpdateUV( const glbVector2 *pUV)
	{
		this->sUV.Set( *pUV );
		this->bUpdate = true;
	}

	//_Zbg
	bool dxObjectTextureSprite::Update()
	{

		// UVOffsetZo
		glbVector2 sUVOffset = glbVector2::Zero;
		if ( this->pTexture != null )
		{
			sUVOffset.X = this->sSize.X / this->sTextureSize.X;
			sUVOffset.Y = this->sSize.Y / this->sTextureSize.Y;
		}


		// _ݒ菈
		struct func : public deAction2<int, D3DVERTEX_TEXTURE*>
		{
			const glbVector2 *pSize;
			const glbVector2 *pUV;
			const glbVector2 *pUVOffset;
			func( const glbVector2 *sInSize,
				  const glbVector2 *sInUV,
				  const glbVector2 *pInUVOffset )
				: pSize( sInSize ), pUV( sInUV ), pUVOffset( pInUVOffset ) {}
			void operator()( int iIndex, D3DVERTEX_TEXTURE *ptData )
			{
				const static D3DXVECTOR3 avPosBase[] = 
				{
					D3DXVECTOR3( 0.0f, 0.0f, 0.0f ),
					D3DXVECTOR3( 1.0f, 0.0f, 0.0f ),
					D3DXVECTOR3( 1.0f, 1.0f, 0.0f ),
					D3DXVECTOR3( 0.0f, 1.0f, 0.0f ),
				};

				// _ݒ
				ptData->position.x = avPosBase[ iIndex ].x * this->pSize->X;
				ptData->position.y = avPosBase[ iIndex ].y * this->pSize->Y;
				ptData->color = D3DCOLOR_ARGB( 255,255,255,255 );
				ptData->tu = this->pUVOffset->X * avPosBase[ iIndex ].x + this->pUV->X;	// Ƃ肠
				ptData->tv = this->pUVOffset->Y * avPosBase[ iIndex ].y + this->pUV->Y;	// Ƃ肠
			}
		};

		return this->pBuffer->DoAll( &func( &this->sSize, &this->sUV, &sUVOffset ) );
	}


	// `v
	void dxObjectTextureSprite::Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor)
	{
		this->Draw(iElemID, pmParent, pColor, &dxMatrix::IdentityMatrix() );
	}

	void dxObjectTextureSprite::Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor, const IGLMatrix *pmUV)
	{
		if ( this->bUpdate )
		{
			this->Update();
			this->bUpdate = false;
		}

		// }XN
//		UpdateMask( &this->sSize, pmParent );

		LPDIRECT3DDEVICE9 pDevice = dx_control::Instance().Device();
		assert(pDevice != NULL);

		// eNX`̐ݒ
		pDevice->SetTexture( 0, this->pTexture );
		// eNX`}gNXݒ
		pDevice->SetTransform( D3DTS_TEXTURE0, &(((dxMatrix *)pmUV)->m) );

		this->pBuffer->Draw( pmParent, pColor );
	}


	// 
	dxObjectTextureSprite::~dxObjectTextureSprite()
	{
		if ( this->pBuffer != null )
		{
			delete this->pBuffer;
			this->pBuffer = null;
		}
	}



	// =================================================================
	// bVǗ
	// 

	// RXgN^
	dxObjectMesh::dxObjectMesh(MeshIndex::Type indexType, int iVertexCount, int iIndexCount)
		: pBuffer( evc_new TextureIndexBuffer( iVertexCount, iIndexCount ) )
	{
		assert(indexType == MeshIndex::TriangleList);
		this->pBuffer->Create();
	}

	// fXgN^
	dxObjectMesh::~dxObjectMesh()
	{
		this->Dispose();
		delete this->pBuffer;
	}


	// eNX`XVꂽ
	void dxObjectMesh::UpdateTexture( siResourceTexture *texture )
	{
		if ( texture == null )
		{
			this->pTexture = null;
			this->sTextureSize.Set( 0, 0 );
			return;
		}
		dxResourceTexture *pTexResource = static_cast<dxResourceTexture *>(texture);
		this->pTexture = pTexResource->Texture();
		this->sTextureSize = *pTexResource->TextureSize();
	}


	// `v
	void dxObjectMesh::Draw( int iElemID, const IGLMatrix *m,
				const glbColor *pColor, const IGLMatrix *mUV )
	{
		LPDIRECT3DDEVICE9 pDevice = dx_control::Instance().Device();
		assert(pDevice != NULL);

		// eNX`̐ݒ
		pDevice->SetTexture( 0, this->pTexture );
		// eNX`}gNXݒ
		pDevice->SetTransform( D3DTS_TEXTURE0, &(((dxMatrix *)mUV)->m) );
		this->pBuffer->Draw( m, pColor );
	}


	// 
	void dxObjectMesh::Dispose()
	{
		if ( this->pBuffer != null )
		{
			delete this->pBuffer;
			this->pBuffer = null;
		}
	}

	// _̕ҏWJnAI錾
	void dxObjectMesh::BeginEditVertex(int iElemID)
	{
		SpriteBuffer<D3DVERTEX_TEXTURE> &rv = this->pBuffer->VertexBuffer();
		this->pVEdit = rv.BeginEditVertex();
	}

	void dxObjectMesh::EndEditVertex()
	{
		SpriteBuffer<D3DVERTEX_TEXTURE> &rv = this->pBuffer->VertexBuffer();
		rv.EndEditVertex();
		this->pVEdit = null;
	}

	// _̐VʒuAUVWݒ肵܂B
	void dxObjectMesh::SetPos( int iIndex, const glbVector2 *pos )
	{
		assert(this->pVEdit != null);
		D3DXVECTOR3 &v = this->pVEdit[ iIndex ].position;
		v.x = pos->X;
		v.y = pos->Y;
		v.z = 0.0f;
	}

	void dxObjectMesh::SetUV( int iIndex, const glbVector2 *uv )
	{
		assert( this->pVEdit != null );
		D3DVERTEX_TEXTURE &r = this->pVEdit[ iIndex ];
		r.tu = uv->X;
		r.tv = uv->Y;
	}


	// VIndex̔zݒ肵܂B
	// id̔z񐔂iIndexCountƓłB
	// nźA`撆ێꑱ鎖ۏႳ܂B
	void dxObjectMesh::SetIndex(const est::vector<short> &id)
	{
		// gCAOXgȊO̓AT[g
		this->pBuffer->SetData( id );
	}


	// =================================================================
	// TEhǗ
	//

	dxObjectSound::dxObjectSound( siResourceSound *pResource )
		: pWavFormatCtrl( null )
		, pStream( null )
		, lStreamPos( 0 )	// Xg[͕AN
		, pSecBuffer( null )
		, hThreadID( 0 )
		, pSoundNotify( NULL )
		, bStopSound( false )	// ItO
		, abSoundBuffer( null )
		, bEnableLoop( false )
	{
		this->abSoundBuffer = evc_new char[ dxObjectSound::buffersize / 2 ];

		dxResourceSound *pDxResource = (dxResourceSound *)pResource;

		this->pStream = pDxResource->Stream();
		this->pWavFormatCtrl = pDxResource->WavFormat()->Clone();
		IDirectSound *pSound = dx_sound::Instance().Device();

		// ZJ_obt@쐬
		DSBUFFERDESC_Ctrl dsbd;
		dsbd.dwFlags = DSBCAPS_GETCURRENTPOSITION2 
					 | DSBCAPS_CTRLPOSITIONNOTIFY 
					 | DSBCAPS_CTRLVOLUME
					 | DSBCAPS_CTRLPAN
					 | DSBCAPS_LOCSOFTWARE
					 | DSBCAPS_CTRLFREQUENCY;
//					 | DSBCAPS_GLOBALFOCUS;

		dsbd.dwBufferBytes = dxObjectSound::buffersize;
		dsbd.lpwfxFormat = this->pWavFormatCtrl->Format();

		pSound->CreateSoundBuffer(&dsbd, &this->pSecBuffer, NULL);


		this->hNotificationEvent[ 0 ] = ::CreateEvent(NULL, FALSE, FALSE, NULL);
		this->hNotificationEvent[ 1 ] = ::CreateEvent(NULL, FALSE, FALSE, NULL);

		DSBPOSITIONNOTIFY	aPosNotify[2];
		aPosNotify[0].dwOffset = dxObjectSound::buffersize / 2 - 1;
		aPosNotify[0].hEventNotify = this->hNotificationEvent[ 0 ];
		aPosNotify[1].dwOffset = dxObjectSound::buffersize - 1;
		aPosNotify[1].hEventNotify = this->hNotificationEvent[ 1 ];

		this->pSecBuffer->QueryInterface(IID_IDirectSoundNotify, (VOID**)&this->pSoundNotify );
		this->pSoundNotify->SetNotificationPositions( 2, aPosNotify );
	}


	// obt@Wavf[^
	// @param iBufferID : obt@hc(0 or 1)
	bool dxObjectSound::SetBuffer( int iBufferID )
	{
		// ptO
		bool bContinue = true;

		int iBufferSize = dxObjectSound::buffersize / 2;
		int iFreeSize = iBufferSize;

		// [vĐ̏ꍇ
		if ( this->bEnableLoop )
		{
			while ( iFreeSize > 0 )
			{
				// ǂݍ݃NGXgTCY
				int iOffset = iBufferSize - iFreeSize;
	
				// Xg[f[^[h
				int iReadSize = this->ReadBuffer( iOffset, iFreeSize );

				// ǂݍݒɃXg[IȂ
				if (iReadSize < iFreeSize)
				{
					// 擪ɖ߂B
					this->lStreamPos = this->pWavFormatCtrl->WavOffset() +
										this->pWavFormatCtrl->StartPos();
				}
				iFreeSize -= iReadSize;
			}
		}
		// PĐ̏ꍇ
		else
		{
			// Xg[f[^[h
			int iReadSize = this->ReadBuffer( 0, iFreeSize );

			// ]͖̈ɐݒ肵ĂB
			char bSilent = (this->pWavFormatCtrl->Format()->wBitsPerSample == (short)16) ?
														(char)0x00 : (char)0x80;
			for (int i = iReadSize; i < iBufferSize; i++)
			{
				this->abSoundBuffer[i] = bSilent;
			}

			// P̓f[^Ȃ
			if ( iReadSize == 0 ) bContinue = false;
		}

		int iPosOffset = iBufferSize * iBufferID;

		
		VOID *pDSLockedBuffer = NULL;
		DWORD dwDSLockedBufferSize = 0;
		this->pSecBuffer->Lock( iPosOffset, iBufferSize,
								&pDSLockedBuffer, 
								&dwDSLockedBufferSize, 
								NULL, NULL, 0L);

		// ڃbNobt@ɏo͂邱Ƃ\B
		// bNԂƂ邩A]Ƃ邩Av؁B
		// 
		::memcpy( pDSLockedBuffer, (void *)this->abSoundBuffer, dwDSLockedBufferSize );

		this->pSecBuffer->Unlock( pDSLockedBuffer, dwDSLockedBufferSize, NULL, 0);
		return bContinue;
	}


	// [Nobt@Ƀf[^[h
	int dxObjectSound::ReadBuffer( int iOffset, int iReadSize )
	{
		// Xg[f[^[h
		this->pStream->seekg( this->lStreamPos, est::ios::beg );

		// NGXgTCYWav̍Ō̃f[^𒴂ĂȂŌ܂łɂB
		if ((this->lStreamPos + iReadSize) > this->pWavFormatCtrl->LastWavePos())
		{
			iReadSize = (int)(this->pWavFormatCtrl->LastWavePos() - this->lStreamPos);
		}

		int iBfoPos = this->pStream->tellg();
		this->pStream->read( &this->abSoundBuffer[ iOffset ], iReadSize );
		this->lStreamPos = this->pStream->tellg();

		return (int)this->lStreamPos - iBfoPos;
	}

	// TEhʃXbh
	DWORD WINAPI SoundProc( LPVOID lpParameter)
	{
		dxObjectSound *pObjectSound = (dxObjectSound *)lpParameter;

		BOOL bDone = FALSE;
		DWORD dwResult;

		bool abContinue[] = { true, true };

		abContinue[ 0 ] = pObjectSound->SetBuffer( 0 );
		abContinue[ 1 ] = pObjectSound->SetBuffer( 1 );

		pObjectSound->SoundBuffer()->SetCurrentPosition( 0 );
		pObjectSound->SoundBuffer()->Play( 0, 0, DSBPLAY_LOOPING );

		HANDLE *phEvent = pObjectSound->NotificationEvent();
		while(true)
		{
			
			dwResult = MsgWaitForMultipleObjects(
							2, 
							phEvent,
							FALSE, 
							50, 
							QS_ALLEVENTS );

			if ( pObjectSound->StopSound() ) break;

			switch(dwResult)
			{
			// obt@̏
			case WAIT_OBJECT_0 + 0:
			case WAIT_OBJECT_0 + 1:
				{
					// tOĂȂI
					int iIndex = (dwResult - WAIT_OBJECT_0);

					if ( !abContinue[ iIndex ^ 1 ] )
					{
						pObjectSound->StopSound( true );
						break;
					}
					// ͏Ȃ疳
					abContinue[ iIndex ] = pObjectSound->SetBuffer( iIndex );
				}
				break;
			// ^CAEg
			case WAIT_TIMEOUT:
				break;
			}

			if ( pObjectSound->StopSound() ) break;
		}

//		DB_STRING( "end sound\n" );
		pObjectSound->SoundBuffer()->Stop();
		pObjectSound->Play( false );
		return 0;
	}


	// pXVꂽ
	void dxObjectSound::UpdatePan(int value )
	{
		// evc:-1000`1000  DirectX: -10000`10000ɕϊ
		value = value * 10;
		if ( value > 10000 ) value = 10000;
		if ( value < -10000 ) value = -10000;

		this->pSecBuffer->SetPan( (LONG)value );
	}

	// {[XVꂽ
	void dxObjectSound::UpdateVolume(int value )
	{
		// evc:0`1000  DirectX: -10000`0ɕϊ
		value = value * 10 - 10000;
		if ( value > 0 ) value = 0;
		if ( value < -10000 ) value = -10000;

		this->pSecBuffer->SetVolume( (LONG)value );
	}

	// tH[}bgw肵čĐ
	void dxObjectSound::PlayLocal( float fStart, 
				float fPlayTime, bool bEndLimit, bool bLoop )
	{
		// x~߂
		this->Stop();

		this->bEnableLoop = bLoop;
		this->pWavFormatCtrl->Start( fStart );
		this->pWavFormatCtrl->Time( fPlayTime );
		this->pWavFormatCtrl->EndLimit( bEndLimit );
		this->pWavFormatCtrl->SetTime( *this->pStream, 0.0f );

		this->lStreamPos = this->pStream->tellg();

		this->bPlay = true;
		this->bStopSound = false;

		// XbhJn
		DWORD dmy;
		this->hThreadID = ::CreateThread( NULL, 0, SoundProc, this, 0, &dmy );
	}

	// Đv
	void dxObjectSound::Play(int iElemID, float fStart, bool bLoop)
	{
		this->PlayLocal( fStart, 0.0f, false, bLoop );
	}

	void dxObjectSound::Play(int iElemID, float fStart, float fTime, bool bLoop)
	{
		this->PlayLocal( fStart, fTime, true, bLoop );
	}

	// ~v
	void dxObjectSound::Stop()
	{
		this->bStopSound = true;
		if ( this->hThreadID != 0 )
		{
			::WaitForMultipleObjects(1, &this->hThreadID, TRUE, INFINITE);
			::CloseHandle( this->hThreadID );
			this->hThreadID = 0;
		}
		this->bPlay = false;
	}

	// fobOp`
	void dxObjectSound::Draw( const IGLMatrix *pmParent, int iElemID, int iDmy)
	{

	}

	// 
	dxObjectSound::~dxObjectSound()
	{
		// TEh~
		this->Stop();

		if ( this->pWavFormatCtrl != NULL )
		{
			delete this->pWavFormatCtrl;
			this->pWavFormatCtrl = NULL;
		}

		if ( this->abSoundBuffer != NULL )
		{
			delete[] this->abSoundBuffer;
			this->abSoundBuffer = NULL;
		}

		if ( this->pSecBuffer != NULL )
		{
			this->pSecBuffer->Release();
			this->pSecBuffer = NULL;
		}

		if ( this->pSoundNotify != NULL )
		{
			this->pSoundNotify->Release();
			this->pSoundNotify = NULL;
		}

		int iCount = sizeof(this->hNotificationEvent) / sizeof(this->hNotificationEvent[ 0 ]);
		for ( int i = 0; i < iCount; i++ )
		{
			if ( this->hNotificationEvent[ i ] == 0 ) continue;
			::CloseHandle( this->hNotificationEvent[ i ] );
			this->hNotificationEvent[ i ] = 0;
		}
//		this->pStream;	// Xg[̓\[XǗ̕ŕ
	}

}
