#ifndef INCLUDE_DXOBJECT_H
#define INCLUDE_DXOBJECT_H
#include <windows.h>
#include <mmsystem.h>
#include <dsound.h>
#include "evc/IO/siObject.h"


using namespace glb;
using namespace evc;

struct IDirect3DTexture9;
struct IDirectSoundBuffer;
struct IDirectSoundNotify;

namespace dx
{
	struct D3DVERTEX_TEXTURE;
	class dxResourceSound;
	class dxResourceTexture;
	class ColorBuffer;
	class TextureBuffer;
	class WavFormatCtrl;
	class TextureIndexBuffer;

	// ==========================================================
	// J[XvCg`Ǘ
	class dxObjectColorSprite : public siObjectColorSprite
	{
	private:
		glbVector2			sSize;
		bool				bUpdate;
		ColorBuffer			*pBuffer;

	public:
		// TCYXVꂽ
		virtual void UpdateSize(const glbVector2 *pSize );

		// `v
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor);

		// RXgN^/fXgN^
		dxObjectColorSprite();
		virtual ~dxObjectColorSprite();
	private:
		bool Update();
	};


	// ==========================================================
	// eNX`XvCg`Ǘ
	class dxObjectTextureSprite : public siObjectTextureSprite
	{
	private:
		TextureBuffer		*pBuffer;
		IDirect3DTexture9	*pTexture;
		glbVector2			sSize;
		glbVector2			sUV;
		glbVector2I			sTextureSize;
		bool				bUpdate;
	public:
		// eNX`XVꂽ
		virtual void UpdateTexture( siResourceTexture *pTextrue );
		// eNX`XVꂽ
		void UpdateTexture( IDirect3DTexture9 *pInTexture, const glbVector2I *pSize );

		// TCYXVꂽ
		virtual void UpdateSize( const glbVector2 *pSize );
		// UVXVꂽ
		virtual void UpdateUV( const glbVector2 *pUV);

		// `v
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor);
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor, const IGLMatrix *pmUV);

		// RXgN^
		dxObjectTextureSprite();
		// fXgN^
		virtual ~dxObjectTextureSprite();

	private:
		bool Update();
	};

	// ==========================================================
	// bVǗ
	class dxObjectMesh : public siObjectMesh
	{
	private:
		IDirect3DTexture9	*pTexture;
		TextureIndexBuffer	*pBuffer;
		glbVector2I			sTextureSize;
		bool				bUpdate;

		D3DVERTEX_TEXTURE	*pVEdit;	// _ҏWp[N
	public:
		dxObjectMesh(MeshIndex::Type indexType, int iVertexCount, int iIndexCount);
		virtual ~dxObjectMesh();


		// eNX`XVꂽ
		virtual void UpdateTexture( siResourceTexture *pTexture );

		// `v
		virtual void Draw(int iElemID, const IGLMatrix *m, 
						const glbColor *pColor, const IGLMatrix *mUV);
		
		// 
		virtual void Dispose();

		
		// _̕ҏWJnAI錾
		virtual void BeginEditVertex( int iElemID );
		virtual void EndEditVertex();

		// _̐VʒuAUVWݒ肵܂B
		virtual void SetPos( int iIndex, const glbVector2 *pos );
		virtual void SetUV( int iIndex, const glbVector2 *uv );


		// VIndex̔zݒ肵܂B
		// id̔z񐔂iIndexCountƓłB
		// nźA`撆ێꑱ鎖ۏႳ܂B
		virtual void SetIndex(const est::vector<short> &id);
	};


	// ==========================================================
	// TEhǗ
	class dxObjectSound : public siObjectSound
	{
	private:
		static const int buffersize = 262144; //256KB

		WavFormatCtrl		*pWavFormatCtrl;
		est::istream		*pStream;
		long				lStreamPos;	// Xg[͕ANZXAʒu͏ɏĂ
		IDirectSoundBuffer	*pSecBuffer;
		LPDIRECTSOUNDNOTIFY pSoundNotify;
		HANDLE				hThreadID;
		HANDLE				hNotificationEvent[ 2 ];
		HANDLE				hNotifyThread;
		char				*abSoundBuffer;
		bool				bStopSound;	// ItO
		bool				bPlay;
		bool				bEnableLoop;	// [vĐtO

	public:
		// RXgN^
		dxObjectSound( siResourceSound *pResource );
		virtual ~dxObjectSound();


		// TEhobt@擾
		IDirectSoundBuffer *SoundBuffer() const { return this->pSecBuffer; }

		// [vtO擾
		bool EnableLoop() const { return this->bEnableLoop; }

		// ʉ߃Cxgnh擾
		HANDLE *NotificationEvent() { return &this->hNotificationEvent[ 0 ]; }

		// TEh~tO擾
		bool StopSound() const		 { return this->bStopSound; }
		void StopSound( bool value ) { this->bStopSound = value; }

		// Đ̎擾Eݒ
		bool Play() const			{ return this->bPlay; }
		void Play( bool value )		{ this->bPlay = value; }


		// pXVꂽ
		virtual void UpdatePan(int value );
		// {[XVꂽ
		virtual void UpdateVolume(int value );

		// Đv
		virtual void Play(int iElemID, float fStart, bool bLoop);
		virtual void Play(int iElemID, float fStart, float fTime, bool bLoop);

		// ~v
		virtual void Stop();

		// fobOp`
		virtual void Draw( const IGLMatrix *pmParent, int iElemID, int iDmy);

	private:
		// tH[}bgw肵čĐ
		void PlayLocal( float fStart, float fPlayTime, bool bEndLimit, bool bLoop );

		// [Nobt@Ƀf[^[h
		int ReadBuffer( int iOffset, int iReadSize );

	public:
		// obt@Ƀf[^ݒ
		bool SetBuffer( int iBufferID );

	};
}
#endif // INCLUDE_DXOBJECT_H