#include "stdafx.h"
#include <d3d9.h>
#include <d3dx9tex.h>
#include "glb/glbColor.h"
#include "evc/IO/siIOManager.h"
#include "evc/common/seMatrixWork.h"
#include "evc/scene/seRootScene.h"
#include "dxObjectFont.h"
#include "dxMatrix.h"
#include "font/dxObjectFontManager.h"
#include "dxObject.h"


using namespace glb;
using namespace evc;

namespace dx
{
	// PǗ

	// RXgN^
	dxObjectFontChar::dxObjectFontChar( dxObjectFont *pInParent, 
										IDirect3DTexture9 *pInTexture,
										const glbVector2 *pUVPos, 
										const glbVector2 *pSize )
		: pParent( pInParent )
		, pTexture ( pInTexture )
		, sUVPos( pUVPos->X, pUVPos->Y )
		, sSize( pSize->X, pSize->Y )
	{
	}

	// @param mParent  : }gNX
	void dxObjectFontChar::Draw( int iElemID, 
					const IGLMatrix *pmParent, const glbColor *pColor )
	{
		// eNX`̐ݒ
		this->pParent->Sprite()->UpdateTexture( this->pTexture, &this->sTextureSize );

		// }gNX[NT|[gNX
		seUseWorkMatrix gw;
		
		IGLMatrix *mLocal = gw.GetMatrix();
		IGLMatrix *mUV = gw.GetMatrix();
		IGLMatrix *mUVSize = gw.GetMatrix();

		mLocal->SetScale( &this->sSize );

		mUV->SetUV( &this->sUVPos );
		mUVSize->SetScale( &this->sSize );
		mLocal->MulR( pmParent );
		mUV->Mul( mUVSize );

		this->pParent->Sprite()->Draw( iElemID, mLocal, pColor, mUV );
	}


	dxObjectFontChar::~dxObjectFontChar()
	{

	}



	// dxObjectFont
	// 


	// \Ǘ

	// RXgN^
	dxObjectFont::dxObjectFont()
		: pImageManager( null )
	{
		siIOManager *pIOManager = seRootScene::Instance()->IOManager();
		this->pSprite = (dxObjectTextureSprite *)pIOManager->CreateTextureSprite( 0 );
		this->pSprite->UpdateTexture( null );
		this->pSprite->UpdateSize( &glbVector2( 1.0f, 1.0f ) );
		this->pSprite->UpdateUV( &glbVector2( 1.0f, 1.0f ) );

		this->pImageManager = evc_new dxObjectFontImageManager( this );
	}

	// fXgN^
	dxObjectFont::~dxObjectFont()
	{
		this->Clear();
		if ( this->pSprite != null )
		{
			delete this->pSprite;
			this->pSprite = null;
		}

		if ( this->pImageManager != null )
		{
			delete this->pImageManager;
			this->pImageManager = null;
		}
	}


	// tHgX^C쐬
	// \ɎgtHgX^Cʒm܂B
	// ߂lIDƂĕ`敶̃X^Cw肵܂B
	// 
	// @param strFontName	: tHgt@~[w肳܂
	// @param fHeight		: tHg̍w肳܂B
	// @param Style			: tHg̃X^Cw肳܂BseFontStyleQƂĉB
	// @retval ID
	int dxObjectFont::CreateFontStyle( const glb::glbString *strFontName,
								float fHeight, seFontStyle::Type eStyle )
	{
		return this->pImageManager->CreateFontStyle( strFontName, fHeight, eStyle );
	}



	// NX̍쐬Jn錾
	// CreateCharĂ΂OɂPxĂ΂܂B
	void dxObjectFont::BeginCharCreating()
	{
	}

	// o^
	// `ɎgX^CƕĂ΂܂B͎ޕĂ΂܂B
	// F""Ƃf[^\ꍇA'','',''w肵
	// CreateCharꂼĂ΂A߂lsiObjectFontCharĂ΂ʂɕ`悵܂B
	// AAiFontStyleႤƕʕƔ肳܂B
	// F""Ƃ̂APڂƂQڂ̃tHgX^CIDႤꍇ
	// CreateChar͂ꂼ""ɑ΂ČĂ΂܂B
	// 
	// @param iFontStyle	: tHg̃X^ChcBCreateFontStyle̖߂lB
	// @param cChar			: 
	// @retval				: `NX
	siObjectFontChar *dxObjectFont::CreateChar(int iFontStyleID,  seTextFormat::Type eFormat, short sChar )
	{
		return this->pImageManager->CreateChar( iFontStyleID, eFormat, sChar );
	}

	// NX̍쐬I錾
	// CreateChar̓o^IɌĂ΂܂B
	void dxObjectFont::EndCharCreating()
	{
		this->pImageManager->Flush();
	}

	// f[^Sč폜
	void dxObjectFont::Clear()
	{
	}

}
