#ifndef INCLUDE_DXOBJECTFONT_H
#define INCLUDE_DXOBJECTFONT_H
#include "glb/glbVector.h"
#include "evc/IO/siObjectFont.h"


struct IDirect3DTexture9;

using namespace glb;
using namespace evc;
namespace dx
{
	class dxObjectFont;
	class dxObjectFontImageManager;
	class dxObjectTextureSprite;

	// PǗ
	class dxObjectFontChar : public siObjectFontChar
	{
	private:
		dxObjectFont		*pParent;
		IDirect3DTexture9	*pTexture;
		glbVector2			sUVPos;
		glbVector2			sSize;
		glbVector2I			sTextureSize;

	public:
		// RXgN^
		dxObjectFontChar ( dxObjectFont *pParent,
						   IDirect3DTexture9 *pTexture,
						   const glbVector2 *pUVPos, 
						   const glbVector2 *pSize );

		virtual ~dxObjectFontChar();

		// eNX`TCY̎擾Eݒ
		const glbVector2I *TextureSize() const 		 { return &this->sTextureSize; }
		void TextureSize( const glbVector2I *value  ) { this->sTextureSize = *value; }

		// eNX`̎擾Eݒ
		IDirect3DTexture9 *Texture() const		 { return this->pTexture; }
		void Texture( IDirect3DTexture9 *value ) { this->pTexture = value; }

		// TCY擾
		virtual const glbVector2 *Size() const { return &this->sSize; }

		// @param mParent  : }gNX
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor );
	};

	// \Ǘ
	class dxObjectFont: public siObjectFont
	{
	private :
		dxObjectFontImageManager *pImageManager;
		dxObjectTextureSprite	 *pSprite;	// `惏[N
//		est::vector<IDirect3DTexture9 *> ainTextureList;
	public:

		dxObjectFont();
		virtual ~dxObjectFont();


		// XvCg擾
		dxObjectTextureSprite *Sprite() const { return this->pSprite; }

		// tHgX^C쐬
		// \ɎgtHgX^Cʒm܂B
		// ߂lIDƂĕ`敶̃X^Cw肵܂B
		// 
		// @param strFontName	: tHgt@~[w肳܂
		// @param fHeight		: tHg̍w肳܂B
		// @param Style			: tHg̃X^Cw肳܂BseFontStyleQƂĉB
		// @retval ID
		virtual int CreateFontStyle( const glb::glbString *strFontName, float fHeight, seFontStyle::Type eStyle );

		// NX̍쐬Jn錾
		// CreateCharĂ΂OɂPxĂ΂܂B
		virtual void BeginCharCreating();

		// o^
		// `ɎgX^CƕĂ΂܂B͎ޕĂ΂܂B
		// F""Ƃf[^\ꍇA'','',''w肵
		// CreateCharꂼĂ΂A߂lsiObjectFontCharĂ΂ʂɕ`悵܂B
		// AAiFontStyleႤƕʕƔ肳܂B
		// F""Ƃ̂APڂƂQڂ̃tHgX^CIDႤꍇ
		// CreateChar͂ꂼ""ɑ΂ČĂ΂܂B
		// 
		// @param iFontStyle	: tHg̃X^ChcBCreateFontStyle̖߂lB
		// @param iChar			: 
		// @retval				: `NX
		virtual siObjectFontChar *CreateChar(int iFontStyleID, seTextFormat::Type eFormat, short sChar );

		// NX̍쐬I錾
		// CreateChar̓o^IɌĂ΂܂B
		virtual void EndCharCreating();

		// f[^Sč폜
		virtual void Clear();

	};


}
#endif // INCLUDE_DXOBJECTFONT_H