#include "stdafx.h"
#include "dxResource.h"
#include <d3d9.h>
#include <d3dx9tex.h>
#include "dx/dx_control.h"
#include "sound/WavFormatCtrl.h"




using namespace glb;
using namespace evc;
namespace dx
{

	// TEh\[X

	// RXgN^
	dxResourceSound::dxResourceSound( const glb::glbString *pcName )
		: siResourceSound( pcName )
		, pWavFormat( null )
		, bFileStream( false )
	{
		
	}

	// \[X̏
	siResourceInit::Type dxResourceSound::Init( const est::vector<glb::Byte> *buffer )
	{
		est::ifstream *f = evc_new est::ifstream();

		const glbString *pName = siResourceSound::Name();
		const est::vector<unsigned char> &rBuffer = pName->Buffer();
		switch( pName->Format() )
		{
			case seTextFormat::Shift_Jis:
				f->open( (const char *)&rBuffer[ 0 ], est::ios::in | est::ios::binary );
				break;

			case seTextFormat::Utf16:
				f->open( (const wchar_t*)&rBuffer[0], est::ios::in | est::ios::binary );
				break;
		}


		if ( !f->is_open() )
		{
			delete f;
			return siResourceInit::Failure;
		}

		f->seekg( 0, est::ios::end );
		int iFileSize = f->tellg();

		f->seekg( 0, est::ios::beg );


		// t@CTCYȉȂ烁ɓǂݍł܂B
		if ( iFileSize < dxResourceSound::MIN_STREAM_SIZE )
		{
			this->stvMemBuffer.resize( iFileSize );


			f->read( &this->stvMemBuffer[ 0 ], iFileSize );

			this->pStream = evc_new est::istrstream( &this->stvMemBuffer[ 0 ], iFileSize );

			f->close();
			delete f;
			this->bFileStream = false;
		}
		else
		{
			this->pStream = f;
			this->bFileStream = true;
		}

		this->pWavFormat = evc_new WavFormatCtrl();
		this->pWavFormat->Register( *this->pStream );

		return siResourceInit::Success;
	}

	// fXgN^
	dxResourceSound::~dxResourceSound()
	{
		if ( this->pStream != null )
		{
			// t@CXg[̏ꍇ͕
			if ( this->bFileStream )
			{
				((est::ifstream *)(this->pStream))->close();
			}
			// Xg[̏ꍇ͈ꉞNA
			else
			{
				this->stvMemBuffer.clear();
			}
			delete this->pStream;
			this->pStream = null;
		}

		if ( this->pWavFormat != NULL )
		{
			delete this->pWavFormat;
			this->pWavFormat = NULL;
		}
	}




	// eNX`\[X
	//


	dxResourceTexture::dxResourceTexture( const glb::glbString *pcName )
		: siResourceTexture( pcName )
		, pTexture( NULL )
	{
		
	}

	// fXgN^
	dxResourceTexture::~dxResourceTexture()
	{
		if ( this->pTexture != NULL )
		{
			this->pTexture->Release();
			this->pTexture = NULL;
		}
	}

	// eNX`NA(gpԂɂ)
	void dxResourceTexture::Clear()
	{
		dx_control::Instance().Device()->SetTexture( 0, NULL );
	}

	// \[X̏
	siResourceInit::Type dxResourceTexture::Init( const est::vector<glb::Byte> *buffer )
	{
		D3DXIMAGE_INFO sImageInfo;
		if ( FAILED( D3DXGetImageInfoFromFileInMemory(
										&(*buffer)[ 0 ],
										buffer->size(),
										&sImageInfo ) ) )
		{
			// s
			return siResourceInit::Failure;
		}

		this->sImageSize.Set( sImageInfo.Width, sImageInfo.Height );

		// D3DPOOL_MANAGEDŃeNX`̂
		// foCXXg̑Ώ͕KvȂB
		D3DXCreateTextureFromFileInMemory(
							dx_control::Instance().Device(), 
							&(*buffer)[ 0 ],
							buffer->size(),
							&this->pTexture );

		this->stvHit.clear();
		switch( sImageInfo.Format )
		{
			// ̃tH[}bg̏ꍇ̂݃qbgf[^쐬
			case D3DFMT_A8R8G8B8:
			case D3DFMT_A8B8G8R8:
				{
					// eNX`̃C[Wqbgf[^쐬
					D3DLOCKED_RECT r;
					this->pTexture->LockRect( 0, &r, null, D3DLOCK_READONLY );
					unsigned char *pLine = (unsigned char *)r.pBits;
					for ( int y = 0; y < this->sImageSize.Y; y++ )
					{
						unsigned char *pPix = pLine;
						for ( int x = 0; x < this->sImageSize.X; x++ )
						{
							// At@l݂̂𔲂of[^쐬
							this->stvHit.push_back( *(pPix + 3) );
							pPix += 4;
						}
						pLine += r.Pitch;
					}
					this->pTexture->UnlockRect(0);
				}
				break;

			default:
				break;
		}

		return siResourceInit::Success;
	}

	// hbgPʓ蔻
	bool dxResourceTexture::IsHit( const glbVector2I *pHitPos )
	{
		// f[^ꍇ͋`ɓĂ΃qbgƂB
		if ( this->stvHit.empty() ) return true;

		// ͈͊O̓qbgȂ
		int iIndex = pHitPos->Y * this->sImageSize.X + pHitPos->X;
		if ( (int)this->stvHit.size() <= iIndex ) return false;

		// At@lOȏȂqbgƂB
		return (this->stvHit[ iIndex ] > 0) ? true : false;
	}



}
