#include "stdafx.h"
#include <d3d9.h>
#include <d3dx9tex.h>
#include <d3dx9math.h>
#include "dx/font_control.h"
#include "dx/dx_control.h"
#include "dx/bmp_control.h"
#include "io/dxObjectFont.h"
#include "io/font/dxObjectFontManager.h"
#include "io/font/dxObjectFontStyle.h"

// tHgC[WBMPƂďo
// #define OUT_FONT_IMAGE_FILE


using namespace glb;
using namespace evc;
namespace dx
{
	// tH[}bgƃLR[hLʃR[h𐶐
	int dxObjectFontImageManager::CreateCharCode( seTextFormat::Type eFormat, short sChar )
	{
		return (((int)eFormat)<< 16) | sChar;
	}

	// ʃR[hLR[h擾
	static short GetCharCode( int iCode )
	{
		return (short)(iCode&0xffff);
	}
	// ʃR[h當tH[}bg擾
	static seTextFormat::Type GetCharFormat( int iCode )
	{
		return (seTextFormat::Type)(iCode>>16);
	}




	// LXgǗ
	// 
	dxCharList::~dxCharList()
	{
		this->Clear();
	}

	// Cӂ̃tH[}bgƕR[h
	dxObjectFontChar *dxCharList::Find( seTextFormat::Type eFormat, short sChar )
	{
		int iCode = dxObjectFontImageManager::CreateCharCode( eFormat, sChar );
		est::map<int,dxObjectFontChar *>::iterator it = this->dicChar.find( iCode );
		return (it == this->dicChar.end()) ? null : it->second;
	}

	// Po^
	void dxCharList::Add( dxObjectFontChar *pFont, 
						  seTextFormat::Type eFormat, 
						  short sChar )
	{
		int iCode = dxObjectFontImageManager::CreateCharCode( eFormat, sChar );
		assert( this->Find( eFormat, sChar ) == null );
		this->dicChar[ iCode ] = pFont;
	}

	// NA
	void dxCharList::Clear()
	{
		glb::DeleteMap( this->dicChar );
	}

	// eNX`ǉ
	void dxCharList::RegisterTextureInfo( IDirect3DTexture9 *pTexture, 
										  const glbVector2I *pTexSize )
	{
		est::map<int,dxObjectFontChar *>::iterator it = this->dicChar.begin();

		for( ; it != this->dicChar.end(); it ++ )
		{
			if ( it->second->Texture() == null )
			{
				it->second->Texture( pTexture );
				it->second->TextureSize( pTexSize );
			}
		}
	}




	// RXgN^
	dxObjectFontImageManager::dxObjectFontImageManager( dxObjectFont *pInParent )
		: pParent( pInParent )
		, pNowBmp( null )
		, pStyleManager( evc_new dxObjectFontStyleManager() )
	{
		SIZE sImageSize = { dxObjectFontImageManager::ImageSize,
							dxObjectFontImageManager::ImageSize };
		this->pNowBmp = evc_new bmp_control( NULL, &sImageSize );
	}

	dxObjectFontImageManager::~dxObjectFontImageManager()
	{
		this->Dispose();
	}


	// ǗNX쐬
	dxObjectFontChar *dxObjectFontImageManager::CreateChar( int iFontStyle, seTextFormat::Type eFormat, short sChar  )
	{
		// ɓo^ς݂Ȃ炻Ԃ
		est::map<int,dxCharList *>::iterator it = this->dicFontStyle.find( iFontStyle );
		if ( it != this->dicFontStyle.end() )
		{
			dxObjectFontChar *pFont = it->second->Find( eFormat, sChar );
			if ( pFont != null ) return pFont;
		}
		// X^CXgȂꍇ
		else
		{
			this->dicFontStyle[ iFontStyle ] = evc_new dxCharList();
		}

		int iCode = dxObjectFontImageManager::CreateCharCode( eFormat, sChar );
		dxObjectFontChar *pFontChar = this->CreateCharImage( iFontStyle, iCode );

		it = this->dicFontStyle.find( iFontStyle );
		it->second->Add( pFontChar, eFormat, sChar );
		return pFontChar;
	}

	// tHgX^C쐬
	int dxObjectFontImageManager::CreateFontStyle( const glb::glbString *strFontName, float fHeight, seFontStyle::Type Style )
	{
		return this->pStyleManager->Create( strFontName, fHeight, Style );
	}



	// ̈̉
	void dxObjectFontImageManager::Dispose()
	{
		this->Clear();

		GLB_SAFE_DELETE( this->pStyleManager );
		GLB_SAFE_DELETE( this->pNowBmp );
	}


	// f[^SăNA
	void dxObjectFontImageManager::Clear()
	{
		// SẴf[^NA
		glb::DeleteMap( this->dicFontStyle );
		this->pStyleManager->Clear();

		// eNX`̍폜
		VECTOR_FOR_EACH( IDirect3DTexture9*, this->lisTexture,
		{
			(*it)->Release();
		});
		this->lisTexture.clear();
	}



	// o^̎c̃f[^o
	void dxObjectFontImageManager::Flush()
	{
		// P͂ꍇ͖
		if ( (this->sImagePutWorkPos.X == 0.0f) &&
			 (this->sImagePutWorkPos.Y == 0.0f) )
		{
			return;
		}

		this->CnvTexture();
		this->ClearImage();
		this->sImagePutWorkPos.Set( 0.0f, 0.0f );
	}


	// intŒ菭ɕϊ
	void SetFixed( FIXED &rsFixed, int iData )
	{
		rsFixed.value = (short)iData;	// 
		rsFixed.fract = 0;				//  fract/65535
	}


	// bitmapɃLC[Wl߂
	dxObjectFontChar *dxObjectFontImageManager::CreateCharImage( int iFontStyle, int iCode )
	{
		dxObjectFontStyle *pFont = this->pStyleManager->Find( iFontStyle );

		// ʃR[hLR[h擾
		short sChar = GetCharCode( iCode );

		HDC hMem = this->pNowBmp->MemDC();

		// eLXgJ[𔒂ɂ
		::SetTextColor( hMem, RGB(255,255,255) );
		// eLXg̔wiFɂ
		::SetBkColor( hMem, 0 );
			
		// tHgݒ
		pFont->Font()->Begin( hMem );

		TEXTMETRIC tm;
	    GetTextMetrics( hMem, &tm );

		MAT2 mat;
		// intŒ菭ɕϊ
		SetFixed( mat.eM11, 1 );
		SetFixed( mat.eM12, 0 );
		SetFixed( mat.eM21, 0 );
		SetFixed( mat.eM22, 1 );

		GLYPHMETRICS gm;
		// A`GCAXtHgf[^擾
		DWORD dwSize = ::GetGlyphOutline(
							hMem,
							(unsigned int)sChar,
							GGO_GRAY8_BITMAP,
							&gm, 
							0, NULL, &mat );

		// TCYݒ
		glbVector2 sCharSize;
		sCharSize.Set( (float)(gm.gmBlackBoxX + gm.gmptGlyphOrigin.x), (float)tm.tmHeight );


		// zuʒu
		if ( (this->sImagePutWorkPos.X + sCharSize.X) > this->pNowBmp->Size()->cx )
		{
			this->sImagePutWorkPos.Set( 0.0f, this->fLineY );
		}
		// ς܂ŕl߂
		if ( (this->sImagePutWorkPos.Y + sCharSize.Y) > this->pNowBmp->Size()->cy )
		{
			// ܂ł̓o^Uo
			this->Flush();
		}

		// C[WOoCgȏȂ(Oȉ̏ꍇFC[WȂXy[X)
		if ( dwSize > 0 )
		{
			// obt@m
			char *pData = evc_new char[ dwSize ];
			::ZeroMemory( pData, dwSize );

			// ۂɎ擾
			GetGlyphOutline( hMem,
							(unsigned int)sChar,
							GGO_GRAY8_BITMAP,
							&gm,
							dwSize,
							pData,
							&mat );

			// sb`
			int iPitch = (gm.gmBlackBoxX + 3) & 0xfffc;

			for (unsigned int v = 0; v < gm.gmBlackBoxY; v++)
			{
				for (unsigned int u = 0; u < gm.gmBlackBoxX; u++)
				{
					bmp_color *pColor = this->pNowBmp->GetPixel(
									(int)this->sImagePutWorkPos.X + u,
									(int)this->sImagePutWorkPos.Y + tm.tmAscent - gm.gmptGlyphOrigin.y + v );
					
					pColor->a = pData[ u+v*iPitch ] * 255 / 65;
					pColor->r = pColor->g = pColor->b = 255;
				}
			}
			// obt@J
			delete[] pData;
		}

		pFont->Font()->End();

		// UVW̐ݒ
		glbVector2 sUVPos = this->sImagePutWorkPos;
		sUVPos.Scale( 1.0f / (float)dxObjectFontImageManager::ImageSize );
		glbVector2 sSize = glbVector2( (float)sCharSize.X, (float)sCharSize.Y );

		// ̑傫擾
		dxObjectFontChar *pCharInfo = evc_new dxObjectFontChar( this->pParent, null, &sUVPos, &sSize );
		

		this->sImagePutWorkPos.X += sCharSize.X + 1;

		float fWorkY = this->sImagePutWorkPos.Y + sCharSize.Y;
		if ( fWorkY > this->fLineY ) this->fLineY = fWorkY;

		return pCharInfo;
	}



	// bmpeNX`ɂnullo^ĂLɐݒ
	void dxObjectFontImageManager::CnvTexture()
	{
		// C[Wꍇ͖
		if ( this->pNowBmp == null ) return;

		// eNX`̍쐬
		IDirect3DTexture9 *pTexture = NULL;
		if ( FAILED( dx_control::Instance().Device()->CreateTexture(
				dxObjectFontImageManager::ImageSize,
				dxObjectFontImageManager::ImageSize,
				0, 0,
				D3DFMT_A8R8G8B8,
				D3DPOOL_MANAGED,
				&pTexture, NULL )))
		{
			assert( false );
		}

		// JE^NA
		this->iPixCount = 0;



		// eNX`bitmap̃sNZݒ
		D3DLOCKED_RECT rect;
		pTexture->LockRect( 0, &rect, NULL, 0);
		bmp_control *pBmp = this->Bmp();

		bmp_color *pDistPix = (bmp_color *)rect.pBits;
		int iPixCount = pBmp->Size()->cx * pBmp->Size()->cy;
		for ( int i = 0; i < iPixCount; i++ )
		{
			// rgb255,a͐F̕ϒlɂ邱ƂŃA`GCAXɑΉB
			bmp_color *pColor = pBmp->GetPixel( i );
			pDistPix[ i ].a = pColor->a;
			pDistPix[ i ].r = pColor->r;
			pDistPix[ i ].g = pColor->g;
			pDistPix[ i ].b = pColor->b;
		}

		pTexture->UnlockRect(0);

		this->lisTexture.push_back( pTexture );
		

		// At@lFɕϊăeXgo
#if OUT_FONT_IMAGE_FILE
		{
			static int iCount = 0;
			pBmp = this->Bmp();
			iPixCount = pBmp->Size()->cx * pBmp->Size()->cy;
			for ( int i = 0; i < iPixCount; i++ )
			{
				// rgb255,a͐F̕ϒlɂ邱ƂŃA`GCAXɑΉB
				bmp_color *pColor = pBmp->GetPixel( i );
				pColor->r = pColor->g = pColor->b = pColor->a;
				pColor->a = 255;
			}
			std::stringstream ss;
			ss << "tes_font_image" << iCount << ".bmp";
			this->Bmp()->Save( ss.str().c_str() );
			iCount ++;
		}
#endif


		// SẴLɑ΂Ďs
		glbVector2I glbTexSize = glbVector2I( dxObjectFontImageManager::ImageSize,
											  dxObjectFontImageManager::ImageSize );

		est::map<int,dxCharList *>::iterator it = this->dicFontStyle.begin();
		for(; it != this->dicFontStyle.end(); it++ )
		{
			it->second->RegisterTextureInfo( pTexture, &glbTexSize );
		}
	}

	// bmpC[WNA
	void dxObjectFontImageManager::ClearImage()
	{
		bmp_color sColor = { 0, 0, 0, 0};
		this->Bmp()->ClearImage( &sColor );
	}
}
