#include "stdafx.h"
#include "evc/seObject/ObjectParts/seoFont/seFontData.h"
#include "dxObjectFontStyle.h"
#include "dx/font_control.h"

using namespace evc;
using namespace glb;
namespace dx
{

	// tHgX^CǗ


	// RXgN^
	dxObjectFontStyle::dxObjectFontStyle (
				const glb::glbString *strInFontName, 
				float fInHeight, seFontStyle::Type eInStyle )
		: pFont( NULL )
		, fHeight( fInHeight )
		, eStyle( eInStyle )
	{
		this->strFontName = *strInFontName;
		BOOL bBold = ( eStyle == seFontStyle::Bold ) ? TRUE : FALSE;

		const est::vector<unsigned char> &rBuffer = strInFontName->Buffer();
		switch( strInFontName->Format() )
		{
			case seTextFormat::Utf16:
				{
					this->pFont = evc_new font_control( (LPCWSTR)&rBuffer[ 0 ], (int)fHeight, bBold );
				}
				break;
			case seTextFormat::Shift_Jis:
				{
					this->pFont = evc_new font_control( (LPCSTR)&rBuffer[ 0 ], (int)fHeight, bBold );
				}
				break;
		}


	}

	dxObjectFontStyle::~dxObjectFontStyle ()
	{
		GLB_SAFE_DELETE( this->pFont );
	}

	bool dxObjectFontStyle::IsSameData( dxObjectFontStyle *pStyle )
	{
		if ( this->eStyle != pStyle->Style() ) return false;
		if ( this->fHeight != pStyle->Height() ) return false;
		if ( this->strFontName == *(pStyle->FontName()) ) return false;

		return true;
	}


	void dxObjectFontStyle::Dispose()
	{
		GLB_SAFE_DELETE( this->pFont );
	}




	// tHgX^CǗ


	dxObjectFontStyleManager::dxObjectFontStyleManager()
	{

	}

	dxObjectFontStyleManager::~dxObjectFontStyleManager()
	{
		glb::DeleteVector( lisStyle );
	}

	// X^C
	dxObjectFontStyle *dxObjectFontStyleManager::Find( int iIndex )
	{
		if ( iIndex >= (int)this->lisStyle.size() ) return null;
		return this->lisStyle[ iIndex ];
	}

	// @retval ID
	int dxObjectFontStyleManager::Create( const glb::glbString *strFontName,
						float fHeight, seFontStyle::Type Style )
	{
		dxObjectFontStyle *pFontStyle = evc_new dxObjectFontStyle( strFontName, fHeight, Style );

		int iIndex = 0;
		VECTOR_FOR_EACH( dxObjectFontStyle*, this->lisStyle,
		{
			// ɓX^C݂Ȃ
			if ( (*it)->IsSameData( pFontStyle ) )
			{
				delete pFontStyle;
				return iIndex;
			}
			iIndex ++;
		});
		
		this->lisStyle.push_back( pFontStyle );
		return iIndex;
	}


	void dxObjectFontStyleManager::Clear()
	{
		glb::DeleteVector( this->lisStyle );
	}
}
