#include "glbPch.h"
#include "FpAnimHermite.h"
#include "../FePointInfo.h"
#include "evc/common/seMath.h"
#include "evc/file/IseStateIO.h"

using namespace glb;
namespace evc
{
	float FpAnimHermite::GetFramePos( float fAnimFrame,
								const FePointInfo *pBefoInfo, 
								const FePointInfo *pNowInfo)
	{
		float fPointLen = pNowInfo->Rate() - pBefoInfo->Rate();
		
		glbVector2 sPos1( pBefoInfo->Rate(), pBefoInfo->Value());
		glbVector2 sPos2( pNowInfo->Rate(), pNowInfo->Value() );

		return seMath::GetHermiteCurvePoint(
				&sPos1,
				&this->sBefoPower, 
				&sPos2,
				&this->sPower, 
				(fAnimFrame - pBefoInfo->Rate()) / fPointLen).Y;
	}

	void FpAnimHermite::Load(IseStateInput *pInput)
	{
		this->sPower = seIOUtil::ReadVector2(pInput);
		this->sBefoPower = seIOUtil::ReadVector2(pInput);
	}
}
