/**
 * @file siObject.h
 * @brief 
 *
 * @author seri
 */
#ifndef INCLUDE_SIOBJECT_H
#define INCLUDE_SIOBJECT_H

#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "glb/IGLMatrix.h"
#include "evc/IO/siResource.h"

using namespace glb;
namespace evc
{
	/** J[XvCg`Ǘ
	 * @brief PF̒``悷鏈LqĉB
	 */
	class siObjectColorSprite
	{
	public:

		/** 
		 * @brief fXgN^
		 */
		virtual ~siObjectColorSprite(){}

		/** TCY̍XV
		 * @brief TCYݒ肳ꂽɌĂяo܂B
		 * ʏAɂPxĂ΂܂B
		 * XP[Aj[V̓}gNXōs
		 * Aj[Vɂ̃\bh͌Ă΂܂B
		 * @param pSize VTCY
		 */
		virtual void UpdateSize(const glbVector2 *pSize ) = 0;

		/** `v
		 * @brief ێĂTCYɑ΂
		 * ̕ό`}gNXAJ[AK`̕`ĉB
		 * ̃\bh͖t[Ă΂܂B
		 * @param iElemID ̕`vĂGg
		 * @param pmParent ό`}gNX
		 * @param pColor J[
		 */
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor) = 0;
	};

	/** eNX`XvCg`Ǘ
	 * @brief C[W𒣂`̕`揈LqĂB
	 */
	class siObjectTextureSprite
	{
	public:

		/** 
		 * @brief fXgN^
		 */
		virtual ~siObjectTextureSprite(){}

		/** eNX`XVꂽ
		 * @brief ʏ평ɂPxs܂BAAppAj[V̂悤
		 * eNX`؂ւAj[VT|[gꂽꍇA
		 * Aj[Vɕpɂɂ̃\bhĂяo悤ɂȂ\܂B
		 * @param pTextrue VeNX`
		 */
		virtual void UpdateTexture( siResourceTexture *pTextrue ) = 0;

		/** TCY̍XV
		 * @brief TCYݒ肳ꂽɌĂяo܂B
		 * ʏAɂPxĂ΂܂B
		 * XP[Aj[V̓}gNXōs
		 * Aj[Vɂ̃\bh͌Ă΂܂B
		 * @param pSize VTCY
		 */
		virtual void UpdateSize( const glbVector2 *pSize ) = 0;

		/** UV̍XV
		 * @brief UVݒ肳ꂽɌĂяo܂B
		 * ʏAɂPxĂ΂܂B
		 * UVAj[VUV}gNXōs
		 * Aj[Vɂ̃\bh͌Ă΂܂B
		 * @param pUV VUV
		 */
		virtual void UpdateUV( const glbVector2 *pUV) = 0;

		/** `v
		 * @brief ێĂTCY,UV,eNX`ɑ΂āA
		 * ̕ό`}gNXAJ[AK`̕`ĉB
		 * @param iElemID ̕`vĂGg
		 * @param pmParent ό`}gNX
		 * @param pColor J[
		 */
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor) = 0;
		/** `v
		 * @brief ێĂTCY,UV,eNX`ɑ΂āA
		 * ̕ό`}gNXAJ[AUV}gNXK`̕`ĉB
		 * @param iElemID ̕`vĂGg
		 * @param pmParent ό`}gNX
		 * @param pColor J[
		 * @param pmUV UV}gNX
		 */
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor, const IGLMatrix *pmUV) = 0;
	};



	/** CfBbNX̃^Cv
	 * 
	 */
	struct MeshIndex
	{
		enum Type
		{
			/** RindexłP̎Op`܂B
			 * UpdateIndexɓnz͂R̔{ł邱ƂۏႳ܂B
			 */
			TriangleList = 0,
		};
		static int EnumMax() { return (int)TriangleList; }
	};

	// eNX`bV`Ǘ
	class siObjectMesh
	{
	public:
		virtual ~siObjectMesh(){}

		// eNX`XVꂽ
		virtual void UpdateTexture( siResourceTexture *pTexture ) = 0;

		// ʏASetPos,SetUV͂܂Ƃ܂ĉxĂяo܂B
		// BeginEditVertex()AEndEditVertex()͂̍ŏƍŌɌĂяo܂B
		// _̕ҏWJnOAIɏꍇA
		// ̃\bhɋLqĉB
		virtual void BeginEditVertex( int iElemID ) = 0;
		virtual void EndEditVertex() = 0;

		// _̐VWݒ肵܂B
		// ̃\bhBeginEditVertexEndEditVertex̊ԂɌĂ΂܂B
		// @param iIndex : ݒ肷钸_index(0`(_-1)͈̔͂ŌĂяo܂
		// @param pos : W
		virtual void SetPos( int iIndex, const glbVector2 *pos ) = 0;
		// _̐VuvWݒ肵܂B
		// ̃\bhBeginEditVertexEndEditVertex̊ԂɌĂ΂܂B
		// @param iIndex : ݒ肷钸_index(0`(_-1)͈̔͂ŌĂяo܂
		// @param uv : UVW
		virtual void SetUV( int iIndex, const glbVector2 *uv ) = 0;


		// id̔z񐔂iIndexCountƓłB
		// nźA`撆ێꑱ鎖ۏႳ܂B
		// @param indexType : index̃^Cv
		// @param id[] : indexz
		virtual void SetIndex( const est::vector<short> &id ) = 0;


		// `v
		virtual void Draw( int iElemID, const IGLMatrix *m, const glbColor *color, const IGLMatrix *mUV ) = 0;
		
		// 
		virtual void Dispose() = 0;
	};



	/** 
	 * @brief TEhǗ
	 */
	class siObjectSound
	{
	public:

		/** 
		 * @brief fXgN^
		 */
		virtual ~siObjectSound(){}

		/** p(̍E΂)XVꂽ
		 * @brief p̃Aj[VɌĂяo܂B
		 * @param value Vp(-1000:`0:`1000:E)
		 */
		virtual void UpdatePan(int value ) = 0;

		/** {[XVꂽ
		 * @brief {[̃Aj[VɌĂяo܂B
		 * @param value V{[(0:`1000:ő)
		 */
		virtual void UpdateVolume(int value ) = 0;

		/** 
		 * @brief Đv
		 * @param iElemID GgID
		 * @param fStart Jn
		 * @param bLoop [v
		 */
		virtual void Play(int iElemID, float fStart, bool bLoop) = 0;

		/** 
		 * @brief Đv(rI)
		 * @param iElemID GgID
		 * @param fStart Jn
		 * @param fTime Đ
		 * @param bLoop [v
		 */
		virtual void Play(int iElemID, float fStart, float fTime, bool bLoop) = 0;

		/** 
		 * @brief ~v
		 */
		virtual void Stop() = 0;

		/** fobOp`
		 * @brief ʏÃ\bh͉Kv͂܂B
		 * TEhɂXP[ړ̃Aj[VׁA
		 * oIɊmFꍇÃ\bhĂ΂x
		 * KȃTCYɕό`}gNX|``悵ĉB
		 * @param pmParent ό`}gNX
		 * @param iElemID 
		 * @param iDmy
		 */
		virtual void Draw( const IGLMatrix *pmParent, int iElemID, int iDmy) = 0;
	};
}
#endif // INCLUDE_SIOBJECT_H
