/**
 * @file siResource.h
 * @brief 
 *
 * @author seri
 */
#ifndef INCLUDE_SIRESOURCE_H
#define INCLUDE_SIRESOURCE_H
#include "glb/glbDefine.h"
#include "evc/common/seDefine.h"


using namespace glb;
namespace evc
{
	class seSceneManager;
	class siFile;

	// \[X
	struct siResourceState
	{
		enum Type
		{
			Unused = 0, // gp
			Loading, // [h
			Initializing, // 
			Effective, // gp\\[X
			Invalidity, // \[X
		};
	};


	// \[X
	struct siResourceInit
	{
		enum Type
		{
			Success,		// 
			Failure,		// s
			Continuation,	// s
		};
	};



	/** P\[XǗ
	 * @brief ̃NX̓\[X̋ʕłB̃NXp
	 * siResourceSound,siResourceTextureɑ΂ďĉB
	 * Kvȃ\bh
	 * 
	 * bool Init( byte[] abData );
	 * 
	 * ݂̂łB
	 */
	class siResourceBase
	{
	private:
		bool bAutoLoad;
		glb::glbString strName; // \[X(t@C)
		siFile *pFile;

	protected:
		siResourceState::Type eState; // \[X̏

	public:
		/** 
		 * @brief RXgN^
		 * @param pcName
		 */
		siResourceBase(const glb::glbString *pcName);

		/** 
		 * @brief \[X(t@C)擾
		 * @return \[X
		 */
		const glb::glbString *Name() const 		{ return &this->strName; }

		/** 
		 * @brief \[X^Cv擾
		 * @return \[X^Cv
		 */
		virtual emResourceState::Type Type() const = 0;

		/** 
		 * @brief Iۂ
		 * @return true:I false:
		 */
		bool IsEffective() const ;

		/** 
		 * @brief \[X̏Ԃ擾
		 * @return \[X
		 */
		siResourceState::Type State() const { return this->eState; }

		/** 
		 * @brief V[ǂݍݎɃ[hf[^ۂ
		 * @return true:[h false:Aj[Vf[^ɂ郍[h
		 */
		bool IsAutoLoad() const { return this->bAutoLoad; }
		/** 
		 * @brief [h̐ݒ
		 * @param value Vݒ
		 */
		void AutoLoad( bool value ) { this->bAutoLoad = value; }

		/** 
		 * @brief \[X[h(O͎Ow)
		 * @param pSceneManager
		 */
		virtual void Load( seSceneManager *pSceneManager );

		/** 
		 * @brief \[XԍXV
		 */
		virtual void Update();

		/** 
		 * @brief \[X̃LZ
		 */
		virtual void Cancel();

		/** 
		 * @brief [hς݂̃f[^ɑ΂ďs
		 * @param pstvData \[Xf[^̓Ă郁
		 */
		void Register( const est::vector<glb::Byte> *pstvData);



		/** \[X
		 * @brief \[X̏ĉB
		 * Ăяo^C~O̓\[X̎ޕʂɈȉ̒ʂłB
		 *
		 * EeNX`(siResourceTexture)
		 * \[Xf[^̃[hIɌĂяo܂B
		 *
		 * ETEh(siResourceSound)
		 * \[Xvꂽ_ŌĂяo܂Bf[^̓[hꂸA
		 * abDataɂnull܂B
		 *
		 * InitAt@C擾ꍇthis.NamegpĉB
		 * 
		 * ʂɉĈȉ̖߂lԂĂB
		 * RI_Success		IꍇA̒lԂĉB
		 * RI_Initializing	IȂꍇA̒lԂĉB̃t[łxInitĂ΂܂B
		 * RI_Failure		sꍇ̒lԂĉB
		 * @param buffer \[Xf[^̓Ă郁obt@
		 * @return 
		 */
		virtual siResourceInit::Type Init( const est::vector<glb::Byte> *buffer ) = 0;

		/** 
		 * @brief fXgN^
		 */
		virtual ~siResourceBase() {};
	};


	/** 
	 * @brief TEh\[X
	 */
	class siResourceSound : public siResourceBase
	{
	protected:
		/** 
		 * @brief RXgN^
		 * @param pcName \[X(t@C)
		 */
		siResourceSound( const glb::glbString *pcName );

	public:
		/** 
		 * @brief \[X^Cv
		 * @return TEh\[X^Cv
		 */
		virtual emResourceState::Type Type() const { return emResourceState::Sound; }

	};

	/** 
	 * @brief eNX`\[X
	 */
	class siResourceTexture : public siResourceBase
	{
	protected:
		/** 
		 * @brief RXgN^
		 * @param pcName \[X(t@C)
		 */
		siResourceTexture( const glb::glbString *pcName );

	public:
		/** eNX`TCY
		 * @brief eNX`̕AԂĉB
		 * @return eNX`̃TCY
		 */
		virtual const glbVector2I *TextureSize() = 0;

		/** 蔻
		 * @brief w̍W̃C[WȂtrueA
		 * łȂȂfalseԂĉB
		 * @return C[WƂ̃qbg
		 */
		virtual bool IsHit( const glbVector2I *pHitPos ) = 0;

		/** 
		 * @brief \[X^Cv
		 * @return eNX`\[X^Cv
		 */
		virtual emResourceState::Type Type() const { return emResourceState::Image; }
	};


}
#endif // INCLUDE_SIRESOURCE_H
