/**
 * @file seIDManager.h
 * @brief hcǗNX
 * dȂ悤ɂhc𐶐A蓖Ă܂B
 * @author seri
 */
#ifndef INCLUDE_SEIDMANAGER_H
#define INCLUDE_SEIDMANAGER_H
#include "glb/glbDefine.h"
#include "glb/glbDebug.h"


using namespace glb;
namespace evc
{
	template<class T>
	class seIDManager
	{
	private:
		static const int DefaultBaseID = 1000;

		int iBaseID; // Œhc
		est::map<int, T> stmIDList;

	public:
		static const int InvalidID = -1;

		// x[Xhc(Œl)̎擾Eݒ
		int BaseID() const	{ return this->iBaseID; }

		// IuWFNg擾
		int Count() const 	{ return this->stmIDList.size(); }

		seIDManager():iBaseID( DefaultBaseID ){}
		seIDManager(int iInBaseID) : iBaseID( iInBaseID ){}
		virtual ~seIDManager(){}

		// f[^NA
		virtual void Clear()	
		{
			this->stmIDList.clear();
		}

		// XgQƗp
		virtual const est::map<int, T> *Piars() const { return &this->stmIDList; }


		// f[^폜
		virtual T Remove(int iIndex)
		{
			T tData = this->Find(iIndex);
			// vfIuWFNg
			this->stmIDList.erase( iIndex );
		
			// 폜CX^XԂB
			return tData;
		}


		// f[^ǉ
		virtual void Add(int iIndex, T tData)
		{
			// ̂܂B
			GLB_ASSERT( this->stmIDList.find(iIndex) == this->stmIDList.end() );
			this->stmIDList.insert( est::pair<int,T>( iIndex, tData ) );
		}

		virtual int Add(T tData)
		{
			int iIndex = this->GetFreeID();
			this->Add(iIndex, tData);
			return iIndex;
		}

		// vfIuWFNg
		virtual T Find(int iIndex) const
		{
			if ( this->stmIDList.size() == 0 ) return null;
			typename est::map<int,T>::const_iterator it = this->stmIDList.find(iIndex);
			if ( it == this->stmIDList.end() ) return null;

			return it->second;
		}

		// vfID擾
		virtual int Find( T tData ) const
		{
			typename est::map<int,T>::const_iterator it = this->stmIDList.begin();

			while( it != this->stmIDList.end() )
			{
				if ( it->second == tData ) return it->first;
				it ++;
			}
			return seIDManager<T>::InvalidID;
		}


		// ̂hc擾(dicIndexɓo^ĂȂKeyԂ)
		// ۂ߁AxĂ΂ĂlԂASYɂB
		int GetFreeID() const
		{
			if (this->stmIDList.empty())
			{
				return this->BaseID();
			}
		
			int iBfoID = this->BaseID();


			MAP_FOR_EACH_CONST_TMP( int, T, this->stmIDList,
			{
				int iIndex = it->first;

				if ((iIndex - iBfoID) > 1)
				{
					return iBfoID + 1;
				}
				iBfoID = iIndex;
			});
			return iBfoID + 1;
		}

	public:
		// T|C^̎ɂSĊJ
		void DeleteAllInstance()
		{
			MAP_FOR_EACH_TMP( int, T, this->stmIDList,
			{
				GLB_SAFE_DELETE( it->second );
			});
			this->stmIDList.clear();
		}
	};

}
#endif // INCLUDE_SEIDMANAGER_H
