/**
 * @file seMath.h
 * @brief 2DxNgZT|[g
 *
 * @author seri
 */
#ifndef INCLUDE_SEMATH_H
#define INCLUDE_SEMATH_H

#include "glb/glbDefine.h"


using namespace glb;


namespace evc
{
	/** 
	 * @brief 2DxNgZT|[g
	 */
	class seMath
	{
	public:
		/** 
		 * @brief SAXP[A]Aʒu2Dp}gNX𐶐
		 * @param pmRet ʊi[p}gNX
		 * @param pCenter Sʒu
		 * @param pScale g嗦
		 * @param fRot ]
		 * @param pTranslation ړ
		 */
		static void Transformation2D( IGLMatrix *pmRet, 
										const glbVector2 *pCenter, 
										const glbVector2 *pScale, 
										float fRot, 
										const glbVector2 *pTranslation);

		/** 
		 * @brief G~[gԂAW擾
		 * @param pPos1 ʉߓ_P
		 * @param pVec1 _P
		 * @param pPos2 ʉߓ_Q
		 * @param pVec2 _Q
		 * @param fRate 擾Ẅʒu(ʉߓ_P`ʉߓ_Q0.0f`1.0fƂĎw)
		 * @return W
		 */
		static glbVector2 GetHermiteCurvePoint( const glbVector2 *pPos1, const glbVector2 *pVec1, 
												const glbVector2 *pPos2, const glbVector2 *pVec2, float fRate );


		static glbVector2 GetHermiteCurvePoint(
							const glbVector2 *pPos1, const glbVector2 *pVec1, 
							const glbVector2 *pPos2, const glbVector2 *pVec2,
							float fRate, float fPower );

	private:
		/** Q_ΊpƂ钷`mڐGĂ邩
		 * @brief ׁ̈AőEŏ`FbN͏ȂB
		 * ̈IsHitPolypprivate\bhƂB
		 * @param pAMin `P̍W
		 * @param pAMax `P̉EW
		 * @param pBMin `Q̍W
		 * @param pBMax `Q̉EW
		 * @return true:qbg@false:qbgȂ
		 */
		static bool IsHitRectangle( const glbVector2 *pAMin, const glbVector2 *pAMax,
									const glbVector2 *pBMin, const glbVector2 *pBMax);


	public:

		/**
		 * _烉WA擾
		 */
		static float GetRot( const glbVector2 *pStartPos, const glbVector2 *pEndPos );


		/** 
		 * @brief 2_Ԃ̋߂
		 * @param p1 WP
		 * @param p2 WQ
		 * @return 
		 */
		static float GetDistance( const glbVector2 *p1, const glbVector2 *p2);

		/** 
		 * @brief n_AI_Ԓɑ΂ĔCӂ̓_̉Eɂ邩Aɂ邩
		 * @param pStartPos n_
		 * @param pEndPos I_
		 * @param pCheckPos Cӂ̓_
		 * @return true E@false 
		 */
		static bool CheckSide( const glbVector2 *pStartPos, const glbVector2 *pEndPos, const glbVector2 *pCheckPos);

		/** |CgCӂ̋`ɂ邩
		 * @brief `̓_͓ʌ^łKv܂B܂A|Cg̕т
		 * vi܂͔vjłKv܂B
		 * @param pvPoint `WXg
		 * @param pPos |Cg
		 * @return true:` false:`O
		 */
		static bool IsInRect( const est::vector<glbVector2> *pvPoint, const glbVector2 *pPos );

		/** 
		 * @brief Cӂ̓_}gNXϊ`ɂ邩ۂ
		 * @param pSize `TCY
		 * @param pmParent ό`}gNX
		 * @param pPos W
		 * @return true:` false:`O
		 */
		static bool IsInRect( const glbVector2 *pSize, const IGLMatrix *pmParent, const glbVector2 *pPos);

		/** 
		 * @brief Q̐邩
		 * @param pA1 P̍WP
		 * @param pA2 P̍WQ
		 * @param pB1 Q̍WP
		 * @param pB2 Q̍WQ
		 * @return true: false:Ȃ
		 */
		static bool IsCrossLine( const glbVector2 *pA1, const glbVector2 *pA2, 
								 const glbVector2 *pB1, const glbVector2 *pB2);

		/** |SmڐGĂ邩
		 * @brief z̍Ō[0]Ԗڂ͌qĂ`ƂB
		 * @param paList |SWXgP
		 * @param pbList |SWXgQ
		 * @return true:ڐG()Ă false:ڐG()ĂȂ
		 */
		static bool IsHitPoly( const est::vector<glbVector2> *paList,
								const est::vector<glbVector2> *pbList);


	};
}
#endif // INCLUDE_SEMATH_H
