#include "glbPch.h"
#include "glb/glbDefine.h"
#include "glb/glbDebug.h"
#include "glb/IGLMatrix.h"
#include "evc/common/seMatrixWork.h"
#include "evc/IO/siIOManager.h"
#include "evc/scene/seRootScene.h"

using namespace glb;


namespace evc
{
	seMatrixWork::seMatrixWork()
		: iStackNum( 0 )
	{
		siIOManager *pIOManager = seRootScene::Instance()->IOManager();

		this->_identity = pIOManager->CreateMatrix();
		this->_identity->Identity();

		for (int i = 0; i < seMatrixWork::MaxMatrix; i++)
		{
			this->stvWorkMatrix.push_back( pIOManager->CreateMatrix() );
		}
	}

	seMatrixWork::~seMatrixWork()
	{
		GLB_SAFE_DELETE(this->_identity);
		glb::DeleteVector( this->stvWorkMatrix );
	}

	int seMatrixWork::StartMatrix()
	{
		return this->iStackNum;
	}

	int seMatrixWork::EndMatrix(int iStackHandle)
	{
		return this->iStackNum = iStackHandle;
	}

	IGLMatrix *seMatrixWork::GetMatrix()
	{
		this->iStackNum ++;
		GLB_ASSERT(this->iStackNum < seMatrixWork::MaxMatrix);
		return this->stvWorkMatrix[this->iStackNum - 1];
	}

	void seMatrixWork::UseMatrixWork( deAction1<IUseWorkMatrix *> *pCallback )
	{
		int iStartID = this->StartMatrix();
		(*pCallback)(this);
		this->EndMatrix(iStartID);
	}
}
