/**
* @file evCmd.h
* @brief 
*
* @author seri
*/
#ifndef EVCMD_H
#define EVCMD_H
#pragma once
#include "glb/glbDefine.h"
#include "evc/common/seDefine.h"
#include "evc/Event/evDefine.h"
#include "evc/Event/evData.h"
using namespace evc;
using namespace glb;

namespace evc
{
	class IevCmdUI;
	class evCmd;
	class evCmdCond;
	class evCmdEvent;


	// Cxg֐|C^
	typedef bool (DoCmdFunc)(IevCmdUI *cmdUI, evCmd *target);

	class evCmdList
	{
	public:
		// ߃CX^X쐬
		static evCmdCond *CraeteCmd(evCond::Type eCmd, IevCmdUI *ui);
		static evCmdEvent *CraeteCmd(evEvent::Type eCmd, IevCmdUI *ui);
	};


	// ߊ
	class evCmd: public evCmdHeader
	{
		friend class evCmdList;
	private:
		est::vector<evCmdData*> lisData;
		DoCmdFunc *pOnFunc;	// s[`

	public:
		const est::vector<evCmdData*> &Data() const { return this->lisData; }

		// RXgN^
		evCmd();
		virtual ~evCmd();


		void AddData(evCmdData *data);

		// Cӂ̈ʒũf[^ւ
		void SetData(evCmdData *data, int iIndex);

		// RXgN^(N[p)
		evCmd(evCmd *mst);

		// s
		virtual bool DoFunc(IevCmdUI *cmd);
		// [h
		virtual void Load(IseStateInput *inReader, IevCmdUI *inCmdUI);
	};


	class evCmdEvent : public evCmd
	{
		friend class evCmdList;
	private:
		evEvent::Type eCmdType;
	public:
		evEvent::Type CmdType() const { return this->eCmdType; }
		void CmdType(evEvent::Type eType){ this->eCmdType = eType; }

		// ߃^Cv擾
		virtual evCmdType::Type Type() { return evCmdType::Event; }


		evCmdEvent();
		evCmdEvent(evCmdEvent *mst);
		virtual ~evCmdEvent(){}

		virtual evCmdHeader *Clone();
	};


	class evCmdCond : public evCmd
	{
		friend class evCmdList;
	private:
		evCond::Type eCmdType;
	public:
		evCond::Type CmdType() const { return this->eCmdType; }
		void CmdType(evCond::Type eType){ this->eCmdType = eType; }

		// ߃^Cv擾
		virtual evCmdType::Type Type() { return evCmdType::Cond; }

		evCmdCond();
		evCmdCond(evCmdCond *mst);
		virtual ~evCmdCond(){}

		virtual evCmdHeader *Clone();
	};
}
#endif //EVCMD_H

