#include "glbPch.h"
#include "glb/glbDefine.h"
#include "glb/glbDebug.h"
#include "evc/common/seDefine.h"
#include "evc/file/IseStateIO.h"
#include "evc/scene/seSceneManager.h"
#include "evc/seElem/seStateType.h"
#include "evc/seElem/seStateTypeEx.h"
#include "evCmdBase.h"
#include "evManager.h"

using namespace evc;
using namespace glb;
namespace evc
{
	// RXgN^
	evCmdHeader::evCmdHeader()
		: bEnable( true )
		, pParent( null )
	{

	}

	void evCmdHeader::Load(IseStateInput *pReader, IevCmdUI *pCmdUI)
	{
		this->bEnable = pReader->ReadBool();
	}



	evVariable *evCmdUtil::Load( IseStateInput *pReader, IevCmdUI *pCmdInput)
	{
		// Group
		VariableGroup::Type eGroupType = static_cast<VariableGroup::Type>(pReader->ReadByte());
		int iVariableID = static_cast<int>(pReader->ReadShort());
	
		evVariableManager *vm = pCmdInput->SceneManager()->VariableList();
		evVariableGroup *pGroup = null;
		switch (eGroupType)
		{
			case VariableGroup::Global:
				pGroup = vm->GlobalGroup();
				break;
			case VariableGroup::Local:
				pGroup = pCmdInput->LocalVariable();
				break;
			case VariableGroup::Sp:
				pGroup = vm->SpGroup();
				break;
			default:
				break;
		}
		GLB_ASSERT(pGroup != 0);
	
		return pGroup->Find(iVariableID);
	}
}
