/**
 * @file evCmdBase.h
 * @brief 
 *
 * @author seri
 */
#ifndef EVCMDBASE_H
#define EVCMDBASE_H
#pragma once
#include "evc/common/seDefine.h"
using namespace evc;
using namespace glb;

namespace evc
{
	class IseStateInput;
	class IseStateType;
	class evVariableState;
	class evVariableNum;
	class seElem;
	class evCmdFlowIf;
	class evVariable;
	class IevCmdUI;


	// Cxgf[^x[X
	class ICmdBase
	{
	public :
		ICmdBase(){}

		// N[
		virtual ICmdBase *Clone() = 0;
		// f[^[h
		virtual void Load( IseStateInput *pReader, IevCmdUI *pCmdUI ) = 0;
	};


	// ߂̎
	struct evCmdType
	{
		enum Type
		{
			FlowIf,
			Call,
			Event,
			Cond,
		};
	};


	// ߊǗx[X
	class evCmdHeader
	{
		// ߂Lۂ
	private:
		bool bEnable;
		evCmdFlowIf *pParent;

	public:
		evCmdHeader();
		evCmdHeader( const evCmdHeader *pHeader )
		{
			this->bEnable = pHeader->bEnable;
			this->pParent = pHeader->pParent;
		}
		virtual ~evCmdHeader(){}


		bool Enable() const		{ return this->bEnable; }
		void Enable(bool value) { this->bEnable = value; }

		evCmdFlowIf *Parent() const { return this->pParent; }
		void Parent( evCmdFlowIf *value ) { this->pParent = value; }

		// R}h^Cv擾
		virtual evCmdType::Type Type() = 0;

		// s
		virtual bool DoFunc(IevCmdUI* pCmdUI ) = 0;

		// f[^[h
		virtual void Load(IseStateInput *pReader, IevCmdUI *pCmdUI);

		// N[
		virtual evCmdHeader *Clone() = 0;
	};


	// ߊ֌W[eBeB
	class evCmdUtil
	{
	public:
		// ϐQƏ[hđΉϐԂ
		// OɕϐXgSă[hŎs
		static evVariable *Load( IseStateInput *pReader, IevCmdUI *pCmdInput);

		template< class T>
		static T *Load( IseStateInput *pReader, IevCmdUI *pCmdInput)
		{
			return (T *)evCmdUtil::Load( pReader, pCmdInput );
		}
	};
}
#endif //EVCMDBASE_H

