#include "glbPch.h"
#include "evc/file/IseStateIO.h"
#include "evCmdFlowCall.h"
#include "evManager.h"
#include "evCmdFlowIf.h"

namespace evc
{
	evCmdFlowCall::evCmdFlowCall( evCmdFlowCall *pCmdCall )
		: evCmdHeader( pCmdCall )
	{
		this->CallInfo( pCmdCall->CallInfo() );
	}


	bool evCmdFlowCall::DoFunc(IevCmdUI *pCmdUI)
	{
		// ̏ꍇ͂ȂɂȂ
		if (!this->Enable()) return true;
		// Ƃ͉ȂB
		if (this->pCallInfo == null) return true;
		return this->pCallInfo->FlowIf()->DoFunc(pCmdUI);
	}

	void evCmdFlowCall::Load(IseStateInput *pReader, IevCmdUI *pCmdUI)
	{
		int iID = pReader->ReadShort();
		this->pCallInfo = pCmdUI->CallManager()->Find(iID);
	}

	evCmdHeader *evCmdFlowCall::Clone()
	{
		return evc_new evCmdFlowCall( this );
	}

	// evCallInfo
	evCallInfo::evCallInfo()
	{
		this->pFlowIf = evc_new evCmdFlowIf();
	}

	evCallInfo::~evCallInfo()
	{
		GLB_SAFE_DELETE( this->pFlowIf );
	}



	void evCmdFlowCallManager::Load(IseStateInput *pReader, IevCmdUI *pCmdUI)
	{
		this->Clear();
	
		int iCount = pReader->ReadShort();
		seDefine::DebugTrace( "Call Count", iCount);
		for (int i = 0; i < iCount; i++)
		{
			int iID = static_cast<int>(pReader->ReadShort());
			seDefine::DebugTrace( "Call ID", iID);
	
			evCallInfo *pCallInfo = evc_new evCallInfo();
//			pCallInfo.Name = pReader.ReadString();
			pCallInfo->FlowIf()->Load(pReader, pCmdUI);
			this->Add(iID, pCallInfo);
		}
	}
}
