/**
 * @file evCmdFlowIf.h
 * @brief 
 *
 * @author seri
 */
#ifndef EVCMDFLOWIF_H
#define EVCMDFLOWIF_H
#pragma once
#include "glb/glbDefine.h"
#include "evCmdBase.h"

using namespace glb;
namespace evc
{
	class evCmdCond;
	class IseStateInput;
	class IevCmdUI;

	// [hpCxg߃^Cv
	struct LoadCmdType
	{
		enum Type
		{
			FlowIf = 0, // if
			Cond = 2, // s
			Event = 3, // ʏ̃Cxg
			FlowNon = 4, // t[(if̃lXg莞AȂꍇɎw)
			Call = 5, // Tu[`R[
		};

		static int EnumMax() { return Call; }
	};


	// sǗ
	class evCmdFlowCondManager
	{
	private:
		// s
		est::vector<evCmdCond*> lisCondCmd;

	public:
		// RXgN^
		evCmdFlowCondManager(){}
		evCmdFlowCondManager( evCmdFlowCondManager *pCondManager );
		virtual ~evCmdFlowCondManager();

		const est::vector<evCmdCond*> *Cmds() const { return &this->lisCondCmd; }

		// ߂̒ǉ
		void Add(evCmdCond *pCmd);

		// ߂̍폜
		void Remove(evCmdCond *pCmd);

		// s𖞂Ă邩
		// true:Ă  false:ĂȂ
		bool IsCondAll(IevCmdUI *pCmdUI);

		// f[^[h
		void Load(IseStateInput *pReader, IevCmdUI *pCmdUI);

		// N[쐬
		evCmdFlowCondManager *Clone();
	};


	// if
	class evCmdFlowIf : public evCmdHeader
	{
	private:
		evCmdFlowCondManager *pCondManager;
		est::vector<evCmdHeader*> lisCmd;
		evCmdFlowIf *pBefoFlow;			// t[̂PÕ`F[
		evCmdFlowIf *pNextFlow;

	public:

		// RXgN^
		evCmdFlowIf();
		// RXgN^(N[p)
		evCmdFlowIf( evCmdFlowIf *pFlowIf );
		virtual ~evCmdFlowIf();

		// ߃^Cv擾
		virtual evCmdType::Type Type() { return evCmdType::FlowIf; }

		// s
		evCmdFlowCondManager *CondManager()			 { return this->pCondManager; }
		void CondManager(evCmdFlowCondManager *value){ this->pCondManager = value; }

		// Cxg
		evCmdFlowIf *BefoFlow() { return this->pBefoFlow; }

		// t[̃`F[
		evCmdFlowIf *NextFlow()				{ return this->pNextFlow; }
		void NextFlow(evCmdFlowIf *value);

		// ߃Xg
		const est::vector<evCmdHeader*> *Cmds() const { return &this->lisCmd; }


		// ߂̒ǉ
		void Add(evCmdHeader *pCmd);

		// ߂̍폜
		void Remove(evCmdHeader *pCmd);

		// ȉ̑SĂ̖߂ɑ΂ďs
		bool DoAll(deFunc1<evCmdHeader*, bool> *pFunc);

		// s
		virtual bool DoFunc(IevCmdUI* pCmdUI );

		// true:s@false:sȂ
		void DoEvent(IevCmdUI *pCmdUI);

		// f[^[h
		void Load(IseStateInput *pReader, IevCmdUI *pCmdUI);

		// N[
		virtual evCmdHeader *Clone();
	};
}
#endif //EVCMDFLOWIF_H

