/**
* @file evData.h
* @brief 
*
* @author seri
*/
#ifndef EVDATA_H
#define EVDATA_H
#pragma once
#include "evc/common/seDefine.h"
#include "evCmdBase.h"
#include "evDefine.h"
using namespace evc;
using namespace glb;

namespace evc
{
	// Cxgf[^ʊǗNX
	// yё̃f[^Ǘ܂B
	// 

	class evCmdData;
	class IseStateType;
	class IevCmdUI;
	class seKeyControlManager;
	class evVariableState;
	class evVariableNum;


	class evData
	{
	public:
		// Gg̃Xe[^X擾
		static int GetValue(IseStateType *stype, emElemState::Type eType, int offet);

		// Gg̃Xe[^Xݒ
		static void SetValue(IseStateType *stype, emElemState::Type eType, int offet, int value);

		// f[^^CvCX^X쐬
		static evCmdData *CreateData(evDataType::Type eType, IevCmdUI *cmdUI);
	};


	// wNX:̃C^tF[X߂͈Ɏgpł܂B
	class evCmdData : public ICmdBase
	{
	private:
		// Õf[^Ƃ̉Z
		evOperator::Type eOperator;

	public:
		evOperator::Type Operator() const	 { return this->eOperator; }
		void Operator(evOperator::Type value){ this->eOperator = value; }

		evCmdData();
		evCmdData(evCmdData *mst);
		virtual ~evCmdData(){}


		virtual ICmdBase *Clone() = 0; // N[
		// f[^[h
		virtual void Load(IseStateInput *pReader, IevCmdUI *pCmdUI);

		virtual evDataType::Type DataType() = 0;
		virtual void DataType(evDataType::Type eType ) = 0;
		virtual int Value() = 0;
		virtual void Value( int iValue ) = 0;
	};



	//==================================
	// int1̃f[^
	class evdInt : public evCmdData
	{
	private:
		evDataType::Type eDataType;
		int iValue;

	public:
		virtual evDataType::Type DataType() { return this->eDataType; }
		virtual void DataType(evDataType::Type value) { this->eDataType = value; }

		virtual int Value()			  { return this->iValue;  }
		virtual void Value(int value) { this->iValue = value; }

		// RXgN^
		evdInt(evDataType::Type eType, int iValue);
		evdInt(evdInt *mst);
		virtual ~evdInt(){}

		virtual ICmdBase *Clone();
		virtual void Load(IseStateInput *inReader, IevCmdUI *inCmdUI);
	};


	//==================================
	// string1̃f[^(ۗ)
	class evdString : public evCmdData
	{
	private:
		evDataType::Type eDataType;
		int iValue;
		glbString strText;

	public:
		virtual evDataType::Type DataType() { return this->eDataType; }
		virtual void DataType(evDataType::Type value) { this->eDataType = value; }

		virtual int Value()			  { return this->iValue;  }
		virtual void Value(int value) { this->iValue = value; }

		const glbString *Text() { return &this->strText; }
		void Text( const glbString *value) { this->strText = *value; }

		// RXgN^
		evdString(evDataType::Type eType, int iValue);
		evdString(evdString *mst);
		virtual ~evdString(){}


		virtual ICmdBase *Clone();
		virtual void Load(IseStateInput *inReader, IevCmdUI *inCmdUI);
	};



	//==================================
	// lϐ
	class evdVariableNum : public evCmdData
	{
		// Ώ
	private:
		evVariableNum *pDataVariable;

	public:
		virtual evDataType::Type DataType();
		virtual void DataType(evDataType::Type value);

		evVariableNum *DataVariable() { return this->pDataVariable; }
		void DataVariable(evVariableNum *value) { this->pDataVariable = value; }

		// f[^l
		virtual int Value();
		virtual void Value(int value);

		evdVariableNum();
		evdVariableNum(evdVariableNum *mst);
		virtual ~evdVariableNum(){}


		virtual ICmdBase *Clone();

		virtual void Load(IseStateInput *inReader, IevCmdUI *inCmdUI);
	};


	//==================================
	// Xe[^Xϐ
	class evdVariableState : public evCmdData
	{
	private:
		evVariableState *pDataVariable;

	public:
		virtual evDataType::Type DataType();
		virtual void DataType(evDataType::Type value);

		// Ώ
		evVariableState *DataVariable() { return this->pDataVariable; }
		void DataVariable(evVariableState *value) { this->pDataVariable = value; }

		// f[^l
		virtual int Value();
		virtual void Value(int value);

		// RXgN^
		evdVariableState();
		evdVariableState(evdVariableState *mst);
		virtual ~evdVariableState(){}


		virtual ICmdBase *Clone();

		virtual void Load(IseStateInput *inReader, IevCmdUI *inCmdUI);
	};


	//==================================
	// Xe[^Xϐ
	class evdVariableStateItem : public evCmdData
	{
	private:
		evVariableState *pDataVariable;
		int iItemID;

	public:
		virtual evDataType::Type DataType();
		virtual void DataType(evDataType::Type value);

		// Ώ
		evVariableState *DataVariable() { return this->pDataVariable; }
		void DataVariable(evVariableState *value) { this->pDataVariable = value; }

		int ItemID()		   { return this->iItemID; }
		void ItemID(int value) { this->iItemID = value; }

		// f[^l
		virtual int Value();
		virtual void Value(int value);


		// RXgN^
		evdVariableStateItem();
		evdVariableStateItem(evdVariableStateItem *mst);
		virtual ~evdVariableStateItem(){}

		virtual ICmdBase *Clone();
		virtual void Load(IseStateInput *inReader, IevCmdUI *inCmdUI);
	};



	//==================================
	// Ggf[^
	class evdElemState : public evCmdData
	{
	private:
		seElem *pTarget;
		emElemState::Type eStateType;
		int iOffset;

	public:
		virtual evDataType::Type DataType();
		virtual void DataType(evDataType::Type value);

		seElem *Target() { return this->pTarget; }
		void Target(seElem *value) { this->pTarget = value; }

		emElemState::Type StateType() { return this->eStateType; }
		void StateType(emElemState::Type eType) { this->eStateType = eType; }

		int Offset() { return this->iOffset; }
		void Offset(int value) { this->iOffset = value; }

		// RXgN^
		evdElemState(seElem *elem);
		evdElemState(evdElemState *mst);
		virtual ~evdElemState(){}

		// f[^l
		virtual int Value();
		virtual void Value(int value);

		virtual ICmdBase *Clone();
		virtual void Load(IseStateInput *inReader, IevCmdUI *inCmdUI);
	};


	//==================================
	// L[f[^
	class evdKeyValue : public evCmdData
	{
	private:
		int iKeyID;
		int iIndex;
		seElem *pTarget;
		seKeyControlManager *pKeyManager;

	public:
		static const int NoKey = -1; // ȃL[

		int KeyID()			  { return this->iKeyID; }
		void KeyID(int value) { this->iKeyID = value; }

		int Index()			  { return this->iIndex; }
		void Index(int value) { this->iIndex = value; }

		seElem *Target() { return this->pTarget; }
		void Target(seElem *value) { this->pTarget = value; }

		seKeyControlManager *KeyManger() const { return this->pKeyManager; }
		void KeyManger(seKeyControlManager *value) { this->pKeyManager = value; }

		virtual evDataType::Type DataType();
		virtual void DataType(evDataType::Type value);


		evdKeyValue(seElem *elem, seKeyControlManager *keyManager);
		evdKeyValue(evdKeyValue *mst);
		virtual ~evdKeyValue(){}

		// f[^l
		virtual int Value();
		virtual void Value(int value);

		virtual ICmdBase *Clone();

		virtual void Load(IseStateInput *inReader, IevCmdUI *inCmdUI);

	};


	//==================================
	// [U[Ăяo
	class evdUserCall : public evCmdData
	{
	private:
		glbString strName;
		seElem *pTarget;

	public:
		virtual evDataType::Type DataType();
		virtual void DataType(evDataType::Type value);

		seElem *Target() { return this->pTarget; }
		void Target(seElem *value) { this->pTarget = value; }

		// 
		const glbString *Name() { return &this->strName; }
		void Name( const glbString *value ) { this->strName = *value; }

		// f[^l
		virtual int Value();
		virtual void Value(int value);

		// RXgN^
		evdUserCall(seElem *target);
		evdUserCall(evdUserCall *mst);
		virtual ~evdUserCall(){}


		virtual ICmdBase *Clone();

		virtual void Load(IseStateInput *inReader, IevCmdUI *inCmdUI);
	};
}
#endif //EVDATA_H

