#include "glbPch.h"
#include "evInputControl.h"
#include "evc/IO/siEventIO.h"
#include "evc/seElem/seElem.h"
#include "evc/scene/seRootScene.h"

using namespace glb;
namespace evc
{

	bool evInputControl::IsFirstPush(ButtonType::Type eBtnType) const
	{
		return ((this->eFirstPushButton & eBtnType) != 0);
	}

	bool evInputControl::IsPush(ButtonType::Type eBtnType) const
	{
		return ((this->ePushButton & eBtnType) != 0 );
	}


	glbVector2 evInputControl::GetMouseMoveOffset() const
	{
		glbVector2 sRet = this->sPointer;
		sRet.Sub(this->sBfoPointer);
		return sRet;
	}

	void evInputControl::Update()
	{
		siEventIO *pEventIO = seRootScene::Instance()->EventIO();
		if (pEventIO == null) return;
	
		// ȌԂۑ
		this->sBfoPointer = this->sPointer;
		this->eBfoPushButton = this->ePushButton;
	
		pEventIO->Update();
	
		this->sPointer = *pEventIO->Pointer();
		this->ePushButton = pEventIO->PushButton();
		this->bMovePointer = pEventIO->IsMovePointer();
	
		// ̍XVŉꂽ{^ݒ			
		this->eFirstPushButton = (ButtonType::Type)(
				((int)this->ePushButton ^ (int)this->eBfoPushButton) & (int)this->ePushButton);
	
		// XVԂϐ֒ʒm
		evVariableSp::Instance().Update(this);
	}
}
