#include "glbPch.h"
#include "evc/scene/seSceneManager.h"
#include "evc/seElem/seElem.h"
#include "evc/Event/evCmdFlowIf.h"
#include "evc/Event/evCmdFlowCall.h"
#include "evc/Event/evVariableManager.h"
#include "evc/Event/evCmd.h"
#include "evc/Event/evData.h"
#include "evManager.h"

using namespace glb;
namespace evc
{
	evManager::evManager(seElem *pInTarget, seSceneManager *pManager)
		: bClone( false )
	{
		this->pTargetElem = pInTarget;
		this->pSceneManager = pManager;
		this->pCallManager = evc_new evCmdFlowCallManager();
		this->pRootFlow = evc_new evCmdFlowIf();
		this->pLocalVariable = evc_new evVariableGroup();
	}

	evManager::evManager(seElem *pInTarget, 
						 seSceneManager *pManager,
						 evCmdFlowIf *pInCmdFlow, 
						 evVariableGroup *pInLocalGroup, 
						 evCmdFlowCallManager *pInCallManager)
		: bClone( true )
	{
		this->pTargetElem = pInTarget;
		this->pSceneManager = pManager;
		this->pRootFlow = pInCmdFlow;
		this->pLocalVariable = pInLocalGroup;
		this->pCallManager = pInCallManager;
	}

	evManager::~evManager()
	{
		if ( !this->bClone )
		{
			GLB_SAFE_DELETE( this->pCallManager );
		}
		GLB_SAFE_DELETE( this->pRootFlow );
		GLB_SAFE_DELETE( this->pLocalVariable );
	}


	void evManager::DoFunc(seSceneManager *pTargetScene)
	{
		// ΏۃV[ݒ
		this->pSceneManager = pTargetScene;
		this->pRootFlow->DoFunc(this);
	}

	evManager *evManager::Clone(seElem *pTargetElem, seSceneManager *pManager)
	{
		// ϐ𒼐ڎQƂĂ̂Ŗ߂KvB
		// IDQƂɂΕ͕Kv܂񂪁AxƂ̃g[hItɂȂ܂B
		evManager *pNewEvent = evc_new evManager(
					pTargetElem, 
					pManager, 
					static_cast<evCmdFlowIf*>(this->pRootFlow->Clone() ),
					this->pLocalVariable->Clone(), 
					this->pCallManager );

		// SĂ̖߂ɑ΂ďs
		// QƂVN[̂̂ɍXV
		// Xe[^XϐȂ
		// lϐȂ
		// lorϐǗȂ
		struct func : deFunc1<evCmdHeader *, bool>
		{
			// Cxg̕ϐQƂXV
			// ϐ̎QƂXV
			// ̕ϐΉN[ϐ擾
			evVariable* GetNewVariable( evVariable *pOldVariable )
			{
				if (pOldVariable == null) return null;
				// [JϐȂ
				int iID = me->LocalVariable()->Find(pOldVariable);
				if (iID != evVariableGroup::InvalidID)
				{
					return pNewEvent->LocalVariable()->Find(iID);
				}
				// ȊO̕ϐ̓N[͍Ȃ̂ł̂܂ܕԂB
				return pOldVariable;
			}


			bool operator()( evCmdHeader *pHeader )
			{
				// CxgA߈ӊO͖
				switch ( pHeader->Type() )
				{
					case evCmdType::Event:
					case evCmdType::Cond:
						break;
					default:
						return true;
				}


				evCmd *pCmd = static_cast<evCmd*>(pHeader);

				const est::vector<evCmdData*> &cmds = pCmd->Data();
				est::vector<evCmdData*>::const_iterator it = cmds.begin();
				for(;it != cmds.end(); it++)
				{
					evCmdData *pCmdData = *it;
					switch( pCmdData->DataType() )
					{
						case evDataType::VariableState:
							{
								evdVariableState *v = static_cast<evdVariableState*>(pCmdData);
								v->DataVariable( static_cast<evVariableState*>(this->GetNewVariable( v->DataVariable() )));
							}
							break;
						case evDataType::VariableStateItem:
							{
								evdVariableStateItem *v = static_cast<evdVariableStateItem*>(pCmdData);
								v->DataVariable( static_cast<evVariableState*>(this->GetNewVariable( v->DataVariable() )));
							}
							break;
						case evDataType::VariableNum:
							{
								evdVariableNum *v = static_cast<evdVariableNum*>(pCmdData);
								v->DataVariable( static_cast<evVariableNum*>(this->GetNewVariable( v->DataVariable() )));
							}
							break;
						default:
							break;
					}
				}

				return true;
			}

			evManager *me;
			evManager *pNewEvent;
			func( evManager *pMe, evManager *pInNewEvent )
				: me( pMe ), pNewEvent( pInNewEvent ) {}
		} f( this, pNewEvent );

		pNewEvent->RootFlow()->DoAll( &f );

		return pNewEvent;
	}


	void evManager::Load(IseStateInput *pInput)
	{
		// O[oϐ[h
		this->pLocalVariable->Load(pInput);
		// Tu[`Xg[h
		this->pCallManager->Load(pInput, this);
		// Cxgt[[h
		this->pRootFlow->Load(pInput, this);
	}
}
