/**
 * @file evManager.h
 * @brief 
 *
 * @author seri
 */
#ifndef EVMANAGER_H
#define EVMANAGER_H
#pragma once
#include "evVariableManager.h"
#include "evVariable.h"

using namespace evc;
using namespace glb;


namespace evc
{
	class seElem;
	class evVariableGroup;
	class evCmdFlowCallManager;
	class seSceneManager;
	class evCmdFlowIf;
	class IseStateInput;

	// ߎsf[^ƂpC^tF[X
	class IevCmdUI
	{
	public:
		// Cxg^[Qbg
		virtual seElem * Target() = 0;

		// ҏWXg
		virtual evVariableGroup * LocalVariable() = 0;

		// Tu[`Xg
		virtual evCmdFlowCallManager * CallManager()= 0;

		// Ώۂ̃V[}l[W
		virtual seSceneManager * SceneManager() = 0;
	};


	// Ggɑ݂CxgǗ
	class evManager : IevCmdUI
	{
	private:
		seElem				 *pTargetElem;
		evCmdFlowCallManager *pCallManager;
		seSceneManager		 *pSceneManager;
		evCmdFlowIf			 *pRootFlow;
		evVariableGroup		 *pLocalVariable;
		bool				 bClone;
	public:
		seElem *Target()			{ return this->pTargetElem; }
		void Target(seElem *value)	{ this->pTargetElem = value; }

		// Tu[`Xg
		evCmdFlowCallManager *CallManager() { return this->pCallManager; }

		// Ώۂ̃V[}l[W:CxgsOɖt[ݒ肳܂B
		seSceneManager *SceneManager() { return this->pSceneManager; }

		// Gg
		evCmdFlowIf *RootFlow() { return this->pRootFlow; }

		// [JϐO[v
		evVariableGroup *LocalVariable() { return this->pLocalVariable; }


		// RXgN^
		evManager(seElem *pInTarget, seSceneManager *pManager);
		virtual ~evManager();


		// Gg̃Cxgs
		void DoFunc(seSceneManager *pTargetScene);

		// N[쐬
		// ̃N[͍Đ̂ݎgp邱ƂOłB
		// ĐɕҏWȂ͎̂QƃRs[łB
		// SɃf[^𕡐N[KvȏꍇevManagerEditDeepClonegpĉB
		evManager *Clone(seElem *pTargetElem, seSceneManager *pManager);

		// RXgN^F̓f[^CX^X쐬
		void Load(IseStateInput *pInput);

	private:
		// RXgN^(N[p)
		evManager(seElem *pInTarget, seSceneManager *pManager, evCmdFlowIf *pInCmdFlow, evVariableGroup *pInLocalGroup, evCmdFlowCallManager *pInCallManager);
	};
}
#endif //EVMANAGER_H

