/**
 * @file evVariable.h
 * @brief 
 *
 * @author seri
 */
#ifndef EVVARIABLE_H
#define EVVARIABLE_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbString.h"

using namespace glb;

namespace evc
{
	class IseStateInput;

	// ϐx[X
	class evVariable
	{
	private:
		glbString strName;

	public:
		virtual ~evVariable(){}

		const glbString *Name() const	   { return &this->strName; }
		void Name( const glbString *value) { this->strName = *value; }

		// f[^lɐݒ
		virtual void Init() = 0;

		// RXgN^F̓f[^CX^X쐬
		virtual void Load(IseStateInput*) = 0;

		virtual evVariable *Clone() = 0;


#if defined(_DEBUG)
		// fobOp\
		virtual void DbString() = 0;
#endif
	};

	// Xe[^Xϐ
	class evVariableState : public evVariable
	{
		// l擾
	private:
		int iDefaultValue;
		bool bMultiSelect;
		int iValue;

	public:
		int DefaultValue() const	 { return this->iDefaultValue; }
		void DefaultValue(int value) { this->iDefaultValue = value; }

		// I̋Es
		bool MultiSelect() const	 { return this->bMultiSelect; } 
		void MultiSelect(bool value) { this->bMultiSelect = value; }

		// Xe[^X
		int Value() const		{ return this->iValue; }
		void Value(int value)	{ this->iValue = value; }

		// RXgN^
		evVariableState();
		virtual ~evVariableState(){}

		// f[^lɂ
		virtual void Init();

		// Xe[^XLۂ
		bool IsOn(int iStateID) const;


		// Xe[^X𑫂
		void Add(int iStateID);

		// Xe[^X폜
		void Remove(int iStateID);

		// Xe[^XNA
		void Clear();

		// [h
		virtual void Load(IseStateInput *pInput);

		// N[쐬
		// ̃\bh͍Đ̂ݎgp邱ƂOłB
		// ҏWpf[^͕܂B
		virtual evVariable *Clone();

#if defined(_DEBUG)
		// fobOp\
		virtual void DbString();
#endif
	};


	// lϐ
	class evVariableNum : public evVariable
	{
	private:
		int iMin;
		int iMax;
		bool bLoop;
		bool bEnableMin;
		bool bEnableMax;
		int iDefaultValue;
		int iValue;

	public:
		// ŏl̎擾Eݒ
		int Min() const		{ return this->iMin; }
		void Min(int value) { this->iMin = value; }

		// ől̎擾Eݒ
		int Max() const		{ return this->iMax; }
		void Max(int value) { this->iMax = value; }

		// true:[v false:؂̂Ă
		bool Loop() const		{ return this->bLoop; }
		void Loop(bool value)	{ this->bLoop = value; }

		// `FbN邩ۂ
		bool EnableMin() const		{ return this->bEnableMin; }
		void EnableMin(bool value)	{ this->bEnableMin = value; }

		// `FbN邩ۂ
		bool EnableMax() const		{ return this->bEnableMax; }
		void EnableMax(bool value)	{ this->bEnableMax = value; }

		// f[^擾
		int DefaultValue() const	{ return this->iDefaultValue; }
		void DefaultValue(int value){ this->iDefaultValue = value; }

		// Xe[^X
		virtual int Value()			{ return this->iValue; }
		virtual void Value(int value);

		// RXgN^
		evVariableNum();
		virtual ~evVariableNum(){}

		// f[^lɂ
		virtual void Init();

		// RXgN^F̓f[^CX^X쐬
		virtual void Load(IseStateInput *pInput);

		// N[쐬
		virtual evVariable *Clone();

#if defined(_DEBUG)
		// fobOp\
		virtual void DbString();
#endif
	};


	// 
	class evVariableRandomNum : public evVariableNum
	{
	public:
		virtual ~evVariableRandomNum(){}

		// 擾xɃ_ȒlԂB
		virtual int Value();
		virtual void Value(int value);
	};

}
#endif //EVVARIABLE_H

