/**
 * @file IseStateIO.h
 * @brief 
 *
 * @author seri
 */
#ifndef ISESTATEIO_H
#define ISESTATEIO_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "glb/glbString.h"

using namespace glb;
namespace evc
{
	// oCip
	class IseStateInput
	{
	public:
		virtual bool ReadBool() = 0;
		virtual unsigned char ReadByte() = 0;
		virtual short ReadShort() = 0;
		virtual int ReadInt() = 0;
		virtual float ReadFloat() = 0;
		virtual glbString ReadString() = 0;

		// enum̃TCYʂēǂݍ(Flagsɂ͑ΉĂ܂B)
		// قƂǂ̏ꍇbyteƂď܂BA1oCgȉ̒Pʂ̃f[^̓o
		// T|[gɍœKȃrbgZoׂ̊gpłB
		template<typename T, typename U>
		U ReadEnum()
		{
			// Enum̒ňԒl̑傫Ȃ̂擾(̂)
			int iMax = T::EnumMax();

			if (iMax <= glb::EnumByteMax)
				return static_cast<U>(this->ReadByte());

			if (iMax <= glb::EnumShortMax)
				return static_cast<U>(this->ReadShort());

			return static_cast<U>(this->ReadInt());
		};

	};

	// ǂݍ݃T|[g
	class seIOUtil
	{
    public:

		// glbVector2ǂݍ
		static glbVector2 ReadVector2(IseStateInput *pInput)
		{
			float fX = pInput->ReadFloat();
			float fY = pInput->ReadFloat();
			return glbVector2(fX, fY);
		};

		// glbColorǂݍ
		static glbColor ReadColor(IseStateInput *pInput)
		{
			unsigned char R = pInput->ReadByte();
			unsigned char G = pInput->ReadByte();
			unsigned char B = pInput->ReadByte();
			unsigned char A = pInput->ReadByte();
			return glbColor(R,G,B,A);
		};

	};
}
#endif //ISESTATEIO_H

