#include "glbPch.h"
#include "glb/glbString.h"
#include "bnInput.h"

namespace evc
{
	void bnInput::Open( const est::vector<glb::Byte> *buffer)
	{
		this->iIndex = 0;
		this->pbBuffer = buffer;
	}

	void bnInput::Close(){}


	bool bnInput::ReadBool()
	{
		unsigned char c = this->ReadByte();
		return (c == 1);
	}

	unsigned char bnInput::ReadByte()
	{
		unsigned char c = (unsigned char)(*this->pbBuffer)[ this->iIndex ];
		this->iIndex ++;
		return c;
	}

	short bnInput::ReadShort()
	{
		unsigned short s1 = (unsigned short)this->ReadByte();
		unsigned short s2 = (unsigned short)this->ReadByte() * 256;
		return (short)(s2 + s1);
	}

	int bnInput::ReadInt()
	{
		unsigned int i1 = (unsigned int)this->ReadByte();
		unsigned int i2 = (unsigned int)this->ReadByte() * 256;
		unsigned int i3 = (unsigned int)this->ReadByte() * 256 * 256;
		unsigned int i4 = (unsigned int)this->ReadByte() * 256 * 256 * 256;

		return (i1 + i2 + i3 + i4);
	}

	float bnInput::ReadFloat()
	{
		float f[1];
		int *p = (int *)&f[ 0 ];
		*p = this->ReadInt();
		return f[ 0 ];
	}

	glbString bnInput::ReadString()
	{
		// ŏ̂QoCg͕oCg
		int iBytes = static_cast<int>(this->ReadShort());
		if (iBytes <= 0) return glbString();
	
		// ̂PoCg^Cv
		seTextFormat::Type eFormat = static_cast<seTextFormat::Type>(this->ReadByte());
		est::string sBuff;

		// ݒ
		for ( int i = 0; i < iBytes; i++ )
		{
			sBuff.push_back( this->ReadByte() );
		}
		glbString s( eFormat, sBuff.c_str(), iBytes );
		return s;
	}
}
