#include "glbPch.h"
#include "glb/glbString.h"
#include "glb/glbDefine.h"
#include "evc/common/seDefine.h"
#include "evc/file/IseStateIO.h"
#include "seAnimManager.h"

namespace evc
{
	seAnimManager::~seAnimManager()
	{
		this->Clear();
	}


	void seAnimManager::Clear()
	{
		this->DeleteAllInstance();
		this->iActiveID = seAnimManager::InvalidID;
	}

	int seAnimManager::SetAnim(const glbString *strAnim )
	{
		this->SetAnim( strAnim, this->seIDManager<seAnimInfo*>::GetFreeID());
		return this->iActiveID;
	}

	void seAnimManager::SetAnim( const glbString *strAnim, int iAnimID)
	{
		// ɓo^ĂȂ炻̂hcԂďI
		this->iActiveID = this->FindID(strAnim);
	
		// ȂΐVKɒǉ
		if ( this->iActiveID == seAnimManager::InvalidID )
		{
			this->iActiveID = iAnimID;
			this->Add(iAnimID, evc_new seAnimInfo(strAnim));
		}
	}

	int seAnimManager::GetFirstAnimID()
	{
		const est::map<int,seAnimInfo*> &anims = *this->Piars();
		if (anims.size() <= 0)
		{
			return seAnimManager::InvalidID;
		}
		est::map<int,seAnimInfo*>::const_iterator it = anims.begin();
		return it->first;
	}


	// 񂩂ID擾
	int seAnimManager::FindID( const glbString *strName )
	{
		if ( strName == null ) return seAnimManager::InvalidID;

		const est::map<int,seAnimInfo*> &anims = *this->Piars();
		est::map<int,seAnimInfo*>::const_iterator it = anims.begin();
		while(it != anims.end())
		{
			if (*strName == *(it->second->Name()))
				return it->first;
			it ++;
		}

		return seAnimManager::InvalidID;
	}

	void seAnimManager::Load(IseStateInput *pInput)
	{
		// Aj[VXg[h
		this->Clear();
		int iAnimCount = static_cast<int>(pInput->ReadShort());
		seDefine::DebugTrace( "AnimCount", iAnimCount);
		for (int i = 0; i < iAnimCount; i++)
		{
			int iAnimID = static_cast<int>(pInput->ReadShort());
			glbString strName = pInput->ReadString();
			this->SetAnim( &strName, iAnimID);
		}
	}
}
