/**
 * @file seAnimManager.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEANIMMANAGER_H
#define SEANIMMANAGER_H
#pragma once
#include "evc/common/seIDManager.h"

namespace glb
{
	class glbString;
}
namespace evc
{
	class IseStateInput;

	class seAnimInfo
	{
	private:
		glbString strName;

		// Aj[V̎擾Eݒ
	public:
		const glbString *Name() const	   { return &this->strName; }
		void Name( const glbString *value) { this->strName = *value; }
		// RXgN^
		seAnimInfo( const glbString *strInName)
			: strName( *strInName ){}
		virtual ~seAnimInfo(){}
	};

	// V[Aj[VǗ
	class seAnimManager : public seIDManager<seAnimInfo*>
	{
	private:
		int iActiveID;

	public:
		// RXgN^
		seAnimManager() : iActiveID( seAnimManager::InvalidID ){}
		virtual ~seAnimManager();

		// ANeBuȃAj[V擾
		int ActiveAnim() const		{ return this->iActiveID; }
		void ActiveAnim(int value)	{ this->iActiveID = value; }


		// Sf[^NA
		void Clear();

		// Aj[V̓o^
		int SetAnim( const glbString *strAnim);
		// Aj[Vhcw
		void SetAnim( const glbString *strAnim, int iAnimID);

		// ŏ̃Aj[VID擾
		int GetFirstAnimID();

		// Oo^Ăhc
		int FindID( const glbString *strName);

		// [h
		void Load(IseStateInput *pInput);
	};
}
#endif //SEANIMMANAGER_H

