/**
 * @file seElemManager.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEELEMMANAGER_H
#define SEELEMMANAGER_H
#pragma once
#include "evc/common/seIDManager.h"
#include "glb/glbDefine.h"
#include "glb/glbColor.h"
#include "glb/glbString.h"
#include "glb/glbVector.h"
#include "seAnimManager.h"
#include "evc/seElem/seElem.h"


using namespace glb;
namespace glb
{
	class IGLMatrix;
}

namespace evc
{
	class seSceneManager;
	class seStateKeyManager;
	class seElemAnim;
	class seObject;
	class IseStateInput;

	// D揇ʊǗ
	struct DrawPriority
	{
		seElem *pLastElem;
		seElem *pFirstElem;

		// NA
		void Clear()
		{
			this->pFirstElem = null;
			this->pLastElem = null;
		}

		// o^
		void Add(seElem *pElem);
	};

	// Gĝhcroot̊Ǘ܂B
	// Ƀt[AJ̊Ǘ܂B
	class seElemManager : public seIDManager<seElem*>
	{
	private:
		seSceneManager *pSceneManager; // ΏۃV[
		float fPlayTime; // ݂̍Đ
		int iFrame; // ݂̃t[(ɕҏWp)

		// `̍ŏƍŌ̃Gg
		seElem *pFirstDrawElem;
		seElem *pLastDrawElem;

		// ŌɗvꂽAj[V擾
		int iLastAnim; // ŌɗvꂽAj[V

		seElem *pRootElem; // ŏʗvf

		// `惊Xg[N:ꎞf[^łBZ[u̕Kv͂܂B
		// 邱Ƃ\łAx҂ăoƂĎĂ܂B
		est::map<int,DrawPriority> dicDrawList;

	public:

		int LastAnim() const { return this->iLastAnim; }

		// [gvf擾Eݒ
		seElem *RootElem() const	 { return this->pRootElem; }
		void RootElem(seElem *value);


		// `揇ɕ\SẴGgɑ΂ďs
		bool DoDrawAll(deFunc1<seElem*, bool> *pFunc);


		// Ŝɉe^J[擾Eݒ
		const glbColor *Color() const;
		void Color( const glbColor *value);


		// RXgN^
		seElemManager(seSceneManager *pTargetScene)
			: pSceneManager( pTargetScene )
			, fPlayTime( 0.0f )
			, iFrame( 0 )
			, pFirstDrawElem( null )
			, pLastDrawElem( null )
			, iLastAnim( seAnimManager::InvalidID )
			, pRootElem( null )
		{}
		virtual ~seElemManager();


		// PlayTime = FrameTime * Frame
		// ̂R̒l͏ɓB

		// vCԎ擾Eݒ
		float PlayTime();
		void PlayTime(float value);
		// t[̎擾Eݒ
		int Frame();
			// O̓CxgʂĂ̂ݐݒ\łB
		void Frame(int value);

		// NA
		void Clear();

		// SẴGgɑ΂ďs
		bool DoAll(deFunc1<seElem*, bool> *pFunc);

		// Aj[Vݒ
		void SetAnim(int iAnimID);

		// [gȉ̃Aj[VčXV
		void ResetAnim();
		// [gȉ̃Aj[VčXV
		void ResetAnim(float fTime, float fFrameTime, const IGLMatrix *pCamera);


		void Draw();

		// XV
		void Update(float fAddTime);

		// XV:(Jw)
		void Update( const IGLMatrix *mParent, float fAddTime);


		// eqpXV
		void Succession( const IGLMatrix *pCamera);

		// IuWFNg[NĐݒ
		void ResetObjectWork(seObject *pNewObject, seObject *pOldObject);


		// Cxg֌W
		// 

		// |Cg̃qbgԂXV
		// @param bFirstHit : ŏɃqbgtO
		bool UpdateHit( const glbVector2 *sPoint, bool bFirstHit);

		// Cxgs
		void DoEvent();

		// [h
		void Load(IseStateInput *pInput, seSceneManager *pManager);

	private:
		// `GgXg쐬
		void RegisterDrawList();

		// `惊Xgɓo^
		void RegisterElem( seElem *pElem );

		void UpdateElem( seElem *pElem,
						 const IGLMatrix *mParent,
						 float fFrameTime,
						 float fAddTime );
	};
}
#endif //SEELEMMANAGER_H

