#include "glbPch.h"
#include "glb/glbString.h"
#include "evc/common/seDefine.h"
#include "evc/file/IseStateIO.h"
#include "seObjectManager.h"
#include "seSceneManager.h"
#include "seElemManager.h"
#include "evc/seObject/seObject.h"
#include "evc/seObject/seObjectWork.h"
#include "evc/seObject/ObjectParts/seoMesh.h"


using namespace glb;
namespace evc
{

	seObjectManager::seObjectManager(seSceneManager *pSceneManager)
		: seIDManager<seObject*>(seObjectManager::OBJECT_BASE_ID)
	{
		this->pSceneManager = pSceneManager;
	}

	seObjectManager::~seObjectManager()
	{
		this->DeleteAllInstance();
	}

	void seObjectManager::Clear()
	{
		this->DeleteAllInstance();
		this->seIDManager<seObject*>::Clear();
	}


	int seObjectManager::Add(seObject *tData)
	{
		int iNewID = this->Add(tData);
		tData->Init(iNewID, this->pSceneManager);
		return iNewID;
	}

	void seObjectManager::Add(int iNewObjectID, seObject *pNewObject)
	{
		seObject *pOldObject = this->Find(iNewObjectID);
	
		this->seIDManager<seObject*>::Add( iNewObjectID, pNewObject );
		// ㏑ȂSĂ̗vfɑ΂ăIuWFNg̍Đݒ
		if ( pOldObject != null )
		{
			this->pSceneManager->ElemManager()->ResetObjectWork(pNewObject, pOldObject);
			delete pOldObject;
		}
		pNewObject->Init(iNewObjectID, this->pSceneManager);
	}

	void seObjectManager::Load(IseStateInput *pInput)
	{
		this->Clear();
		// IuWFNgf[^[h
		int iObjectCount = static_cast<int>(pInput->ReadShort());
		seDefine::DebugTrace( "ObjectCount", iObjectCount);
		for (int i = 0; i < iObjectCount; i++)
		{
			emObject::Type eObjectType = pInput->ReadEnum<emObject,emObject::Type>();
			seObject *pObject = seObject::Create(eObjectType);
			pObject->Load(pInput, this->pSceneManager);
			this->Add( pObject->ObjectID(), pObject );
		}

		// IuWFNg̃[hSďIɏ
		const est::map<int,seObject*> &objs = *this->Piars();
		est::map<int,seObject*>::const_iterator it = objs.begin();
		while(it != objs.end())
		{
			seObject *pObj = it->second;
			// bVIuWFNg̐eq\\zB
			if ( pObj->ElemType() == emObject::Mesh )
			{
				seoMesh *mesh = static_cast<seoMesh*>(pObj);
				mesh->LinkMechChild(this);
			}
			it ++;
		}



	}
}
