#include "glbPch.h"
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "evc/file/IseStateIO.h"
#include "seOption.h"

using namespace glb;
namespace evc
{
	seOption::seOption()
	{
		this->Clear();
	}

	void seOption::Clear()
	{
		this->FrameNum(200);
		this->sBgColor = glbColor(0, 0, 0, 255);
		this->sScreenSize = glbVector2(200.0f, 200.0f);
		this->fFrameTime = 100.0f;
		this->ePathMode = seOutputPath::Local;
		this->bAddExt = true;
		this->bCopyFile = false;
		this->bIncludeElemName = false;
		this->bIncludeKeyWord = true;
		this->bNoDebugData = false;
	
		this->eTextFormat = seTextFormat::Utf16; // o͕tH[}bg
		this->eInsideName = seTextFormat::Shift_Jis; // tH[}bg
	}

	void seOption::Load(IseStateInput *pInput)
	{
		this->sBgColor = seIOUtil::ReadColor(pInput);
		this->sScreenSize = seIOUtil::ReadVector2(pInput);
	
		this->FrameNum(pInput->ReadInt());
		this->FrameTime(pInput->ReadFloat());
	
		this->ePathMode = pInput->ReadEnum<seOutputPath,seOutputPath::Type>();
		this->bAddExt = pInput->ReadBool();
		this->bCopyFile = pInput->ReadBool();
		this->bIncludeElemName = pInput->ReadBool();
		this->bIncludeKeyWord = pInput->ReadBool();
		this->bNoDebugData = pInput->ReadBool();
	
		this->eTextFormat = pInput->ReadEnum<seTextFormat,seTextFormat::Type>();
		this->eInsideName = pInput->ReadEnum<seTextFormat,seTextFormat::Type>();
	}
}
