#include "glbPch.h"
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "glb/glbVector.h"
#include "evc/common/seDefine.h"
#include "evc/file/IseStateIO.h"
#include "seRootScene.h"
#include "seSceneManager.h"
#include "seElemManager.h"
#include "seResourceManager.h"
#include "evc/IO/siResource.h"
#include "evc/IO/siIOManager.h"
#include "evc/seResource/seResourceScene.h"


using namespace glb;
namespace evc
{
	seResourceManager::~seResourceManager()
	{
		this->DeleteAllInstance();
	}

	siResourceBase *seResourceManager::Find( const glbString *pName)
	{
		const est::map<int,siResourceBase*> &resources = *this->Piars();
		est::map<int,siResourceBase*>::const_iterator it = resources.begin();
		while(it != resources.end())
		{
			if ( *(it->second->Name()) == *pName )
				return it->second;
			it ++;
		}
		return null;
	}

	siResourceBase *seResourceManager::Register(
								seSceneManager *pScene, 
								const glbString *strFileName, 
								int iResourceID, 
								emResourceState::Type eResType, 
								const glbVector2I *sTexSize, 
								bool bAutoLoad )
	{
		// ɓo^ς݂Ȃ
		siResourceBase *pResource = this->seIDManager<siResourceBase*>::Find(iResourceID);
		if (pResource != null) return pResource;
	
		siIOManager *pIOManager = seRootScene::Instance()->IOManager();
		switch (eResType)
		{
			// eNX`
			case emResourceState::Image:
				pResource = pIOManager->CraeteTextureResource(pScene, strFileName, sTexSize);
				break;
			// TEh
			case emResourceState::Sound:
				pResource = pIOManager->CraeteSoundResource(pScene, strFileName);
				pResource->Register(null);
				break;
			// V[
			case emResourceState::Scene:
				pResource = evc_new seResourceScene(strFileName);
				break;
		}
	
		// Ń[h邩ۂ
		pResource->AutoLoad( bAutoLoad );
	
		// \[XXgɓo^
		this->Add(iResourceID, pResource);
		return pResource;
	}

	seResourceManager::seResourceManager()
	{
	}

	void seResourceManager::Clear()
	{
		this->DeleteAllInstance();
	}

	void seResourceManager::Release(int iResourceID)
	{
		siResourceBase *pResource = seIDManager<siResourceBase *>::Find(iResourceID);
		if (pResource == null) return;
		delete pResource;

		seIDManager<siResourceBase *>::Remove( iResourceID );
	}

	void seResourceManager::Load(IseStateInput *pInput, seSceneManager *pScene)
	{
		int iCount = static_cast<int>(pInput->ReadShort());
		seDefine::DebugTrace("ResourceCount", iCount);
	
		for (int i = 0; i < iCount; i++)
		{
			int iResourceID = static_cast<int>(pInput->ReadShort());
			bool bAutoLoad = pInput->ReadBool();
			emResourceState::Type eType = pInput->ReadEnum<emResourceState,emResourceState::Type>();
			glbVector2I sTexSize = glbVector2I::Zero;
			// eNX`̏ꍇA^Cvw̌ɃTCY
			if (eType == emResourceState::Image)
			{
				sTexSize.X = static_cast<int>(pInput->ReadShort());
				sTexSize.Y = static_cast<int>(pInput->ReadShort());
			}
			glbString strName = pInput->ReadString();
			// [hs
			// \[X̓o^݂̂A[h̓Aj[VŎw肳ꂽ^C~Oōs܂B
			this->Register(pScene, &strName, iResourceID, eType, &sTexSize, bAutoLoad);
		}
	}
}
