/**
 * @file seResourceManager.h
 * @brief 
 *
 * @author seri
 */
#ifndef SERESOURCEMANAGER_H
#define SERESOURCEMANAGER_H
#pragma once
#include "evc/common/seIDManager.h"
#include "evc/common/seDefine.h"

using namespace glb;

namespace glb
{
	struct glbVector2I;
	class glbString;
}
namespace evc
{
	class siResourceBase;
	class seSceneManager;
	class IseStateInput;

	// Ot@Cf[^Ǘ
	class seResourceManager : public seIDManager<siResourceBase*>
	{
	public:
		virtual ~seResourceManager();

		// \[X烊\[X擾
		siResourceBase *Find( const glbString *pName);

		// \[Xo^
		siResourceBase *Register( seSceneManager *pScene,
									const glbString *pFileName, 
									int iResourceID, 
									emResourceState::Type eResType, 
									const glbVector2I *sTexSize,
									bool bAutoLoad );
		// RXgN^
		seResourceManager();

		// Sf[^NA
		void Clear();

		// \[X
		void Release(int iResourceID);

		// f[^[h
		void Load(IseStateInput *pInput, seSceneManager *pScene);
	};
}
#endif //SERESOURCEMANAGER_H

