/**
 * @file seRootScene.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEROOTSCENE_H
#define SEROOTSCENE_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbColor.h"
#include "glb/glbString.h"
#include "seSceneManager.h"

using namespace glb;

namespace glb
{
	class IGLMatrix;
}

namespace evc
{
	class seSceneManager;
	class seResourceScene;
	class siEventIO;
	class siIOManager;
	class siMaterial;
	class siEventListener;
	class siAnimListener;

	// ԏ̃V[Ǘ
	class seRootScene
	{
	public:
		/** xVOg
		 * @brief CX^XĂgƂ̂łVOg
		 * @return 
		 */
		static seRootScene *Instance() { return seRootScene::instance; }

	private:
		// V[[hO̔wiF
		static glbColor DefaultBgColor;
		// xVOg
		static seRootScene *instance;

		seResourceScene	*pSceneResource; // V[\[X

		IGLMatrix		*pRootMatrix; // ŏʃ}gNX
		seSceneManager	*pRootScene; // ŜǗV[
		glbString		strAnimName; // [hIɎsAj[V
		bool			bEditMode; // ҏWĐ(ĐftHg)

		siEventIO		*pEventIO;
		siIOManager		*pIOManager; // o̓NX
		siMaterial		*pMaterial;

		siEventListener	*pEventListener; // CxgXi[
		siAnimListener	*pAnimListener;	 // Aj[VXi[

	public:
		// ŏ̃V[
		deAction1<seSceneManager *> *OnInit;

		// CxgXi[
		siEventListener	*EventListener() { return this->pEventListener; }
		void EventListener( siEventListener	*evListener ) { this->pEventListener = evListener; }

		// Aj[VXi[
		siAnimListener *AnimListener() { return this->pAnimListener; }
		void AnimListener( siAnimListener *animListener ) { this->pAnimListener = animListener; }


		// o͊Ǘ擾
		siIOManager *IOManager() { return this->pIOManager; }

		// J}gNX擾
		IGLMatrix *Camera()		{ return this->pRootMatrix; }

		// [gV[擾
		seSceneManager *RootScene() { return this->pRootScene; }

		// ҏWpAĐp擾Eݒ
		bool EditMode() const		{ return this->bEditMode; }
		void EditMode(bool value)	{ this->bEditMode = value; }

		// Cxgo͂擾
		siEventIO *EventIO() { return this->pEventIO; }

		// }eA擾
		siMaterial *Material() { return this->pMaterial; }

		// [gV[ǂݍݒۂ
		bool IsRootLoading() const;

		// [gV[LZ
		void RootCancel();

		// afJ[擾
		const glbColor *BgColor();

		void Load( const glbString *pSceneName, 
					const glbString *pAnimName );

		// ͍XV
		void UpdateInput();

		// Aj[Vs
		void DoAnim(float fAddTime);


		// `
		void Draw();


		// SăZbg
		void Clear();

		// RXgN^
		seRootScene( siIOManager *pIOManager,
					 siEventIO *pInEventIO, 
					 siMaterial *pInMaterial);
		virtual ~seRootScene();
	};
}
#endif //SEROOTSCENE_H

