#include "glbPch.h"
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "evc/common/seDefine.h"
#include "evc/common/seStringPair.h"
#include "evc/file/IseStateIO.h"
#include "evc/IO/siIOManager.h"
#include "evc/seResource/seResourceScene.h"
#include "evc/Event/evVariableManager.h"
#include "evc/seElem/seElem.h"
#include "seObjectManager.h"
#include "seSceneManager.h"
#include "seResourceManager.h"
#include "seElemManager.h"
#include "seKeyControlManager.h"
#include "seOption.h"
#include "seElemManager.h"
#include "seRootScene.h"

using namespace glb;
namespace evc
{
	bool seSceneManager::IsPlayNextAnim(int iAnimID)
	{
		return ( est::find( this->lisChangeAnim.begin(), this->lisChangeAnim.end(), iAnimID )
																!= this->lisChangeAnim.end() );
	}

	void seSceneManager::RequestAnim(int iAnimID)
	{
		// ̃Aj[VNGXg͖
		if (iAnimID == seAnimManager::InvalidID) return;

		// ꍇ̂ݒǉ
		if (!this->IsPlayNextAnim(iAnimID))
		{
			this->lisChangeAnim.push_back(iAnimID);
		}
	}

	void seSceneManager::RequestAnim( const glbString *pAnimName)
	{
		this->RequestAnim(this->AnimManager()->FindID(pAnimName));
	}

	void seSceneManager::UpdateAnim()
	{
		// ̃Aj[Vݒ肳ĂȂ炻s
		est::vector<int>::iterator it = this->lisChangeAnim.begin();
		while( it != this->lisChangeAnim.end() )
		{
			this->pElemManager->SetAnim(*it);
			it ++;
		}
		this->lisChangeAnim.clear();
	}



	void seSceneManager::Parent(seSceneManager *value)
	{
		this->pParent = value;
		// ẽL[[hƃN
		this->pKeyWord = (this->pParent != null) ? this->pParent->KeyWord() : null;
	}




	seSceneManager::seSceneManager( const glbString *pInName)
	{
		// ł͂ȂB
		this->bClone = false;
		this->bCreateKeyWord = false;
	
		// L[[ht@Crootɂ̂ݑ݂܂B
		// root̃f[^[hɃCX^X쐬Aǂݍ݂܂B
		this->pKeyWord = null;
	
		this->strName = *pInName;
		this->pOption = evc_new seOption();
		this->pElemManager = evc_new seElemManager(this);
		this->pElemObjectManager = evc_new seObjectManager(this);
		this->pAnimManager = evc_new seAnimManager();
		this->pResourceManager = evc_new seResourceManager();
		this->pKeyControlManager = evc_new seKeyControlManager();
		// ϐ͓BN[̏ꍇ̓Rs[B
		this->pVariableList = evc_new evVariableManager();
	}

	seSceneManager::seSceneManager(seSceneManager *sm)
	{
		// V[B
		this->bClone = true;
		this->bCreateKeyWord = false;

		this->strName = *sm->Name();
		this->pElemManager = evc_new seElemManager(this); // KvȈׁAN[ōB
		if (sm->ElemManager()->RootElem() != null)
		{
			// f[^Rs[
			this->ElemManager()->RootElem( sm->ElemManager()->RootElem()->Clone(null, this) );
		}
		this->pOption = sm->Option();
		this->pElemObjectManager = sm->ObjectManager();
		this->pAnimManager = sm->AnimManager();
		this->pResourceManager = sm->ResourceManager();
		this->pKeyWord = sm->KeyWord();
		this->pKeyControlManager = sm->KeyControlManager();
	
		// ϐf[^̃N[쐬
		this->pVariableList = sm->VariableList()->Clone();
	}

	seSceneManager::~seSceneManager()
	{
		GLB_SAFE_DELETE( this->pOption );
		GLB_SAFE_DELETE( this->pElemManager );
		GLB_SAFE_DELETE( this->pVariableList );
	
		// N[̎͋L}l[WNAȂB
		if (!this->bClone)
		{
			GLB_SAFE_DELETE( this->pElemObjectManager );
			GLB_SAFE_DELETE( this->pAnimManager );
			GLB_SAFE_DELETE( this->pResourceManager );
			GLB_SAFE_DELETE( this->pKeyControlManager );
		}

		// L[[ht@ĈȂ폜
		if ( this->bCreateKeyWord )
		{
			GLB_SAFE_DELETE( this->pKeyWord );
		}
	}


	void seSceneManager::Clear()
	{
		// L[[h͑SV[ŋL̈׍폜܂B
		// 


		// Aj[VNGXgNA
		this->lisChangeAnim.clear();
	
		this->Option()->Clear();
		this->pElemManager->Clear();
		this->pVariableList->Clear();
	
		// N[̎͋L}l[WNAȂB
		if (!this->bClone)
		{
			this->pElemObjectManager->Clear();
			this->pAnimManager->Clear();
			this->pResourceManager->Clear();
			this->pKeyControlManager->Clear();
		}
	
		this->strName = "";
	}

	seSceneManager *seSceneManager::Clone()
	{
		return evc_new seSceneManager(this);
	}

	void seSceneManager::OnProc(float fAddTime)
	{
		this->UpdateAnim();
		// vfAj[Vs
		// vfXV
		this->pElemManager->Update(fAddTime);
	}

	void seSceneManager::Load(IseStateInput *pInput)
	{
		// fobO\錾
		seDefine::StartDebugTrace();
	
		// }WbNႢ܂Bprat@Cł͂܂B
		if (pInput->ReadInt() != seDefine::Magic)
		{
			GLB_ASSERT(false);
			return;
		}
	
		// o[WႢ܂Bt@CƓǂݍݏ̃o[W
		// Kv܂B
		if (pInput->ReadInt() != seDefine::FileVarsion)
		{
			GLB_ASSERT(false);
			return;
		}
	
		this->pVariableList->Load( pInput );
		// IvV
		this->Option()->Load(pInput);
	
		// f[^݂ȂL[[ht@C[h
		if (this->Option()->IncludeKeyWord())
		{
			// ߋɃ[hĂȂx폜
			if ( this->bCreateKeyWord )
			{
				GLB_SAFE_DELETE( this->pKeyWord );
			}
			this->pKeyWord = evc_new seKeyWord();
			this->pKeyWord->Load(pInput);
			this->bCreateKeyWord = true;
		}
	
		// \[Xo
		this->ResourceManager()->Load(pInput, this);
	
		// IuWFNgo
		this->ObjectManager()->Load(pInput);
	
		// Aj[VXgo
		this->AnimManager()->Load(pInput);
	
		// ݂Ȃvfo
		this->ElemManager()->Load(pInput, this);
	}
}
