/**
 * @file seSceneManager.h
 * @brief 
 *
 * @author seri
 */
#ifndef SESCENEMANAGER_H
#define SESCENEMANAGER_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "seObjectManager.h"
#include "evc/common/seStringPair.h"

using namespace glb;

namespace evc
{
	class seObjectManager;
	class seAnimManager;
	class seResourceManager;
	class seElemManager;
	class seOption;
	class seKeyControlManager;
	class seSceneManager;
	class evVariableManager;
	class IseStateInput;


	class seKeyWord : public seStringPair {};

	/**
	 * V[Ǘ
	 */
	class seSceneManager
	{
	private:
		glbString strName; // V[
		seObjectManager		*pElemObjectManager; // IuWFNg}l[W
		seAnimManager		*pAnimManager; // Aj[V}l[W
		seResourceManager	*pResourceManager; // \[X}l[W
		seElemManager		*pElemManager; // Gg}l[W
		seOption			*pOption; // V[ݒǗ
		seKeyControlManager *pKeyControlManager; // L[Xg
		seSceneManager		*pParent; // eV[
		seKeyWord			*pKeyWord; // L[[hf[^


		bool bClone;			// V[ۂ
		bool bCreateKeyWord;	// L[[ht@C쐬ۂ

		// ̃t[Ő؂ւAj[V
		est::vector<int> lisChangeAnim;

		// O[oϐXg擾Eݒ
		evVariableManager	*pVariableList;

	public:
		evVariableManager *VariableList()			{ return this->pVariableList; }
		void VariableList(evVariableManager *value) { this->pVariableList = value; }


		// ̃t[sAj[Vۂ
		bool IsPlayNextAnim(int iAnimID);

		// ̃t[Ő؂ւAj[V
		// Aj[V͏d˂Ĕ\̂ŕo^ł悤ɂĂB
		void RequestAnim(int iAnimID);

		// Ow肵ăAj[VNGXg
		void RequestAnim( const glbString *pAnimName);

		// NGXgĂAj[VĂяo
		// Aj[V̕ύX͍XV^C~OłPxɍs܂B
		void UpdateAnim();

		// V[擾
		const glbString *Name() const		{ return &this->strName; }
		void Name( const glbString *value ) { this->strName = *value; }

		// eV[擾Eݒ
		seSceneManager *Parent() { return this->pParent; }
		void Parent(seSceneManager *value);

		// L[[hǗ擾
		seKeyWord *KeyWord() { return this->pKeyWord; }
		// ݒǗ擾
		seOption *Option() { return this->pOption; }
		// IuWFNg}l[W[擾
		seObjectManager *ObjectManager() { return this->pElemObjectManager; }
		// Aj[V}l[W̎擾
		seAnimManager *AnimManager() { return this->pAnimManager; }
		// eNX`Rg[擾
		seResourceManager *ResourceManager() { return this->pResourceManager; }
		// Gg}l[W擾
		seElemManager *ElemManager() { return this->pElemManager; }
		// Rg[L[Ǘ擾
		seKeyControlManager *KeyControlManager() { return this->pKeyControlManager; }


		// RXgN^
		seSceneManager( const glbString *pName);

	private:
		// RXgN^(Clonep)
		// ҏWȂ̂͌烊NALB
		seSceneManager(seSceneManager *sm);


	public:

		virtual ~seSceneManager();


		// V[Zbg
		void Clear();


		// V[̕쐬
		// eNX`A`IuWFNgAAj[V͋LA
		// vf̓f[^XV̂Ńf[^𕡐
		seSceneManager *Clone();


		// V[vV[W
		void OnProc(float fAddTime);

		// oCi[h
		void Load(IseStateInput *pInput);

	};
}
#endif //SESCENEMANAGER_H

