/**
 * @file seElem.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEELEM_H
#define SEELEM_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "glb/glbVector.h"

using namespace glb;
namespace glb
{
	class IGLMatrix;
}

namespace evc
{
	class siMaterial;
	class IUseWorkMatrix;
	class seSceneManager;
	class evManager; // Cxg
	class seElemAnimManager; // Aj[VǗ
	class seObjectWork;
	class seElemState; // f[^Ǘ
	class IseStateInput;

	// 蔻^Cv
	struct seHit
	{
		enum Type
		{
			Non = 0, // qbgĂȂ
			TopHit,	 // ԍŏɃqbg
			Hit		 // qbg
		};
		static int EnumMax() { return Hit; }
	};


	// PvfǗNX
	class seElem
	{
	private:
		int			iElemID;
		bool		bSelectWork;
		bool		bStopAnim;
		bool		bStopAnimAll;
		seHit::Type eHit;
		bool		bDisableEdit;
		bool		bDisableEditParent;
		seElem		*pParent;
		est::vector<seElem*> lisChildList;
		glbString	strName;

		seElem		*pBeforDraw; // O̕`vf
		seElem		*pNextDraw; // ̕`vf

		bool		bUpdateAnim; // Aj[VXVۂ
		evManager	*pEvent; // Cxg
		seElemAnimManager *pAnimManager; // Aj[VǗ
		seObjectWork *pObjectWork;
		seElemState	*pState; // f[^Ǘ

		bool		bClone; // ۂ

	public:
		// Ip[N
		bool SelectWork() const 	{ return this->bSelectWork; }
		void SelectWork(bool value) { this->bSelectWork = value; }

		// Aj[V~
		bool StopAnim() const		{ return this->bStopAnim; }
		void StopAnim(bool value)	{ this->bStopAnim = value; }

		// ȉ̃Aj[V~
		bool StopAnimAll() const	 { return this->bStopAnimAll; }
		void StopAnimAll(bool value) { this->bStopAnimAll = value; }

		// 蔻
		seHit::Type Hit() const		  { return this->eHit; }
		void Hit( seHit::Type value ) { this->eHit = value; }

		// ҏW𖳎(ҏWp):Sɔ\ɂ܂B
		bool DisableEdit() const	 { return this->bDisableEdit; }
		void DisableEdit(bool value) { this->bDisableEdit = value; }

		// ɕҏW݂邱Ƃ\܂B(ҏWp)
		bool DisableEditParent() const		{ return this->bDisableEditParent; }
		void DisableEditParent(bool value)	{ this->bDisableEditParent = value; }

		// e擾
		seElem *Parent() const { return this->pParent; }

		// q̃Xg
		const est::vector<seElem*> *Child() const { return &this->lisChildList; }

		// ʂhc擾
		int ElemID() const { return this->iElemID; }

		// Gg擾
		const glbString *Name() const		{ return &this->strName; }
		void Name( const glbString *value)	{ this->strName = *value; }

		// O̕`vf擾
		seElem *BeforDraw() const		{ return this->pBeforDraw; }
		void BeforDraw( seElem *value ) { this->pBeforDraw = value; }

		// ̕`vf擾
		seElem *NextDraw() const		{ return this->pNextDraw; }
		void NextDraw(seElem *value)	{ this->pNextDraw = value; }

		// CxgRg[擾
		evManager *Event() const		{ return this->pEvent; }
		void Event(evManager *value)	{ this->pEvent = value; }

		// Aj[V擾
		seElemAnimManager *Anim() const { return this->pAnimManager; }

		// IuWFNg[N擾Eݒ
		seObjectWork *ObjectWork() const		{ return this->pObjectWork; }
		void ObjectWork(seObjectWork *value)	{ this->pObjectWork = value; }

		// Xe[^XNX擾
		seElemState *State() const { return this->pState; }

		// eƍ̃}gNX擾
		const IGLMatrix *NowMatrix() const;

		// \Ԃۂ擾
		bool IsVisible() const;


		// RXgN^
		seElem( const glbString *pName, seElem *pInParent, int iIndex);
		virtual ~seElem();

	private:
		// RXgN^(N[)
		// ҏWȂf[^͋LseElem̃N[쐬܂
		seElem(seElem *pMstElem, seElem *pInParent, seSceneManager *pManager);

		// 
		void Init();

	public:
		// ȉ̑SĂ̎qɑ΂čXV
		// @retval true:XVp false:ʂ̍XV͂Ȃ
		bool Update( const IGLMatrix *mCamera, float fFrameTime, float fTime);


		// Aj[VCӂ̃t[̏ԂɐݒB
		void ResetAnim(const IGLMatrix *mCamera, float fFrameTime, float fTime);


		// e̗vf̃f[^pčŏIf[^쐬
		void Succession(const IGLMatrix *mCamera);


		// f[^𕡐AN[
		// ĐύXȂf[^͕̂QƂ܂B
		seElem *Clone(seElem *pElemParent, seSceneManager *pManager);


		// ܂߁ASĂ̎qɏs
		// pFunc̖߂lfalseɂƓrI
		bool DoAll(deFunc1<seElem*, bool> *pFunc);

		// qƂ̊֌W폜
		void RemoveChild(seElem *pElem);

		// qƂ̊֌W쐬
		void AddChild(seElem *pElem);


		// f[^[h
		void Load(IseStateInput *pInput, seSceneManager *pSceneManager);

	private:

		// vfPXV
		void UpdateOne(const IGLMatrix *mCamera, float fFrameTime, float fTime);

		// Aj[VXVtO
		bool UpdateAnim();


	// seElemDraw
	//


	public:
		// Cӂ̓_`ɑ݂邩ۂ
		bool IsInRect( const glbVector2 *pVector);


		// sNZPʃqbg
		bool IsHitPixel( const glbVector2 *sPos);


		// [v݂̗vf̋`}gNX擾
		// v͗vf̒_\}gNX
		void GetRectMatrix(IGLMatrix *pMatrix);

		// IuWFNI̋`擾
		// ݂̃Aj[V܂߂`ɂȂĂ܂B
		bool GetRect( est::vector<glbVector2> &rPosBuffer );

		// ȉ̑SĂ̎qɑ΂ĕ`揈
		void Draw(siMaterial *pMaterial);

	};
}
#endif //SEELEM_H

