#include "glbPch.h"
#include "glb/glbDefine.h"
#include "seElemAnim.h"
#include "seStateKeyManager.h"
#include "evc/common/seDefine.h"
#include "evc/scene/seSceneManager.h"
#include "evc/file/IseStateIO.h"

using namespace glb;
namespace evc
{
	seElemAnim::seElemAnim()
	{
	}

	seElemAnim::~seElemAnim()
	{
		glb::DeleteMap( this->dicElemState );
	}
	
	void seElemAnim::Load(IseStateInput *pInput, seSceneManager *pManager)
	{
		int iCount = static_cast<int>(pInput->ReadShort());
		seDefine::DebugTrace("StateCount", iCount);
		for (int i = 0; i < iCount; i++)
		{
			emElemState::Type eStateType = pInput->ReadEnum<emElemState,emElemState::Type>();
			seStateKeyManager *pKeyManager = evc_new seStateKeyManager(eStateType);
			pKeyManager->Load(pInput, pManager);
			this->dicElemState[eStateType] = pKeyManager;
		}
	}
}
