#include "glbPch.h"
#include "seStateKeyInfo.h"
#include "evc/scene/seSceneManager.h"
#include "evc/scene/seKeyControlManager.h"
#include "evc/file/IseStateIO.h"
#include "evc/seElem/seStateType.h"
#include "evc/seElem/seStateTypeEx.h"
#include "evc/AnimInterpolation/FePointInfo.h"

using namespace glb;
namespace evc
{

	void seStateKeyInfo::AddPoint(FePointInfo *pPointInfo)
	{
		this->lisPoint.push_back(pPointInfo);
	}

	seStateKeyInfo::seStateKeyInfo()
	{
	}

	seStateKeyInfo::~seStateKeyInfo()
	{
		glb::DeleteVector( this->lisPoint );
		GLB_SAFE_DELETE( this->pData );
	}

	float seStateKeyInfo::GetRate(float fTime)
	{
		if (this->lisPoint.size() <= 0) return 0.0f;
		return FePointInfo::GetPos(fTime, this->lisPoint);
	}

#if 0
	void seStateKeyInfo::Anim(IseStateType *pOutData, IseStateType *pBfoData, float fTime)
	{
		// _ꍇ̓Aj[VȂ
		if (this->lisPoint.size() <= 0) return;
	
		// _Aj[V擾
		float fRate = FePointInfo::GetPos(fTime, this->lisPoint);
		pOutData->Set(this->pData);
	
		// Aj[V
		pOutData->Anim(pBfoData, fRate);
	}
#endif

	int seStateKeyInfo::Load(IseStateInput *pInput)
	{
		int iKeyID = seKeyControlManager::InvalidID;
		this->strName = pInput->ReadString();
		// L[ꍇ̂݃L[f[^擾
		if ( !strName.IsEmpty() )
		{
			iKeyID = static_cast<int>(pInput->ReadShort());
		}
		this->iFrame = static_cast<int>(pInput->ReadShort());
	
		this->bDisableData = pInput->ReadBool();
		this->eMoveControl = pInput->ReadEnum<seKeyMoveContorl,seKeyMoveContorl::Type>();
		this->eSuccess = pInput->ReadEnum<seKeySuccess,seKeySuccess::Type>();
		this->eStateType = pInput->ReadEnum<emElemState,emElemState::Type>();
	
		// {A[vIłȂΈȉ̃f[^̓Z[uȂėǂB
		this->iLoopCount = static_cast<int>(pInput->ReadShort());
		this->iReturnFrame = pInput->ReadInt();
	
		this->pData = seStateUtil::CreateStateType(this->eStateType);
		this->pData->Load(pInput);
	
		int iPointNum = static_cast<int>(pInput->ReadByte());
		for (int i = 0; i < iPointNum; i++)
		{
			FePointInfo *pPointInfo = evc_new FePointInfo();
			pPointInfo->Load(pInput);
			this->lisPoint.push_back(pPointInfo);
		}
	
		return iKeyID;
	}
}
