/**
 * @file seStateKeyInfo.h
 * @brief 
 *
 * @author seri
 */
#ifndef SESTATEKEYINFO_H
#define SESTATEKEYINFO_H
#pragma once
#include "glb/glbDefine.h"
#include "evc/common/seDefine.h"


using namespace glb;

namespace evc
{
	class IseStateType;
	class IseStateInput;
	class FePointInfo;

	// L[ړ
	struct seKeyMoveContorl
	{
		enum Type
		{
			Non = 0, // ݒ
			LoopStart, // [vX^[g
			LoopEnd, // [vI
			Wait // L[i߂Ȃ
		};

		static int EnumMax() { return Wait; }
	};

	// L[pݒ
	struct seKeySuccess
	{
		enum Type
		{
			Non = 0, // ݒ
			On, // pON
			Off, // pOFF
		};
		static int EnumMax() { return Off; }
	};

	// 1Aj[VL[t[ǗNX
	class seStateKeyInfo
	{
	public:
		static const int Infinity = -1; // 

	private:
		est::vector<FePointInfo*> lisPoint;
		bool bDisableData;
		seKeySuccess::Type eSuccess;
		seKeyMoveContorl::Type eMoveControl;
		int	iLoopCount; // [v
		int	iReturnFrame; // Wv߂鎞̃t[
		glbString strName;
		IseStateType *pData;
		int	iFrame;
		emElemState::Type eStateType;

	public:
		// f[^(tÔ݂LɂꍇɗĂ)		
		bool DisableData() const	 { return this->bDisableData; }
		void DisableData(bool value) { this->bDisableData = value; }

		// p
		seKeySuccess::Type Success() const		{ return this->eSuccess; }
		void Success(seKeySuccess::Type value)	{ this->eSuccess = value; }

		// L[ړ
		seKeyMoveContorl::Type MoveControl() const	   { return this->eMoveControl; }
		void MoveControl(seKeyMoveContorl::Type value) { this->eMoveControl = value; }

		// Xe[^Xʃf[^擾Eݒ
		int LoopCount() const		{ return this->iLoopCount; }
		void LoopCount(int value)	{ this->iLoopCount = value; }
									
		int ReturnFrame() const		{ return this->iReturnFrame; }
		void ReturnFrame(int value) { this->iReturnFrame = value; }

		// O̎擾Eݒ
		const glbString *Name() const { return &this->strName; }
		void Name( const glbString *value) { this->strName = *value; }

		// L[̒l擾
		IseStateType *Data() { return this->pData; }
		void Data(IseStateType *value) { this->pData = value; }

		// Ԃ擾(ÕL[̍)
		int Frame() const { return this->iFrame; }
		void Frame( int value ) { this->iFrame = value; }

		// Xe[^X^Cv̎擾
		emElemState::Type StateType() const { return this->eStateType; }


		// ԃAj[V̒ǉ(Ƀ[hp
		void AddPoint(FePointInfo *pPointInfo);

		// RXgN^FN[/[hp
		seStateKeyInfo();
		virtual ~seStateKeyInfo();

		// POKeyInfoƌoߎԂ獡̃f[^擾
//		void Anim(IseStateType *pOutData, IseStateType *pBfoData, float fTime);

		// ԃAj[V
		bool HasSpeed() const { return (this->lisPoint.size() > 0); }

		// ԂAj[V̈ړ[g擾
		float GetRate(float fTime); 


		// 
		int Load(IseStateInput *pInput);
	};

}
#endif //SESTATEKEYINFO_H

