#include "glbPch.h"
#include "evc/common/seDefine.h"
#include "evc/scene/seSceneManager.h"
#include "evc/scene/seKeyControlManager.h"

#include "evc/file/IseStateIO.h"
#include "seStateKeyManager.h"
#include "seStateKeyInfo.h"


using namespace glb;
namespace evc
{

	seStateKeyManager::seStateKeyManager(emElemState::Type eStateType)
	{
		this->eStateType = eStateType;
	}

	seStateKeyManager::~seStateKeyManager()
	{
		this->Clear();
	}

	void seStateKeyManager::Clear()
	{
		glb::DeleteVector( this->liKeyList );
	}


	void seStateKeyManager::Load(IseStateInput *pInput, seSceneManager *pSceneManager)
	{
		this->eStateType = pInput->ReadEnum<emElemState,emElemState::Type>();
		int iCount = static_cast<int>(pInput->ReadShort());
		seDefine::DebugTrace("KeyCount", iCount);
		for (int i = 0; i < iCount; i++)
		{
			seStateKeyInfo *pKeyInfo = evc_new seStateKeyInfo();
			int iKeyID = pKeyInfo->Load(pInput);
			this->liKeyList.push_back(pKeyInfo);
	
			// LȃL[̏ꍇ͓o^
			if (iKeyID != seKeyControlManager::InvalidID)
			{
				pSceneManager->KeyControlManager()->seIDManager<seStateKeyInfo*>::Add(iKeyID, pKeyInfo);
			}
		}
	}
}
