/**
 * @file seElemState.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEELEMSTATE_H
#define SEELEMSTATE_H
#pragma once
#include "glb/glbColor.h"
#include "evc/common/seDefine.h"
#include "evc/seElem/seStateType.h"
#include "evc/seElem/seStateTypeEx.h"

using namespace glb;
namespace glb
{
	class IGLMatrix;
}

namespace evc
{
	class seStateData;
	class siMaterial;
	class seStateSwitchInt1;
	class seStateAttribute;
	class seStateColor;
	class seStateRot;
	class seStateInt1;

	/**
	 * PvfԊǗNX
	 * Aj[VǗ猻݂̃f[^炢A
	 * p̃f[^쐬AǗ܂B
	 */
	class seElemState
	{
	private:
		est::vector<seStateData*> asStateList;	// pf[^Xg
		IGLMatrix *sAnimMatrix;					// Aj[V}gNX
		IGLMatrix *sParentMatrixWork;			// ptO鎞ɍŏIIɐe}gNX
		const IGLMatrix	*sParentMatrix;			// ŏIIɗpe}gNX(N̂)
		IGLMatrix *sNowMatrix;
		glbColor sColor;
		int iPriority;
		glbVector2 _bfoPos;				// Öʒu:ɒOƂ̌Zop

		seStateInt1		  *pPriority;
		seStateAttribute  *pAttribute;
		seStateColor	  *pColor;
		seStatePos		  *pPos;
		seStateFloat2	  *pScale;
		seStateFloat2	  *pCenter;
		seStateRot		  *pRot;
		seStateInt1		  *pMask;

		// \tO擾(Show:\, Hide:\, Succes:ep ̉ꂩ)
		seAttrVisible::Type eVisible;

	public:

		seAttrVisible::Type Visible() const { return this->eVisible; }

		// e}gNX擾
		const IGLMatrix *ParentMatrix() const { return this->sParentMatrix; }

		// eƍ̃}gNX擾
		const IGLMatrix *NowMatrix() const { return this->sNowMatrix; }

		// eƍ̃J[擾
		const glbColor *NowColor() const	   { return &this->sColor; }
		void NowColor( const glbColor *value ) { this->sColor = *value; }

		// eƍ̕\Dx擾
		int NowPriority() const { return this->iPriority; }

		// Öʒu
		const glbVector2 *BfoPos() const { return &this->_bfoPos; }

		// GgʃXe[^X

		// \Dx
		seStateInt1 *Priority() { return this->pPriority; }

		// 
		seStateAttribute *Attrbute() { return this->pAttribute; }

		// J[
		seStateColor *Color() { return this->pColor; }

		// ʒu
		seStatePos *Pos() { return this->pPos; }

		// XP[
		seStateFloat2 *Scale() { return this->pScale; }

		// Sʒu
		seStateFloat2 *Center() { return this->pCenter; }

		// ]
		seStateRot *Rot() { return this->pRot; }

		// }XNAt@l
		seStateInt1 *Mask() { return this->pMask; }


		// SẴXe[^XAj[VJnOԂɂ
		void RestartAnim();

		// Aj[V̍XV
		bool UpdateAnim(float fFrameTime, float fTime);

		void ClearAnim();

		// Xe[^X擾
		IseStateType *At( emElemState::Type eType );

		// f[^擾
		seStateData *GetData(emElemState::Type eType);

		// f[^擾
		void SetState(seElemState *pState);


		// ݂̃f[^f[^쐬
		void Apply();

		// }gNX̂݌p
		void Succession( const IGLMatrix *mParent);

		// f[^p
		void Succession(seElemState *pParentState);


		// `O}eAݒ
		void SetMaterial(siMaterial *pMaterial);


		// X[e^Xf[^N
		// ȍ~Aݒ肳ꂽf[^ɃAj[V߂܂B
		void LinkStateData(emElemState::Type eState, IseStateType *pStateType);

		// gf[^폜
		void ClearStateData();

		// RXgN^
		seElemState();
		virtual ~seElemState();
	};
}
#endif //SEELEMSTATE_H

