#include "glbPch.h"
#include "evc/seElem/seElemAnim/seStateKeyManager.h"
#include "evc/seElem/seElemAnim/seStateKeyInfo.h"
#include "evc/seElem/seStateType.h"
#include "evc/scene/seRootScene.h"
#include "seStateData.h"
#include "seStateFlgKey.h"
#include "seStateJump.h"

namespace evc
{
	void seStateData::RestartAnim()
	{
		this->fStateTime = 0.0f;
		this->fTime = 0.0f;
		this->iKeyIndex = KeyCode::First;
		this->iNextFrame = 0;
		// ݂̃f[^PÕf[^ƂB
		this->pBeforData->Set(this->pData);
	
		// [ṽL[Wvpf[^̃NA
		this->pFlgKey->Clear();
		this->pJumpStack->Clear();
	}

	void seStateData::ChangeAnim( const seStateKeyManager *pNewKeyManger)
	{
		// Aj[VJnOԂɂ
		this->RestartAnim();
		// VL[}l[Wݒ
		this->pKeyManager = pNewKeyManger;
	}

	bool seStateData::Update(float fFrameTime, float fTime)
	{
		// xL[ʉ߃tONA
		this->bMoveKey = false;
	
		if (this->pKeyManager == null) return false;
	
		// ߂ĂȂڕWL[ݒ
		if (this->iKeyIndex == KeyCode::First)
		{
			this->MoveNextDataKey();
		}
		// IȂ疳
		else if (this->iKeyIndex == KeyCode::End)
		{
			return false;
		}

		// L[Xg擾
		const est::vector<seStateKeyInfo*> &keys = this->pKeyManager->Keys();

		if ( (int)keys.size() <= this->iKeyIndex) return false;
		// L[͈͊Ȍꍇ(ɃAj[VIĂ铙)͖
		if (this->iKeyIndex < 0) return false;
	
		seStateKeyInfo *pNowKey = keys[this->iKeyIndex];
		float fKeyTime = 0.0f;
	
		// Pt[̃~b
		this->fTime += fTime;
		// f[^L[Ԃ̈ړԂZ
		this->fStateTime += fTime;
	
		// ̎Ԃ̒ÕL[擾
		while (pNowKey != null)
		{
			fKeyTime = this->iNextFrame * fFrameTime;
	
			// L[ʂ߂ĂȂȂI
			if (this->fTime < fKeyTime) break;
	
			this->Data()->Add(pNowKey->Data());
			this->pBeforData->Add(pNowKey->Data());
	
			// ̃L[ֈړ
			this->fTime -= fKeyTime;
			this->fStateTime = this->fTime;
	
			// L[ztOZbg
			this->bMoveKey = true;
	
			// f[^ҋ@Ȃ玟̃L[ɍsI
			if (pNowKey->MoveControl() == seKeyMoveContorl::Wait)
				return true;
	
			// ̃L[擾
			pNowKey = this->GetNextKey();
		}
	
		// L[̊ԂȂ
		if (pNowKey != null)
		{
			// tOL[Ǘ
			if (this->UpdateFlagKey(fFrameTime))
			{
				pNowKey = keys[this->iKeyIndex];
			}

			if (pNowKey->HasSpeed())
			{
				float fRate = pNowKey->GetRate(this->fTime / fKeyTime);
				this->Data()->Anim(pNowKey->Data(), this->pBeforData, fRate);
			}
		}
		else
		{
			this->iKeyIndex = KeyCode::End;
		}
	
		return true;
	}

	bool seStateData::UpdateFlagKey(float fFrameTime)
	{
		struct func : public deFunc1<seStateKeyInfo *,bool>
		{
			seStateData *pme;
			float fFrameTime;
			bool bRet;

			func( seStateData *pInMe, float fInFrameTime )
				: pme( pInMe ), fFrameTime( fInFrameTime ), bRet( false ) {}

			bool operator()(seStateKeyInfo *pKey )
			{
				float fNextFrame = fFrameTime * pKey->Frame();
		
				if (pme->fStateTime < fNextFrame) return false;
		
				// L[ʉߏ
				if (pme->PassageKey(pKey))
				{
					// L[̃Wv(Loop)ꍇ
					// tOpL[NAĂ̂őɏI
					this->bRet = true;
					return false;
				}
		
				pme->fStateTime -= fNextFrame;
				return true;
			}
		};

		func f( this, fFrameTime );
		this->pFlgKey->DoFoInfo( &f );

		return f.bRet;
	}

	bool seStateData::MoveNextDataKey()
	{
		int iStartID = (this->iKeyIndex == KeyCode::First) ? 0 : this->iKeyIndex + 1;
		this->iNextFrame = 0;
		this->pFlgKey->Clear();
	
		const est::vector<seStateKeyInfo*> &keys = this->pKeyManager->Keys();
		for (int i = iStartID; i < (int)keys.size(); i++)
		{
			// ̃f[^̂L[Ȃ
			seStateKeyInfo *pNextKey = keys[i];
			this->iNextFrame += pNextKey->Frame();
	
			// f[^L[ȂI
			if (!pNextKey->DisableData())
			{
				this->iKeyIndex = i;
				return true;
			}
			// f[^Ȃ(tOp)L[Ȃۑ
			else
			{
				this->pFlgKey->Add(pNextKey);
			}
		}
		return false;
	}

	seStateKeyInfo *seStateData::GetNextKey()
	{
		const est::vector<seStateKeyInfo*> &keys = this->pKeyManager->Keys(); 
		seStateKeyInfo *pKey = keys[this->iKeyIndex];
	
		// L[ʉߎ
		if (this->PassageKey(pKey))
		{
			// ʉߎɃL[̃Wv̂ł̂܂ܕԂ
			return keys[this->iKeyIndex];
		}
	
		// keyf[^ƌJnʒũt[ݒ
		if (this->MoveNextDataKey())
		{
			return keys[this->iKeyIndex];
		}
	
		return null;
	}

	bool seStateData::PassageKey(seStateKeyInfo *pKey)
	{
		bool bRet = false;
	
		// ҏW̓[v𖳎
		if (!seRootScene::Instance()->EditMode())
		{
			// ʉ߂L[ɑ΂ă[vB
			switch (pKey->MoveControl())
			{
				// [vJnʒuȂX^bNɓo^
				case seKeyMoveContorl::LoopStart:
					this->pJumpStack->AddStack(pKey);
					break;
				// [vIʒuȂ
				case seKeyMoveContorl::LoopEnd:
					{
						seStateKeyJumpStack *pStack = this->pJumpStack->IncLoopNum();
						if (pStack != null)
						{
							// [vw񐔏IȂ
							if ((pKey->LoopCount() != seStateKeyInfo::Infinity) &&
								(pStack->iLoopNum > pKey->LoopCount()))
							{
								// X^bNP炷
								this->pJumpStack->Pop();
							}
							// w񐔂ȂȂ
							else
							{
								// [vJnʒuɔ
								this->iKeyIndex = -1;
								const est::vector<seStateKeyInfo*> &keys = this->pKeyManager->Keys();
								for( est::size_t i = 0; i < keys.size(); i++)
								{
									if ( keys[i] == pStack->pKey)
									{
										this->iKeyIndex = (int)i;
										break;
									}
								}
								// ̃L[܂ł̃t[
								this->iNextFrame = pKey->ReturnFrame();
								// L[t[Wv鎞͐FXȂ̂KvB
								this->pFlgKey->Clear();
								bRet = true;
							}
						}
					}
					break;
				default:
					break;
			}
		}
	
		// p邩ۂݒ
		switch (pKey->Success())
		{
			case seKeySuccess::On: this->EnableSuccession(true); break;
			case seKeySuccess::Off: this->EnableSuccession(false); break;
			default: break;
		}
	
		return bRet;
	}

	seStateData::seStateData(IseStateType *pData, bool bEnable)
		: pBeforData( null) // PO
		, pData( null ) // ݂̃f[^
		, bEnableSuccession( true ) // ptO
		, bVisible( true ) // \tO
		, bMoveKey( false ) // Aj[V̍XVAL[zۂ
		// Đo
		, fTime( 0.0f ) // ݂̌oߎ
		, iKeyIndex( KeyCode::First ) // Ōɒʉ߂L[
		, iNextFrame(0) // ̃L[܂ł̃t[
		, pKeyManager(null) // Đ̃L[}l[W

		// tOpL[pRg[o
		, fStateTime( 0.0f ) // f[^L[ƃf[^L[̊Ԃ̌oߎ
		, pFlgKey( null )
		, pJumpStack( null )
	{
		this->pData = pData;
		this->bEnableSuccession = bEnable;
		this->pBeforData = pData->Clone();
		this->pFlgKey = evc_new seStateFlgKey();
		this->pJumpStack = evc_new seStateJump();
	}

	seStateData::~seStateData()
	{
		// }X^[̊J͊OɔC
//		GLB_SAFE_DELETE( this->pData );
		GLB_SAFE_DELETE( this->pBeforData );
		GLB_SAFE_DELETE( this->pFlgKey );
		GLB_SAFE_DELETE( this->pJumpStack );
	}

}
