/**
 * @file seStateData.h
 * @brief 
 *
 * @author seri
 */
#ifndef INCLUDE_SESTATEDATA_H
#define INCLUDE_SESTATEDATA_H


namespace evc
{
	class IseStateType;
	class seStateKeyManager;
	class seStateKeyInfo;
	class seStateFlgKey;
	class seStateJump;

	/** KeyIndexpR[h
	 * @brief 
	 */
	class KeyCode
	{
	public:
		const static int First = -1; //!< ߂ẴAj[V
		const static int End = -2;	 //!< I
	};

	/** Xe[^XǗ\
	 * @brief Gg̃Xe[^XPǗ܂B
	 */
	class seStateData
	{
	private:
		IseStateType *pBeforData; // PO
		IseStateType *pData; // ݂̃f[^
		bool bEnableSuccession; // ptO
		bool bVisible; // \tO
		bool bMoveKey; // Aj[V̍XVAL[zۂ

		// Đo
		float fTime; // ݂̌oߎ
		int iKeyIndex; // Ōɒʉ߂L[
		int iNextFrame; // ̃L[܂ł̃t[
		const seStateKeyManager *pKeyManager; // Đ̃L[}l[W

		// tOpL[pRg[o
		float fStateTime; // f[^L[ƃf[^L[̊Ԃ̌oߎ
		seStateFlgKey *pFlgKey;
		seStateJump *pJumpStack;


	public:
		/** Xe[^Xf[^̎擾
		 * @brief 
		 * @return 
		 */
		IseStateType *Data() const { return pData; }

		/** \̎擾
		 * @brief 
		 * @return 
		 */
		bool MoveKey() const { return bMoveKey; }

	public:

		/** \̎擾
		 * @brief 
		 * @return 
		 */
		bool Visible() const { return bVisible; }
		/** 
		 * @brief 
		 * @param value
		 */
		void Visible( bool value ) { bVisible = value; }
		
		/** p擾
		 * @brief 
		 * @return 
		 */
		bool EnableSuccession() const { return bEnableSuccession; }
		/** 
		 * @brief 
		 * @param value
		 */
		void EnableSuccession( bool value ) { bEnableSuccession = value; }

		/** Aj[VJnOԂɂ
		 * @brief 
		 */
		void RestartAnim();

		/** Aj[VύXꂽ̏
		 * @brief 
		 * @param pNewKeyManger
		 */
		void ChangeAnim( const seStateKeyManager *pNewKeyManger);

		/** Aj[V̍XV
		 * @brief 
		 * @param fFrameTime
		 * @param fTime
		 * @return true:XV false:XVȂ
		 */
		bool Update(float fFrameTime, float fTime);

		/** 
		 * @brief RXgN^
		 * @param pData
		 * @param bEnable
		 */
		seStateData(IseStateType *pData, bool bEnable);

		/** 
		 * @brief fXgN^
		 */
		virtual ~seStateData();

	private:
		/** tOpL[
		 * @brief 
		 * @param fFrameTime
		 * @return true:L[ړ false:L[͈ړȂ
		 */
		bool UpdateFlagKey(float fFrameTime);

		/** ̃L[ֈړ
		 * @brief L[f[^̓ԂiStartID܂߂
		 * ̃f[^̂L[܂ňړԂɂB
		 * @return 
		 */
		bool MoveNextDataKey();

		/** ݂̃L[玟̃L[擾
		 * @brief 
		 * @return 
		 */
		seStateKeyInfo *GetNextKey();

		/** L[ʉߎ
		 * @brief 
		 * @param pKey
		 * @return true:L[̃Wv false:L[̃Wv͂Ȃ
		 */
		bool PassageKey(seStateKeyInfo *pKey);
	};
}
#endif // INCLUDE_SESTATEDATA_H
