/**
 * @file seStateTypeEx.h
 * @brief 
 *
 * @author seri
 */
#ifndef SESTATETYPEEX_H
#define SESTATETYPEEX_H
#pragma once
#include "glb/glbDefine.h"
#include "evc/seObject/ObjectParts/seoNum.h"
#include "evc/AnimInterpolation/FePointInfo.h"
#include "evc/file/IseStateIO.h"
#include "seStateType.h"


using namespace glb;
namespace evc
{
	class IseStateType;
	class seSceneManager;
	class seObjectManager;
	class seObject;



	// eNX`蔻
	struct seTexHit
	{
		enum Type
		{
			Non = 0, // ݒ
			Rectangle, // `P
			Pixel, // sNZP
		};
		static int EnumMax() { return Pixel; }
	};

	// eNX`AhXݒ
	struct seTexAddress
	{
		enum Type
		{
			Non = 0, // ݒ(Aj[V̂ݐݒ\ł)
			Wrap, // ͈͂𒴂eNX`̓[v
			Clamp, // ͈͂𒴂eNX`͍Ō̃hbgL΂B
		};
		static int EnumMax() { return Clamp; }
	};


	// eNX`
	class seStateTextureControl : public IseStateType
	{
	private:
		seTexHit::Type eHit;
		seTexAddress::Type eAddress;

	public:
		seStateTextureControl();

		// eNX`蔻ݒ
		seTexHit::Type Hit() const		{ return this->eHit; }
		void Hit(seTexHit::Type value);

		// eNX`AhXݒ
		seTexAddress::Type Address() const		{ return this->eAddress; }
		void Address(seTexAddress::Type value)	{ this->eAddress = value; }

		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState);
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate){}
		virtual void Load(IseStateInput *pInput);
		virtual IseStateType *Clone();
	};



	// [hݒ
	struct seLoadControl
	{
		enum Type
		{
			Load = 0, // [h
			Release, // 
		};
		static int EnumMax() { return Release; }
	};

	// [hRg[NX
	class seStateLoadControl : public IseStateType
	{
		// Xe[^X̎擾Eݒ
	private:
		seLoadControl::Type eState;

	public:
		seLoadControl::Type State() const		{ return this->eState; }
		void State( seLoadControl::Type value)	{ this->eState = value; }

		// w̃f[^Lۂ
		bool IsEnable( seLoadControl::Type eCheckType ) const;

		// RXgN^
		seStateLoadControl();
		seStateLoadControl(seLoadControl::Type eInState);

		// N[
		virtual IseStateType *Clone();
		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState){ this->Set(pState); }
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate){}
		virtual void Load(IseStateInput *pInput);
	};





	// TEhݒ
	struct seSoundControl
	{
		enum Type
		{
			Non = 0, // 
			Play, // TEhĐ
			PlayLoop, // TEh[vĐ
			Stop, // TEh~
		};
		static int EnumMax() { return Stop; }
	};


	// TEhRg[NX
	class seStateSoundControl : public IseStateType
	{
	private:
		seSoundControl::Type eState;
	public:
		seSoundControl::Type State() const		{ return this->eState; }
		void State(seSoundControl::Type value)	{ this->eState = value; }

		// RXgN^
		seStateSoundControl();
		seStateSoundControl(seSoundControl::Type eInSoundControl);

		// N[
		virtual IseStateType *Clone();
		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState);
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate){}
		virtual void Load(IseStateInput *pInput);
	};




	// uhݒ
	struct seAttrBlend
	{
		enum Type
		{
			Non = 0, // ݒ(Aj[V̂ݐݒ\ł)
			Normal, // ʏuh
			Add, // Z
			Sub, // Z
		};
		static int EnumMax() { return Sub; }
	};

	// }XNݒ
	struct seAttrMask
	{
		enum Type
		{
			Non = 0, // ݒ(Aj[V̂ݐݒ\ł)
			NoUse, // }XNgpȂ
			Data, // }XN
			Reflection, // }XNK
			End, // }XNI
		};
		static int EnumMax() { return End; }
	};


	// \ݒ
	// qvfŕ\ݒ肪ĂȂꍇɌ
	// evf̕\ݒp܂B
	struct seAttrVisible
	{
		enum Type
		{
			Non = 0, // ݒ(Aj[V̂ݐݒ\ł)
			Show, // \
			Hide, // \
			Succes, // ȅԂp
		};
		static int EnumMax() { return Succes; }
	};


	// NX
	class seStateAttribute : public IseStateType
	{
		// uhݒ
	private:
		seAttrBlend::Type eBlend;
		seAttrMask::Type eMask;
		seAttrVisible::Type eVisible;

	public:
		seAttrBlend::Type Blend() const		{ return this->eBlend; }
		void Blend(seAttrBlend::Type value) { this->eBlend = value; }

		// }XNݒ
		seAttrMask::Type Mask() const	 { return this->eMask; }
		void Mask(seAttrMask::Type value){ this->eMask = value; }

		// \ݒ
		seAttrVisible::Type Visible() const			{ return this->eVisible; }
		void Visible( seAttrVisible::Type value )	{ this->eVisible = value; }

		// RXgN^
		seStateAttribute();

		// N[
		virtual IseStateType *Clone();
		virtual void Set(IseStateType *s);
		virtual void Add(IseStateType *pState);
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate){}
		virtual void Load(IseStateInput *pInput);
	};



	// t[Rg[NX([h҂AAj[VWvp)
	class seStateFrameCtrl : public IseStateType
	{
		// ^[QbgV[
	private:
		seSceneManager	*pSceneManager;
		int				iFinishLoadAnimID;
		int				iLoadingAnimID;
		bool			bWatchAll;
		est::vector<int> lisWatchID;		// Ď\[XXg

	public:
		seSceneManager *SceneManager() const	{ return this->pSceneManager; }
		void SceneManager(seSceneManager *value){ this->pSceneManager = value; }

		// [hIȂsAj[V
		int FinishLoadAnimID() const	{ return this->iFinishLoadAnimID; }
		void FinishLoadAnimID(int value){ this->iFinishLoadAnimID = value; }

		// [hȂړAj[V
		int LoadingAnimID() const		{ return this->iLoadingAnimID; }
		void LoadingAnimID(int value)	{ this->iLoadingAnimID = value; }

		// SĊĎtO:
		// ꂪtruȅꍇAĎXg𖳎đSẴ[hIĂ邩̔ɂȂ܂B
		bool IsWatchAll() const		{ return this->bWatchAll; }
		void IsWatchAll(bool value) { this->bWatchAll = value; }

		// ĎΏۂ̃\[X
		bool IsWatch(int iResourceID) const;

		// Ď\[Xǉ
		void AddWatch(int iResourceID);
		// Ď\[X폜
		void RemoveWatch(int iResourceID);
		// Ď\[XNA
		void ClearWatch();

		// `FbN
		void DoCheck();

		// RXgN^
		seStateFrameCtrl();
		virtual ~seStateFrameCtrl(){}

		// f[^ݒ
		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState) { this->Set(pState); }
		virtual void Load(IseStateInput *pInput);
		virtual IseStateType *Clone();
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate){}
	};



	// eLXgXe[^X
	struct seTextControl
	{
		enum Type
		{
			AllDraw = 0, // IɂPy[WS\
			TextSpeed, // eLXg̕\x
		};
		static int EnumMax(){ return TextSpeed; }
	};

	// eLXg\Rg[NX
	class seStateTextControl : public IseStateType
	{
	private:
		int iPage;
		seTextControl::Type eState;

	public:
		int Page() const	 { return this->iPage; }
		void Page(int value) { this->iPage = value; }

		seTextControl::Type State() const		{ return this->eState; }
		void State(seTextControl::Type value)	{ this->eState = value; }

		// RXgN^
		seStateTextControl();

		// N[
		virtual IseStateType *Clone();
		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState){ this->Set(pState); }
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate){}
		virtual void Load(IseStateInput *pInput);
	};


	// lC[WNX(IuWFNgp)
	// IuWFNgƂƂ肷鎞̂ݎgp܂B
	// AnimSet͓܂
	class seStateNumImage : public IseStateType
	{
	private:
		seObjectManager *pObjectManager;
		est::vector<seObject *> apImageList;

	public:
		seObjectManager *ObjectManager() const { return this->pObjectManager; }
		void ObjectManager(seObjectManager *value) { this->pObjectManager = value; }

		const est::vector<seObject *> *Images() const { return &this->apImageList; }

		// C[Wݒ
		void SetImage(seoNumImage::Type eImageType, seObject *pObject);

		// C[W擾
		seObject *GetImage(seoNumImage::Type eImageType);

		// RXgN^
		seStateNumImage();
		virtual ~seStateNumImage(){}

		// N[
		virtual IseStateType *Clone();
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate){}
		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState){ this->Set(pState); }
		virtual void Load(IseStateInput *pInput);
	};



	// ʒu
	struct seNumArrange
	{
		enum Type
		{
			Non = 0, // ݒ(Aj[V̂ݐݒ\ł)
			L, // 
			R, // E
			Point // _
		};

		static int EnumMax() { return Point; }
	};

	// ݒ
	struct seNumCharLen
	{
		enum Type
		{
			Non = 0, // ݒ(Aj[Vݒ莞̂ݑI܂)
			Fix, // Œ:seStateNumInfo.NumLenK܂B
			Change, // :l̕K܂B
		};
		static int EnumMax() { return Change; }
	};

	// \ݒ
	struct seNumVisible
	{
		enum Type
		{
			Non = 0, // ݒ(Aj[Vݒ莞̂ݑI܂)
			On, // \
			Off, // \
		};
		static int EnumMax() { return Off; }
	};

	// lXe[^XNX(Aj[Vp)
	class seStateNumInfo : public IseStateType
	{
	private:
		seNumArrange::Type eArrange;
		seNumCharLen::Type eCharLen;
		seNumVisible::Type eVisibleComma;
		seNumVisible::Type eVisibleMinus;
		seNumVisible::Type eZeroBuries;		// 0
		int iMaxDisit;
		int iPointDraw;
		int iNumLen;
		int iCommaLen;

	public:
		// RXgN^
		seStateNumInfo()
			: eCharLen( seNumCharLen::Change )
			, eVisibleComma( seNumVisible::Off )
			, eVisibleMinus( seNumVisible::Off )
			, eZeroBuries( seNumVisible::Off )
			, iMaxDisit( 0 )
			, iPointDraw( 0 )
			, iNumLen( 0 )
			, iCommaLen( 0 )
		{}

		virtual ~seStateNumInfo(){}


		seNumArrange::Type Arrange() const		{ return this->eArrange; }
		void Arrange(seNumArrange::Type value)	{ this->eArrange = value; }

		// ݒ
		seNumCharLen::Type CharLen() const		 { return this->eCharLen; }
		void CharLen( seNumCharLen::Type value ) { this->eCharLen = value; }

		// J}\ݒ
		seNumVisible::Type VisibleComma() const		  { return this->eVisibleComma; }
		void VisibleComma( seNumVisible::Type value ) { this->eVisibleComma = value; }

		// }CiX\ݒ
		seNumVisible::Type VisibleMinus() const		 { return this->eVisibleMinus; }
		void VisibleMinus( seNumVisible::Type value) { this->eVisibleMinus = value; }

		// 0ߕ\ݒ
		seNumVisible::Type VisibleZeroBuries() const	  { return this->eZeroBuries; }
		void VisibleZeroBuries( seNumVisible::Type value) { this->eZeroBuries = value; }


		// ő包
		int MaxDisit() const		{ return this->iMaxDisit; }
		void MaxDisit(int value)	{ this->iMaxDisit = value; }

		// _ȉ
		int PointDraw() const		{ return this->iPointDraw; }
		void PointDraw(int value)	{ this->iPointDraw = value; }

		// Œ蕶(Œ蕶\̎̂ݎgp)
		int NumLen() const		{ return this->iNumLen; }
		void NumLen(int value)	{ this->iNumLen = value; }

		// ŒJ}
		int CommaLen() const	 { return this->iCommaLen; }
		void CommaLen(int value) { this->iCommaLen = value; }


		// N[
		virtual IseStateType *Clone();
		virtual void Anim( IseStateType *pNext, IseStateType *pBefore, float fRate ){}
		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState);
		virtual void Load(IseStateInput *pInput);
	};




	// ]^Cv
	struct seSpinType
	{
		enum Type
		{
			Non = 0, // px̋߂ŉ]
			Left,	 // 
			Right,	 // E
			Direction,	// ړ
		};

		static int EnumMax() { return Right; }
	};


	// RotNX	
	class seStateRot : public IseStateType
	{
	private:
		float fRot;
		seSpinType::Type eSpinType;
		int iRotNum;

	public:
		// px擾Eݒ
		float Rot() const		{ return this->fRot; }
		void Rot(float value)	{ this->fRot = value; }

		// ]̎擾Eݒ
		seSpinType::Type SpinType() const		{ return this->eSpinType; }
		void SpinType(seSpinType::Type value)	{ this->eSpinType = value; }

		// ]̎擾Eݒ
		int RotNum() const		{ return this->iRotNum; }
		void RotNum(int value)	{ this->iRotNum = value; }

		// RXgN^
		seStateRot()
			: fRot( 0.0f )
			, eSpinType( seSpinType::Non )
			, iRotNum( 0 )
		{}

		seStateRot(float fInRot, int iInRotNum, seSpinType::Type eInSpinType)
			: fRot( fInRot )
			, eSpinType( eInSpinType )
			, iRotNum( iInRotNum )
		{}

		virtual IseStateType *Clone();
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate);
		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState) { this->Set(pState); }
		virtual void Load(IseStateInput *pInput);
	};


	// looppNX
	class seStateLoop : public IseStateType
	{
	private:
		bool bRevW;
		bool bRevH;
		int iLoopCountW;
		int iLoopCountH;

	public:
		// ɔ]
		bool RevW() const		{ return this->bRevW; }
		void RevW(bool value)	{ this->bRevW = value; }

		// JԂ
		int LoopCountW() const		{ return this->iLoopCountW; }
		void LoopCountW(int value)	{ this->iLoopCountW = value; }

		// cɔ]
		bool RevH() const		{ return this->bRevH; }
		void RevH(bool value)	{ this->bRevH = value; }

		// cJԂ
		int LoopCountH() const		{ return this->iLoopCountH; }
		void LoopCountH(int value)	{ this->iLoopCountH = value; }


		seStateLoop()
			: bRevW( false )
			, bRevH( false )
			, iLoopCountW( 1 )
			, iLoopCountH( 1 )
		{}
		seStateLoop(bool bEnableRevW, int iInLoopCountW, bool bEnableRevH, int iInLoopCountH )
			: bRevW( bEnableRevW )
			, bRevH( bEnableRevH )
			, iLoopCountW( iInLoopCountW )
			, iLoopCountH( iInLoopCountH )
		{}

		virtual IseStateType *Clone();
		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState) { this->Set(pState); }
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate);
		virtual void Load(IseStateInput *pInput);
	};



	// ړ^Cv
	struct sePosType
	{
		enum Type
		{
			Line,	// C
			Path	// pX
		};
		static int EnumMax() { return Path; }
	};


	// ʒuNX
	class seStatePos : public IseStateType
	{
	public:
		static const float Power; //  = 3.0f;	// p[W
	private:
		glbVector2 _value;		// ʒu
		sePosType::Type _type;	// ړ^Cv
		float _exData[2];		// ^Cvʃf[^
	public:
		// ʒu
		const glbVector2 *Value() const { return &this->_value; }
		void Value( const glbVector2 *pvalue ) { this->_value = *pvalue; }

		// ړ^Cv
		sePosType::Type Type() const { return this->_type; }
		void Type( sePosType::Type type ) { this->_type = type; }

		// ^Cvʃf[^
		const float* ExData() const { return (float*)this->_exData; }

		seStatePos();
		seStatePos( seStatePos *mst );
		virtual ~seStatePos(){}

		virtual IseStateType *Clone();
		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState) { this->Set(pState); }
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate);
		virtual void Load(IseStateInput *pInput);
	};




	/**
	 * ColorpNX
	 * Zʂ255𒴂ꍇ255ɂ܂߂
	 * Zʂ0ȉ̏ꍇ0ɂ܂߂
	 */
	class seStateColor : public IseStateType
	{
	private:
		glbColor sColor;

	public:
		const glbColor *Color() const { return &this->sColor; }
		void Color( const glbColor *value) { this->sColor = *value; }


		seStateColor() : sColor( glbColor::White ){}
		seStateColor( const glbColor *sInColor ) : sColor( *sInColor ){}
		seStateColor( unsigned char bR, unsigned char bG, unsigned char bB, unsigned char bA)
			: sColor( glbColor( bR, bG, bB, bA ) ){}


		virtual void Load(IseStateInput *pInput);

		// N[
		virtual IseStateType *Clone();

		// `
		static const seStateColor *White; // = evc_new seStateColor(255,255,255,255);

		virtual void Set(IseStateType *pInState);
		virtual void Add(IseStateType *pState) { this->Set(pState); }
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate);
	};



	// ObhIuWFNgNX
	class seStateGridPoint : public IseStateType
	{
	private:
		glbVector2 _value;
		glbVector2 _powerH;
		glbVector2 _powerV;
	public:
		const glbVector2 *Value() const { return &this->_value; }
		void Value( const glbVector2 *pvalue ) { this->_value = *pvalue; }

		const glbVector2 *PowerH() const { return &this->_powerH; }
		void PowerH( const glbVector2 *pvalue ) { this->_powerH = *pvalue; }

		const glbVector2 *PowerV() const { return &this->_powerV; }
		void PowerV( const glbVector2 *pvalue ) { this->_powerV = *pvalue; }


		seStateGridPoint();
		seStateGridPoint(seStateGridPoint *pMst);

		// N[
		virtual IseStateType *Clone();
		virtual void Set(IseStateType *pState);
		virtual void Add(IseStateType *pState) { this->Set(pState); }
		virtual void Load(IseStateInput *pInput);
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate);
	};





	// p[eBNĐ
	struct ParticlesPlay
	{
		enum Type
		{
			Non,		// ݒ
			Play,		// Jn
			PlayOne,	// P񂾂Jn
			Stop,		// ~
		};
		static int EnumMax() { return Stop; }
	};

	// o̓^Cv
	struct ParticlesOutType
	{
		enum Type
		{
			Non,	// ݒ
			Point,	// _
			Plane,	// 
		};
		static int EnumMax() { return Plane; }
	};


	// p[eBNXP[^Cv
	struct ParticlesSuccession
	{
		enum Type
		{
			Non,		// ݒ(ȌԂp)
			Use,		// e̒lgp
			NoUse,		// e̒lgpȂ
		};
		static int EnumMax() { return NoUse; }
	};

	// p[eBN]^Cv
	struct ParticlesRot
	{
		enum Type
		{
			Non,		// ݒ(ȌԂp)
			Normal,		// ʏ
			Succession,	// e̒lgp
			Direction,	// ړ
		};
		static int EnumMax() { return Direction; }
	};

	// `揇
	struct ParticlesDrawPriority
	{
		enum Type
		{
			Non,		// ݒ(ȌԂp)
			Top,		// p[eBN͎Oɒu܂B
			Interior,	// p[eBN͉ɒu܂B
		};
		static int EnumMax() { return Interior; }
	};


	// p[eBNo̓Gg
	class seStateParticles : public IseStateType
	{
	private:
		float _outCount;		// Pt[̏o͐
		int _startFrame;		// X^[gt[
		ParticlesPlay::Type _play;	// ˊJnE~
		ParticlesDrawPriority::Type _priority;	// p[eBN̔zuʒu
		ParticlesSuccession::Type _successionScale;	// ẽXP[p邩ۂ
		ParticlesRot::Type _successionRot;	// ẻ]p邩ۂ
		ParticlesOutType::Type _outType;	// o̓^Cv
		glbVector2 _outVector;		// o͕yуp[
		float _outScaleLenge;		// o͔͈(p[XP[)
		float _outLenge;	// o͔͈(px)
		glbVector2 _influenceVector; // eyуp[
		float _influenceScaleLenge;	// e͈(p[XP[)
		float _influenceLenge; // e͈

	public :
		// Pt[̏o͐
		float OutCount() const { return this->_outCount; }
		void OutCount(float value) { this->_outCount = value; }

		// X^[gt[
		int StartFrame() const { return this->_startFrame; }
		void StartFrame(int value) { this->_startFrame = value; }

		// ˊJnE~
		ParticlesPlay::Type Play() const  { return this->_play; }
		void Play(ParticlesPlay::Type value) { this->_play = value; }

		// p[eBN̔zuʒu
		ParticlesDrawPriority::Type Priority() const { return this->_priority; }
		void Priority(ParticlesDrawPriority::Type value) { this->_priority = value; }

		// ẽXP[p邩ۂ
		ParticlesSuccession::Type SuccessionScale() const { return this->_successionScale; }
		void SuccessionScale(ParticlesSuccession::Type value) { this->_successionScale = value; }

		// ẻ]p邩ۂ
		ParticlesRot::Type SuccessionRot() const  { return this->_successionRot; }
		void SuccessionRot(ParticlesRot::Type value) { this->_successionRot = value; }

		// o̓^Cv
		ParticlesOutType::Type OutType() const { return this->_outType; }
		void OutType(ParticlesOutType::Type value) { this->_outType = value; }

		// o͕yуp[
		const glbVector2 *OutVector() const { return &this->_outVector; }
		void OutVector(const glbVector2 *pVector) { this->_outVector = *pVector; }

		// o͔͈(p[XP[)
		float OutScaleLenge() const { return this->_outScaleLenge; }
		void OutScaleLenge( float value) { this->_outScaleLenge = value; }

		// o͔͈(px)
		float OutLenge() const { return this->_outLenge; }
		void OutLenge(float value) { this->_outLenge = value; }

		// eyуp[
		const glbVector2 *InfluenceVector() const { return &this->_influenceVector; }
		void InfluenceVector(const glbVector2 *pVector) { this->_influenceVector = *pVector; }

		// e͈(p[XP[)
		float InfluenceScaleLenge() const { return this->_influenceScaleLenge; }
		void InfluenceScaleLenge(float value) { this->_influenceScaleLenge = value; }

		// e͈
		float InfluenceLenge() const { return this->_influenceLenge; }
		void InfluenceLenge(float value) { this->_influenceLenge = value; }

		seStateParticles();
		seStateParticles( seStateParticles *pMst );
		virtual ~seStateParticles(){}

		virtual void Set(IseStateType *state);
		virtual void Add(IseStateType *pState);
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate){}
		virtual void Load(IseStateInput *pInput);
		virtual IseStateType *Clone();
	};



	// p[eBNIuWFNgXe[^X
	// IuWFNgł̂ݎgp
	class seStateParticlesInfo : public IseStateType
	{
	public:
		// Aj[VtXe[^X
		template<class T>
		class State
 		{
		private:
			T _start;	// Jn
			T _end;		// I
			est::vector<FePointInfo*> _anim;	// Aj[V

		public:
			const T &Start() const { return this->_start; }
			void Start(const T &value) { this->_start = value; }

			const T &End() const { return this->_end; }
			void End(const T &value) { this->_end = value; }

			// Aj[VԎ擾
			const est::vector<FePointInfo*> *Anim() const { return &this->_anim; }


			// Aj[V[h
			void LoadAnim(IseStateInput *pInput)
			{
				glb::DeleteVector(this->_anim);
				int iCount = pInput->ReadInt();
				for (int i = 0; i < iCount; i++)
				{
					FePointInfo *pi = evc_new FePointInfo();
					pi->Load(pInput);
					this->_anim.push_back(pi);
				}
			}

			// RXgN^
			State()
			{
				FePointInfo *p = evc_new FePointInfo(1.0f,1.0f);
				p->CreateAnimFunc(FeAnim::Liner);
				this->_anim.push_back(evc_new FePointInfo(0.0f,0.0f));
				this->_anim.push_back(p);
			}

			virtual ~State()
			{
				glb::DeleteVector(this->_anim);
			}
		};

	private:
		// p[eBNPɑ΂Aj[V
		State<glbColor> _color;
		State<float> _rot;
		float _rotLenge; 	// px
		State<glbVector2> _scale;
		float _scaleLenge; // XP[
		State<glbVector2> _center; 
		int _lifeMin; 	// ŒZ
		int _lifeMax;	// Œ
		int _maxNum;	// ő`搔

	public:
		// p[eBNPɑ΂Aj[V
		const State<glbColor> *Color() const { return &this->_color; }

		const State<float> *Rot() const { return &this->_rot; }

		// px
		float RotLenge() const { return this->_rotLenge; }

		const State<glbVector2> *Scale() const { return &this->_scale;}

		// XP[
		float ScaleLenge() const { return this->_scaleLenge; } 

		const State<glbVector2> *Center() const { return &this->_center; }

		// ŒZ
		int LifeMin() const { return this->_lifeMin; }	

		// Œ
		int LifeMax() const { return this->_lifeMax; }	

		// ő`搔
		int MaxNum() const { return this->_maxNum; }

		seStateParticlesInfo();
		seStateParticlesInfo(seStateParticlesInfo *pMst);
		virtual ~seStateParticlesInfo(){}

		// IuWFNgp̏ꍇ͕Ȃ
		virtual IseStateType *Clone() { return null; }
		virtual void Set(IseStateType *pState){}
		virtual void Add(IseStateType *pState){}
		virtual void Anim(IseStateType *pNext, IseStateType *pBefore, float fRate){}
		virtual void Load(IseStateInput *pInput);
	};

}
#endif //SESTATETYPEEX_H

