/**
 * @file seoColorSprite.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEOCOLORSPRITE_H
#define SEOCOLORSPRITE_H
#pragma once
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "evc/common/seDefine.h"
#include "evc/seObject/seObjectWork.h"

using namespace glb;
namespace glb
{
	class IGLMatrix;
}

namespace evc
{
	class seoColorSprite;
	class seElem;
	class seObject;
	class IseStateInput;

	// J[`掞ɕKvȃ[N
	class seoColorSpriteWork : public seObjectWork
	{
	private:
		seoColorSprite *pObject;
		seElem *pElem;

		// IuWFNg擾
	public:
		virtual seObject *Object();

		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();

		// RXgN^
		seoColorSpriteWork( seElem *pInElem, seoColorSprite *pInObjct );

		// `	
		virtual void Draw();

		// XV
		virtual void Update(float fAddTime);
	};

	// J[`
	class seoColorSprite : public seObject
	{
	private:
		siObjectColorSprite *pColorSprite;
		glbVector2 sSize;
		glbColor sColor;

	public:
		seoColorSprite();
		virtual ~seoColorSprite();

		// TCY
		const glbVector2 *Size() const	{ return &this->sSize; }
		void Size( const glbVector2 *value);

		// J[
		const glbColor *Color() const	{ return &this->sColor; }
		void Color( const glbColor *value)	{ this->sColor = *value; }

		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const { return emObject::Color; }


		// 
		virtual void Init(int iInObjectID, seSceneManager *pInScene);


		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *pElem);

		// IuWFNgɐFĕ\
		void Draw(int iElemID, const IGLMatrix *m, const glbColor *sMulColor);

		virtual void Load(IseStateInput *pInput, seSceneManager *pManager);

	};
}
#endif //SEOCOLORSPRITE_H

