#include "glbPch.h"
#include "glb/IGLMatrix.h"
#include "seFontChar.h"
#include "seoFont.h"
#include "evc/scene/seSceneManager.h"
#include "evc/scene/seOption.h"
#include "evc/scene/seAnimManager.h"
#include "evc/scene/seElemManager.h"
#include "evc/IO/siObjectFont.h"


using namespace glb;
namespace evc
{

	seFontCharExSpeed::seFontCharExSpeed(float fInSpeed)
		: fSpeed( fInSpeed )
	{
	}

	void seFontCharExSpeed::UpdateInfo(seFontDrawInfo *pDrawInfo)
	{
		// 1\̂ɂ鎞ԂXV
		pDrawInfo->Speed( pDrawInfo->SceneManager()->Option()->FrameTime() / this->fSpeed );
	}

	seFontCharExWait::seFontCharExWait(float fInWait)
		: fWait( fInWait )
	{
	}

	void seFontCharExWait::UpdateInfo(seFontDrawInfo *pDrawInfo)
	{
		// WaitԂݒ
		pDrawInfo->Wait( pDrawInfo->SceneManager()->Option()->FrameTime() * this->fWait );
	}

	seFontCharExAnim::seFontCharExAnim(const glbString *strInAnim)
	{
		this->strAnim = *strInAnim;
	}

	void seFontCharExAnim::UpdateInfo(seFontDrawInfo *pDrawInfo)
	{
		seSceneManager *sm = pDrawInfo->SceneManager();
		int iAnimID = sm->AnimManager()->FindID(&this->strAnim);
		sm->ElemManager()->SetAnim(iAnimID);
	}

	siObjectFontChar *seFontChar::FontChar()
	{
		return this->pFontChar;
	}


	void seFontChar::AddData(IseFontCharEx *pData)
	{
		this->pDataEx.push_back(pData);
	}

	void seFontChar::Draw(int iElemID, const IGLMatrix *mParent, const glbColor *sBaseColor)
	{
		glbColor c = *sBaseColor;
		c.Mul( &this->sColor );
		this->pFontChar->Draw(iElemID, mParent, &c);
	}

	void seFontChar::UpdateInfo(seFontDrawInfo *pDrawInfo)
	{
		est::vector<IseFontCharEx*>::iterator it = this->pDataEx.begin();
		for( ; it != this->pDataEx.end(); it++)
		{
			(*it)->UpdateInfo( pDrawInfo );
		}
	}

	seFontChar::seFontChar(siObjectFontChar *pFontChar, const glbColor *pColor)
	{
		this->pFontChar = pFontChar;
		this->sColor = *pColor;
	}


	seFontChar::~seFontChar()
	{
		glb::DeleteVector( this->pDataEx );
	}

}
