/**
 * @file seFontChar.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEFONTCHAR_H
#define SEFONTCHAR_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "glb/glbColor.h"
#include "glb/IGLMatrix.h"

using namespace glb;
namespace evc
{
	class seFontDrawInfo;
	class siObjectFontChar;

	// gf[^
	class IseFontCharEx
	{
	public:
		virtual void UpdateInfo(seFontDrawInfo*) = 0;
	};

	// Xs[hύX
	class seFontCharExSpeed : public IseFontCharEx
	{
	private:
		float fSpeed;
	public:
		seFontCharExSpeed(float fInSpeed);

		// XV
		void UpdateInfo(seFontDrawInfo *pDrawInfo);
	};

	// WaitύX
	class seFontCharExWait : public IseFontCharEx
	{
	private:
		float fWait;
	public:
		seFontCharExWait(float fInWait);

		void UpdateInfo(seFontDrawInfo *pDrawInfo);
	};

	// Aj[VĂяo
	class seFontCharExAnim : public IseFontCharEx
	{
	private:
		glbString strAnim;
	public:
		seFontCharExAnim(const glbString *strInAnim);
		virtual ~seFontCharExAnim(){}

		void UpdateInfo(seFontDrawInfo *pDrawInfo);
	};



	// PǗ
	class seFontChar
	{
	private:
		glbColor sColor; // J[
		siObjectFontChar *pFontChar; // 
		est::vector<IseFontCharEx*> pDataEx; // gf[^

	public:
		// RXgN^
		seFontChar(siObjectFontChar *pFontChar, const glbColor *sColor);
		virtual ~seFontChar();

		// 擾
		siObjectFontChar *FontChar();
		// J[擾
		const glbColor *Color() const { return &this->sColor; }

		// gf[^o^
		void AddData(IseFontCharEx *pData);


		// `
		void Draw(int iElemID, const IGLMatrix *mParent, const glbColor *sBaseColor);

		// gf[^ɂԍXV
		void UpdateInfo(seFontDrawInfo *pDrawInfo);

	};
}
#endif //SEFONTCHAR_H

