#include "glbPch.h"
#include "glb/glbDefine.h"
#include "evc/common/seMatrixWork.h"
#include "evc/IO/siObjectFont.h"
#include "evc/seObject/ObjectParts/seoFont/seoFont.h"
#include "seFontLine.h"
#include "seFontChar.h"


using namespace glb;
namespace evc
{

	seFontLine::seFontLine(float fHeight)
	{
		// Œፂݒ
		this->sSize = glbVector2(0.0f, fHeight);
	}

	seFontLine::~seFontLine()
	{
		glb::DeleteVector( this->lisFontChar );
	}


	seFontChar *seFontLine::GetLastChar()
	{
		if (this->lisFontChar.size() <= 0) return null;
		return this->lisFontChar[this->lisFontChar.size() - 1];
	}


	void seFontLine::Apply()
	{
		// TCY̌vZ
		VECTOR_FOR_EACH(seFontChar *,this->lisFontChar, 
		{
			const glbVector2 *sCharSize = (*it)->FontChar()->Size();
			this->sSize.X += sCharSize->X;
			this->sSize.Y = glb::MaxValue(this->sSize.Y, sCharSize->Y);
		});
	}


	void seFontLine::Add(seFontChar *pChar)
	{
		this->lisFontChar.push_back(pChar);
	}

	bool seFontLine::Draw(int iElemID,
						  float fHeight, 
						  const IGLMatrix *mParent, 
						  const glbColor *sColor, 
						  int iDrawNum, 
						  int &iNowCount)
	{
		// \ʒu
		float fUnderY = fHeight + this->Size()->Y;
	
		bool bRet = true;
		int iLocalCount = iNowCount;

		seUseWorkMatrix gw;
		IGLMatrix *mPos = gw.GetMatrix();
		float fPosX = 0.0f;

		VECTOR_FOR_EACH( seFontChar *,this->lisFontChar, 
		{
			const glbVector2 *sCharSize = (*it)->FontChar()->Size();
			mPos->SetPos( fPosX, fUnderY - static_cast<float>(sCharSize->Y));
			mPos->MulR(mParent);
			(*it)->Draw(iElemID, mPos, sColor);
			fPosX += static_cast<float>(sCharSize->X);
			iLocalCount ++;
			if (iDrawNum == seoFont::ALL_TEXT) continue;
			if (iLocalCount >= iDrawNum)
			{
				bRet = false;
				break;
			}
		});

		iNowCount = iLocalCount;
		return bRet;
	}
}
