#include "glbPch.h"
#include "glb/glbDebug.h"
#include "seFontPage.h"
#include "seFontLine.h"

using namespace glb;
namespace evc
{
	seFontPage::seFontPage()
	{
	}
	
	seFontPage::~seFontPage()
	{
		glb::DeleteVector( this->lisLine );
	}


	seFontLine *seFontPage::GetLastLine()
	{
		GLB_ASSERT(this->lisLine.size() > 0);
		return this->lisLine[ this->lisLine.size() - 1];
	}

	void seFontPage::Add(seFontLine *pLine)
	{
		this->lisLine.push_back(pLine);
	}

	seFontChar *seFontPage::GetCharInfo(int iTextNum)
	{
		est::vector<seFontLine*>::iterator it = this->lisLine.begin();
		for (; it != this->lisLine.end(); it++)
		{
			const est::vector<seFontChar*> &chars = *(*it)->Char();
			int iCharCount = chars.size();
			if (iTextNum >= iCharCount)
			{
				iTextNum -= iCharCount;
				continue;
			}
			return chars[iTextNum];
		}
		return null;
	}

	void seFontPage::Clear()
	{
		this->lisLine.clear();
	}

	void seFontPage::UpdateSize()
	{
		// TCYĐݒ
		this->sSize = glbVector2::Zero;

		// s̃TCYXV
		VECTOR_FOR_EACH( seFontLine *, this->lisLine, 
		{
			(*it)->Apply();
			const glbVector2 *ps = (*it)->Size();
			this->sSize.X = glb::MaxValue(this->sSize.X, ps->X);
			this->sSize.Y += ps->Y;
		});
	}


	void seFontPage::Draw( int iElemID, 
						   const IGLMatrix *mParent, 
						   const glbColor *sColor, 
						   int iDrawNum)
	{
		// SC`
		float fHeight = 0.0f;
		int iNowCount = 0;
		VECTOR_FOR_EACH( seFontLine *, this->lisLine, 
		{
			if (!(*it)->Draw( iElemID, fHeight, mParent, sColor, iDrawNum, iNowCount) )
				break;
			fHeight += static_cast<float>((*it)->Size()->Y);
		});
	}
}
