#include "glbPch.h"
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "glb/IGLMatrix.h"
#include "evc/common/seMatrixWork.h"
#include "evc/file/IseStateIO.h"
#include "evc/IO/siObject.h"
#include "evc/IO/siObjectFont.h"
#include "evc/IO/siIOManager.h"
#include "evc/scene/seRootScene.h"
#include "evc/scene/seSceneManager.h"
#include "evc/scene/seOption.h"
#include "evc/seObject/seObject.h"
#include "evc/seObject/ObjectParts/seoFont/seoFont.h"
#include "evc/seElem/seElem.h"
#include "evc/seElem/seStateType.h"
#include "evc/seElem/seStateTypeEx.h"
#include "evc/seElem/seElemState/seElemState.h"
#include "evc/seElem/seElemState/seStateData.h"
#include "seFontData.h"
#include "seFontLine.h"
#include "seFontChar.h"
#include "seoFont.h"


using namespace glb;
namespace evc
{
	void seFontDrawInfo::SceneManager( seSceneManager *value)
	{
		this->pSceneManager = value;
		// V[ɍ킹ăXs[hXV
		this->fSpeed = (this->pSceneManager != null) ? 
				this->pSceneManager->Option()->FrameTime() : 0.0f;
	}


	void seFontDrawInfo::Clear()
	{
		this->iDrawNum = 0;
		this->fSpeed = (this->pSceneManager != null) ? 
				this->pSceneManager->Option()->FrameTime() : 0.0f;

		this->fWait = 0.0f;
		this->fTime = 0.0f;
	}

	void seFontDrawInfo::NextPage()
	{
		this->iDrawNum = 0;
	}

	seFontDrawInfo::seFontDrawInfo()
		: iDrawNum( 0 )
		, iPage( 0 )
		, fSpeed( 0.0f )
		, fWait( 0.0f )
		, fTime( 0.0f )
		, pSceneManager( null )
	{
		this->Clear();
	}


	// seoWorkFont
	seoWorkFont::seoWorkFont(seElem *pInElem, seoFont *pInObject)
		: iLastPage( -1 ) // Ōɕ\y[W
		, pFontDrawInfo( null )
		, pElem( pInElem )
		, pObject( pInObject )
		, pText( null )
	{
		this->pFontDrawInfo = evc_new seFontDrawInfo();
		this->pFontDrawInfo->SceneManager(pInObject->Scene());
	
		this->pText = static_cast<seStateTextControl*>(seStateUtil::CreateStateType(emElemState::TextControl));
	
		// Xe[^X̊gf[^NA
		this->pElem->State()->ClearStateData();
		this->pElem->State()->LinkStateData(emElemState::TextControl, this->pText);
	}

	seoWorkFont::~seoWorkFont()
	{
		GLB_SAFE_DELETE( this->pFontDrawInfo );
		GLB_SAFE_DELETE( this->pText );
	}

	seObject *seoWorkFont::Object()
	{ 
		return static_cast<seObject *>(this->pObject);
	}

	const glbVector2 *seoWorkFont::GetSize()
	{
		return this->pObject->FontData()->Size();
	}

	void seoWorkFont::Draw()
	{
		this->pObject->Draw(this->pElem->ElemID(), 
							this->pElem->NowMatrix(),
							this->pElem->State()->NowColor(),
							this->pFontDrawInfo->Page(),
							this->pFontDrawInfo->DrawNum());
	}

	void seoWorkFont::Reset()
	{
		// ZbgXs[h͂ǂ邩BB
		this->iLastPage = -1;
		pFontDrawInfo->Clear();
	}

	void seoWorkFont::Update(float fAddTime)
	{
		seStateData *pData = this->pElem->State()->GetData( emElemState::TextControl );
		seFontData *pFontData = this->pObject->FontData();
	
		// y[WVȂȂ
//		if (this->iLastPage != this->pText->Page())
		if ( (pData != null) && pData->MoveKey() )
		{
			this->iLastPage = this->pText->Page();
			pFontDrawInfo->NextPage();
	
			// y[W͍ŏ̂Pꕶ`FbN
			seFontChar *pFirstCharInfo = pFontData->GetCharInfo(this->iLastPage, 0);
			if (pFirstCharInfo == 0)
				return;
			// ԍXV
			pFirstCharInfo->UpdateInfo(pFontDrawInfo);
		}
	
		// ҏW͑SẴeLXg`
		if (seRootScene::Instance()->EditMode())
		{
			pFontDrawInfo->DrawNum(seoFont::ALL_TEXT);
			return;
		}
	
		// XV\莞Ԃǉ
		pFontDrawInfo->Time(pFontDrawInfo->Time() + fAddTime);
		// ǉoߎԂ\Zo
		while (true)
		{
			// ҋ@Ȃҋ@Ԃ
			if (pFontDrawInfo->Wait() > 0.0f)
			{
				// ҋ@Ԃ̕Ȃ炱ȏ\Ȃ
				if (pFontDrawInfo->Wait() >= pFontDrawInfo->Time())
				{
					pFontDrawInfo->Wait(pFontDrawInfo->Wait() - pFontDrawInfo->Time());
					pFontDrawInfo->Time(0.0f);
					break;
				}
				// ҋ@Ԃ̕ZȂҋ@I
				else
				{
					pFontDrawInfo->Time(pFontDrawInfo->Time() - pFontDrawInfo->Wait());
					pFontDrawInfo->Wait(0.0f);
				}
			}
	
			// P\ɖȂȂI
			if (pFontDrawInfo->Time() < pFontDrawInfo->Speed())
				break;
	
			// PAԂĎ
			pFontDrawInfo->Time(pFontDrawInfo->Time() - pFontDrawInfo->Speed());
	
			pFontDrawInfo->DrawNum( pFontDrawInfo->DrawNum() + 1 );
			// ̕擾
			seFontChar *pCharInfo = pFontData->GetCharInfo(this->iLastPage, pFontDrawInfo->DrawNum());
			// f[^ȂI
			if (pCharInfo == 0)
				break;
	
			// ԍXV
			pCharInfo->UpdateInfo(pFontDrawInfo);
		}
	
	}


	seoFont::seoFont()
		: pBgSprite( null )
		, sColor( &glbColor::White )
		, pFontData( null )
	{
		this->pFontData = evc_new seFontData(this);
	}

	seoFont::~seoFont()
	{
		GLB_SAFE_DELETE( this->pFontData );
		GLB_SAFE_DELETE( this->pBgSprite );
	}

	void seoFont::Init(int iInObjectID, seSceneManager *pInScene)
	{
		seObject::Init(iInObjectID, pInScene);
		// VID蓖Ăꂽ̂ōȂ
		if (this->pBgSprite != null)
		{
			delete this->pBgSprite;
		}
		this->pBgSprite = seRootScene::Instance()->IOManager()->CreateColorSprite(this->ObjectID());
		this->pBgSprite->UpdateSize( &glbVector2::One );
	}

	seObjectWork *seoFont::CreateDrawWork(seElem *pElem)
	{
		return evc_new seoWorkFont(pElem, this);
	}

	void seoFont::Draw( int iElemID, 
						const IGLMatrix *mParent, 
						const glbColor *sMulColor, 
						int iPage, 
						int iDrawNum)
	{
		seFontData *pFondData = this->FontData();
		if (pFondData != null)
		{
			glbColor sBackGroundColor = *sMulColor;
			sBackGroundColor.Mul(this->Color());
	
				// wi`
				// tHg`
				// Ƃ肠S
			seUseWorkMatrix gw;

			const glbVector2 *sSize = pFondData->Size();
			IGLMatrix *m = gw.GetMatrix();
			m->SetScale(sSize);
			m->MulR(mParent);
			this->pBgSprite->Draw( iElemID, m, &sBackGroundColor );
			pFondData->BaseColor( sMulColor );
			pFondData->Draw(iElemID, mParent, sMulColor, iPage, iDrawNum);
		}
	}

	void seoFont::Load(IseStateInput *pInput, seSceneManager *pManager)
	{
		seObject::Load(pInput, pManager);
		this->sColor = seIOUtil::ReadColor( pInput );
		this->pFontData->Load(pInput);
	}

}
