/**
 * @file seoFont.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEOFONT_H
#define SEOFONT_H
#pragma once
#include "evc/common/seDefine.h"
#include "evc/seObject/seObject.h"
#include "evc/seObject/seObjectWork.h"

using namespace glb;
namespace glb
{
	class IGLMatrix;
	struct glbVector;
}
namespace evc
{
	class siObjectColorSprite;
	class seSceneManager;
	class seElem;
	class seFontData;
	class seoFont;
	class seStateTextControl;
	class IseStateInput;

	// tHg`p[N
	class seFontDrawInfo
	{
	private:
		int iDrawNum; // ꂩ\镶(_؎̂)
		int iPage;
		float fSpeed; // `摬x
		float fWait; // EGCg
		float fTime; // XV\莞
		seSceneManager *pSceneManager;

	public:
		int DrawNum() const		{ return this->iDrawNum; }
		void DrawNum(int value) { this->iDrawNum = value; }

		int Page() const	{ return this->iPage; }
		void Page(int value){ this->iPage = value; }

		float Speed() const		{ return this->fSpeed; }
		void Speed(float value)	{ this->fSpeed = value; }

		float Wait() const		{ return this->fWait; }
		void Wait(float value)	{ this->fWait = value; }

		float Time() const		{ return this->fTime; }
		void Time(float value)	{ this->fTime = value; }

		// `ΏۃV[
		seSceneManager *SceneManager() const { return this->pSceneManager; }
		void SceneManager(seSceneManager *value);


		void Clear();

		// ̃y[WɂƂ̏
		void NextPage();

		seFontDrawInfo();
	};


	// `Ǘ
	class seoWorkFont : public seObjectWork
	{
	private:
		int iLastPage; //  = -1; // Ōɕ\y[W

		seFontDrawInfo *pFontDrawInfo;
		seElem *pElem;
		seoFont *pObject;

		// gXe[^X
		seStateTextControl *pText;

	public:
		virtual seObject *Object();

		// RXgN^
		seoWorkFont(seElem *pInElem, seoFont *pInObject);
		virtual ~seoWorkFont();

		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();

		// `	
		virtual void Draw();

		virtual void Reset();

		// XV
		virtual void Update(float fAddTime);
	};




	// J[`
	class seoFont : public seObject
	{
	public:
		static const int ALL_TEXT = -1; // SĂ̕\


	private:
		siObjectColorSprite *pBgSprite;
		glbColor sColor;
		seFontData *pFontData;

	public:
		// wiXvCg擾
		siObjectColorSprite *BgSprite() { return this->pBgSprite; }

		const glbColor *Color() const		{ return &this->sColor; }
		void Color( const glbColor *value )	{ this->sColor = *value; }

		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const { return emObject::Font; }

		// IuWFNgǗĂtHg擾
		seFontData *FontData()				{ return this->pFontData; }

		// RXgN^
		seoFont();

		// 
		virtual void Init(int iInObjectID, seSceneManager *pInScene);

		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *pElem);


		// \
		void Draw( int iElemID, 
				   const IGLMatrix *mParent, 
				   const glbColor *sMulColor, 
				   int iPage, 
				   int iDrawNum );


		virtual void Load(IseStateInput *pInput, seSceneManager *pManager);

		// 
		virtual ~seoFont();
	};


}
#endif //SEOFONT_H

