/**
 * @file seoFrame.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEOFRAME_H
#define SEOFRAME_H
#pragma once
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "evc/common/seDefine.h"
#include "evc/seObject/seObject.h"
#include "evc/seObject/seObjectWork.h"


using namespace glb;
namespace glb
{
	class IGLMatrix;
}
namespace evc
{
	class seoFrame;
	class seElem;
	class seStateFloat2;
	class siObjectTextureSprite;


	// eNX`[XvCg`掞ɕKvȃ[N
	class seoFrameWork : public seObjectWork
	{
	private:
		seoFrame *pObject; // `IuWFNg
		seElem *pElem; // Gg
		seStateFloat2 *pUV; // UV

	public:
		virtual seObject *Object();

		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();

		// RXgN^
		seoFrameWork(seElem *pInElem, seoFrame *pInObjct);
		virtual ~seoFrameWork();

		// `	
		virtual void Draw();

		// XV
		virtual void Update(float fAddTime);
	};


	// eNX``
	class seoFrame : public seObject
	{
		// Pp[c`
	private:
		class FrameParts
		{
		private:
			bool bVisible;
			siObjectTextureSprite *pSprite;

		public:
			bool Visible() const	 { return this->bVisible; }
			void Visible(bool value) { this->bVisible = value; }

			// `XvCg
			siObjectTextureSprite *Sprite()			  { return this->pSprite; }
			void Sprite(siObjectTextureSprite *value) { this->pSprite = value; }

			// RXgN^
			FrameParts();

			// f[^쐬
			void CreateSprite( int iObjectID );
			// f[^NA
			void Clear();
		};


		// p[c͍őX
	private:
		FrameParts apImages[9];

		// XVtO
		bool bUpdateSprite;
		glbVector2 sSize;
		glbVector2 sUV;
		glbVector2 sExpansionStart;
		glbVector2 sExpansionEnd;
		int iResourceID;
		siResourceTexture *pResourceTexture;
		glbColor sColor;

	public:
		// TCY
		const glbVector2 *Size() const		{ return &this->sSize; }
		void Size( const glbVector2 *value);

		// UV
		const glbVector2 *UV() const	{ return &this->sUV; }
		void UV(const glbVector2 *value);

		// Lg̍̈ʒu
		const glbVector2 *ExpendStart() const	 { return &this->sExpansionStart; }
		void ExpendStart(const glbVector2 *value);

		// Lg̉Ëʒu
		const glbVector2 *ExpendEnd() const		{ return &this->sExpansionEnd; }
		void ExpendEnd(const glbVector2 *value);

		// RXgN^
		seoFrame();
		virtual ~seoFrame();

		// \[XID
		int ResourceID() const { return this->iResourceID; }
		void ResourceID(int value);

		// eNX`\[X擾
		siResourceTexture *ResourceTexture();

		// J[
		const glbColor *Color() const		{ return &this->sColor; }
		void Color(const glbColor *value)	{ this->sColor = *value; }


		// 
		virtual void Init(int iInObjectID, seSceneManager *pInScene);

		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const { return emObject::Frame; }



		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *pElem);


		void Draw( int iElemID, 
				   const IGLMatrix *mParent, 
				   const glbColor *sMulColor, 
				   const glbVector2 *sMstScale, 
				   const glbVector2 *sUV);


		virtual void Load( IseStateInput *pInput, seSceneManager *pManager );

	private:
		// f[^XV
		void Apply();

	};
}
#endif //SEOFRAME_H

