/**
 * @file seoGrid.h
 * @brief 
 *
 * @author seri
 */
#ifndef INCLUDE_SEOGRID_H
#define INCLUDE_SEOGRID_H
#pragma once
#include "glb/IGLMatrix.h"
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "evc/common/seDefine.h"
#include "evc/seObject/seObjectWork.h"
#include "evc/seObject/seObject.h"

using namespace glb;

namespace glb
{
	class IGLMatrix;
}

namespace evc
{
	class siObjectMesh;
	class IseStateInput;
	class siResourceTexture;
	class siObjectTextureSprite;
	class siObjectMesh;
	class seoTextureSprite;
	class seElem;
	class seSceneManager;
	class seStateSwitchInt1;
	class seStateTextureControl;
	class seStateLoop;
	class seStateFloat2;
	class seStateGridPoint;
	class seoGrid;


	class seoGridWork : public seObjectWork
	{
	private:
		seoGrid *_obj; // `IuWFNg
		seElem *_elem; // Gg

		seStateSwitchInt1 *_texture;
		seStateTextureControl *_textureControl;
		seStateFloat2 * _uv;
		est::vector<seStateGridPoint *> _gridPoint;
		IGLMatrix *_mUV;

		// `Tu[`
		// ĐGWȊOŗʂDrawƕĂ܂B
		void DrawSub(const IGLMatrix *mBase, const glbColor *color);

	public:
		static const float PowerScale;

		virtual seObject *Object();

		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();

		// RXgN^
		seoGridWork(seElem *elem, seoGrid *obj);
		virtual ~seoGridWork();

		// [ÑZbg
		virtual void Reset();

		// `
		virtual void Draw();

		// XV
		virtual void Update(float fAddTime);
	};




	class seoGrid : public seObject
	{
	private:
		siObjectMesh *_pMesh;
		glbVector2 _uv;
		glbVector2I _partitions;
		glbColor _color;
		glbVector2 _size;
		glbVector2 _uvRate;

		est::vector<short> _triIndex; // gCAOindex
		int iResourceID;	// \[XID

		siResourceTexture *_pTexture;
		bool _bUpdateImage;

	public:
		siObjectMesh *Mesh() { return this->_pMesh; }

		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const;

		const glbVector2 *UV() const		{ return &this->_uv; }
		void UV(const glbVector2 *value)	{ this->_uv = *value; }

		const glbVector2I *Partitions() const		{ return &this->_partitions; }
		void Partitions(const glbVector2I *value)	{ this->_partitions = *value; }

		const glbColor *Color() const		{ return &this->_color; }
		void Color(const glbColor *value)	{ this->_color = *value; }

		const glbVector2 *Size() const		{ return &this->_size; }
		void Size(const glbVector2 *value)	{ this->_size = *value; }

		const glbVector2 *UVRate() const	{ return &this->_uvRate; }
		void UVRate(const glbVector2 *value){ this->_uvRate = *value; }

		int ResourceID() const		{ return this->iResourceID; }
		void ResourceID(int value);

		// eNX`\[X擾
		siResourceTexture *ResourceTexture();

		// RXgN^
		seoGrid();
		virtual ~seoGrid();

		// 
		virtual void Init(int objID, seSceneManager *scene);

		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *elem);

		void Draw(int elemID, const IGLMatrix *m,
				const glbColor *color, const IGLMatrix *mUV);

		virtual void Load(IseStateInput *input, seSceneManager *manager);


	private:
		// ResourceIDɂ킹ăeNX`̍XV
		bool UpdateImage(int elemID);

		// Op`indexXg쐬
		void ResetTriIndex();

		// UVXg쐬
		void ResetUV(int elemID);

		// obt@č쐬
		void UpdateMesh();
	};
}
#endif // INCLUDE_SEOGRID_H
