#include "glbPch.h"
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "glb/IGLMatrix.h"
#include "evc/common/seMatrixWork.h"
#include "evc/file/IseStateIO.h"
#include "evc/IO/siObject.h"
#include "evc/IO/siObjectFont.h"
#include "evc/IO/siIOManager.h"
#include "evc/scene/seRootScene.h"
#include "evc/scene/seSceneManager.h"
#include "evc/scene/seOption.h"
#include "evc/scene/seResourceManager.h"
#include "evc/seObject/seObject.h"
#include "evc/seObject/ObjectParts/seoFont/seoFont.h"
#include "evc/seElem/seElem.h"
#include "evc/seElem/seStateType.h"
#include "evc/seElem/seStateTypeEx.h"
#include "evc/seElem/seElemState/seElemState.h"
#include "./seoMeshChild.h"


using namespace glb;
namespace evc
{
	// ===================================================
	// seoMeshChildWork
	// 

	seObject *seoMeshChildWork::Object()
	{
		return static_cast<seObject*>( this->pObj );
	}


	const glbVector2 *seoMeshChildWork::GetSize()
	{
		return this->pObj->Size();
	}

	seoMeshChildWork::seoMeshChildWork(seElem *elem, seoMeshChild *child)
		: pElem( elem )
		, pObj( child )
	{
		// Xe[^X̊gf[^NA
		this->pElem->State()->ClearStateData();
	}

	void seoMeshChildWork::Reset(){}
	void seoMeshChildWork::Draw(){}
	void seoMeshChildWork::Update(float fAddTime){}


	// ===================================================
	// seoMeshChild
	// 

	void seoMeshChild::Link(seoMeshChild *child)
	{
		this->stvChild.push_back( child );
		child->Parent( this );
		child->Mesh( this->Mesh() );
	}

	seoMeshChild::seoMeshChild()
		: iLabel( -1 )
		, pMesh( null )
		, pParent( null )
		, sSize( 0.0f, 0.0f )
		, sPos( 0.0f, 0.0f )
	{
	}

	void seoMeshChild::Init(int objID, seSceneManager *scene)
	{
		seObject::Init(objID, scene);
	}

	seObjectWork *seoMeshChild::CreateDrawWork(seElem *elem)
	{
		return evc_new seoMeshChildWork(elem, this);
	}

	void seoMeshChild::Draw(int iElemID, const IGLMatrix *m, const glbColor *sMulColor)
	{
	}

	void seoMeshChild::Load(IseStateInput *input, seSceneManager *scene)
	{
		seObject::Load(input, scene);

		this->iLabel = input->ReadInt();
		this->sSize = seIOUtil::ReadVector2(input);
		this->sPos = seIOUtil::ReadVector2(input);
	}
}

