#ifndef INCLUDE_SEOMESHCHILD_H
#define INCLUDE_SEOMESHCHILD_H
#pragma once
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "evc/common/seDefine.h"
#include "evc/seObject/seObject.h"
#include "evc/seObject/seObjectWork.h"

using namespace glb;

namespace glb
{
	class IGLMatrix;
}

namespace evc
{
		// 
	class seSceneManager;
	class seElem;
	class IseStateInput;
	class seSceneManager;
	class seoMeshChild;
	class seoMesh;
	

	// bV`掞ɕKvȃ[N
	class seoMeshChildWork : public seObjectWork
	{
	private:
		seElem *pElem;
		seoMeshChild *pObj;
		
	public:
		seElem *Elem() const { return this->pElem; }

		virtual seObject *Object();

		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();

		// RXgN^
		seoMeshChildWork(seElem *elem, seoMeshChild *child);

		// [ÑZbg
		virtual void Reset();
		// `	
		virtual void Draw();
		// XV
		virtual void Update(float fAddTime);
	};




	class seoMeshChild : public seObject
	{
	private:
		int iLabel;
		seoMesh *pMesh;
		seoMeshChild *pParent;
		est::vector<seoMeshChild*> stvChild;
		glbVector2 sSize;
		glbVector2 sPos;
	
	public:
		// x
		int Label() const { return this->iLabel; }

		// 匳̃bV
		seoMesh *Mesh() const { return this->pMesh; }
		void Mesh(seoMesh *value) { this->pMesh = value; }

		// ̐e
		seoMeshChild *Parent() const		{ return this->pParent; }
		void Parent(seoMeshChild *value)	{ this->pParent = value; }

		// qXg
		const est::vector<seoMeshChild*> &Child() const { return this->stvChild; }

		// TCY
		const glbVector2 *Size() const		{ return &this->sSize; }

		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const { return emObject::MeshChild; }


		// qǉ
		void Link(seoMeshChild *child);

		// RXgN^
		seoMeshChild();

		// 
		virtual void Init(int objID, seSceneManager *scene);

		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *elem);


		void Draw(int iElemID, const IGLMatrix *m, const glbColor *sMulColor);

		virtual void Load(IseStateInput *input, seSceneManager *scene);
	};
}
#endif // INCLUDE_SEOMESHCHILD_H
