#pragma once
#ifndef INCLUDE_SEOPARTICLES_H
#define INCLUDE_SEOPARTICLES_H
#include "glb/IGLMatrix.h"
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "evc/common/seDefine.h"
#include "evc/seObject/seObjectWork.h"
#include "evc/seObject/seObject.h"

using namespace glb;

namespace glb
{
	class IGLMatrix;
}

namespace evc
{
	class siObjectMesh;
	class IseStateInput;
	class siResourceTexture;
	class siObjectTextureSprite;
	class seoTextureSprite;
	class seElem;
	class seSceneManager;
	class seStateSwitchInt1;
	class seStateTextureControl;
	class seStateLoop;
	class seStateFloat2;
	class ParticleOne;
	class seStateParticlesInfo;
	class seoParticles;

	class seoParticlesWork : public seObjectWork
	{
		friend class ParticleOne;

	private:
		// p[eBNPǗ
		seoParticles *_particlesObj; // `IuWFNg
		seElem *_elem; // Gg
		ParticleOne *_particlesList; // p[eBNXg
		ParticleOne *_lastParticles; // p[eBNXg̍Ō
		ParticleOne *_unuseList; // gpp[eBNXg
		bool _bPlay; // p[eBNۂ
		bool _successionScale; // XP[pۂ
		ParticlesRot::Type _successionRot; // ]pۂ
		ParticlesDrawPriority::Type _drawPriority; // `惂[h
		ParticlesOutType::Type _outType; // ݂̏o͏

		// Xe[^X
		seStateParticles *_partState; // p[eBNXe[^X
		seStateFloat2 *_uv;

		// Op[eBNĂ̌oߎ
		// p[eBN̏oʂ͂Pt[ɑ΂鐔Ŏw肳܂B
		// oߎԂt[^CŊ؂ȂꍇA]ɌJz
		// p[eBN̏oʂ𒲐܂B
		float _elapsedTime;

	public:
		virtual seObject *Object();

		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();

		// RXgN^
		seoParticlesWork(seElem *elem, seoParticles *obj);
		virtual ~seoParticlesWork();

		// [ÑZbg
		virtual void Reset();

		// `	
		virtual void Draw();

		// XV
		virtual void Update(float fAddTime);

	private:
		// p[eBNobt@̃NA
		void ClearBuffer();

		// gpXg̐擪ɒǉ
		void InsertUnuseTop(ParticleOne *p);

		// gpXgP擾
		ParticleOne *GetUnuseInstance();

		// Ɏg\̖gp̈Q
		ParticleOne *PeekNextUnuse();

		// p[eBNobt@̃TCY
		void ResizeParticlesBuffer(int iPartNum);

		// p[eBNobt@SĖgpɂ
		void ResetParticlesBuffer();
	};




	class seoParticles : public seObject
	{
	private:
		siObjectTextureSprite *_pSprite;
		glbColor _color;		// J[
		glbVector2 _size;		// TCY
		glbVector2 _uv;			// UV
		int iResourceID;		// \[XID
		bool bUpdateImage;		// ResourceIDɂ킹ăeNX`̍XV
		siResourceTexture *_pTexture;	// eNX`\[X擾
		seStateParticlesInfo *_pInfo;

	public:
		const glbColor *Color() const		{ return &this->_color; }
		void Color(const glbColor *value)	{ this->_color = *value; }

		const glbVector2 *Size() const		{ return &this->_size; }
		void Size(const glbVector2 *value);

		const glbVector2 *UV() const		{ return &this->_uv; }
		void UV(const glbVector2 *value);

		int ResourceID() const		{ return this->iResourceID; }
		void ResourceID(int value);


		siResourceTexture *ResourceTexture();

		const seStateParticlesInfo *Info() const;

		// Xe[^Xݒ
		void SetState(seStateParticlesInfo *state);

		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const;

		// RXgN^
		seoParticles();
		virtual ~seoParticles();


		// 
		virtual void Init(int iInObjectID, seSceneManager *pManager);

		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *elem);

		void Draw(int iElemID, const IGLMatrix *m, const glbColor *color);
		void Draw(int iElemID, const IGLMatrix *m, const IGLMatrix *mUV, const glbColor *color);

		virtual void Load(IseStateInput *input, seSceneManager *pManager);

	private:
		void UpdateImage();
	};
}

#endif // INCLUDE_SEOPARTICLES_H
