/**
 * @file seoScene.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEOSCENE_H
#define SEOSCENE_H
#pragma once
#include "evc/seObject/seObjectWork.h"
#include "evc/common/seDefine.h"

using namespace glb;

namespace glb
{
	struct glbVector2;
	class IGLMatrix;
	struct glbColor;
}
namespace evc
{
	class seResourceScene;
	class seSceneManager;
	class seoScene;
	class seElem;
	class seStateLoadControl;
	class seStateString;
	class siObjectColorSprite;
	class IseStateInput;

	// V[`掞ɕKvȃ[N
	class seoSceneWork : public seObjectWork
	{
	private:
		seSceneManager *pScene; // ێĂV[
		seoScene *pObject;
		seElem *pElem;

		// gXe[^X
		seStateLoadControl *pLoadControl;
		seStateString *pSceneAnim; // {ID̕

		// IuWFNg擾
	public:
		virtual seObject *Object();

		// [ÑV[擾
		seSceneManager *LocalScene() { return this->pScene; }

		// RXgN^
		seoSceneWork(seElem *pInElem, seoScene *pInObject);
		virtual ~seoSceneWork();

		// `	
		virtual void Draw();

		// [ÑZbg
		virtual void Reset();

		// Cxg̎s
		void DoEvent();


		// XV
		virtual void Update(float fAddTime);


		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();
	};


	// V[ċAIɌĂяopXvCg
	class seoScene : public seObject /*, IseObjResourceScene, IseObjResource */
	{
	public:
		static const glbVector2 sDefaultSize;

	private:
		siObjectColorSprite *pColorSprite;
		int iResourceID;
		seResourceScene *pTargetScene;
		glbColor sBgColor;

	public:

		// \[X̓o
		int ResourceID() const { return this->iResourceID; }
		void ResourceID(int value);

		// V[LbVF̃o𒼐ڐG邱Ƃ͍TĉB
		// CreateDrawWorkō쐬V[𑀍삵ĉB
		seResourceScene *ResourceScene();

		seoScene();
		virtual ~seoScene();

		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const { return emObject::Scene; }


		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *pElem);

		// wi`
		void DrawBg(int iElemID, const IGLMatrix *m, const glbColor *sMulColor);



		virtual void Load(IseStateInput *pInput, seSceneManager *pManager);
	};
}
#endif //SEOSCENE_H

