/**
 * @file seoSound.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEOSOUND_H
#define SEOSOUND_H
#pragma once
#include "evc/seObject/seObjectWork.h"
#include "evc/common/seDefine.h"
#include "evc/seElem/seStateTypeEx.h"

using namespace glb;
namespace evc
{
	class siObjectSound;
	class siResourceSound;
	class seElem;
	class seoSound;
	class seStateInt1;
	class seStateSoundControl;
	class IseStateInput;
	class seSceneManager;


	// TEhsɕKvȃ[N
	class seoSoundWork : public seObjectWork
	{
	private:
		siObjectSound *pObjectSound;
		// TEh		
		bool bDoUpdate; // XVtO
		seSoundControl::Type eSoundState;

		seElem *pElem;
		seoSound *pObject;

		// gXe[^X
		seStateInt1 *pVolume;
		seStateInt1 *pPan;
		seStateSoundControl *pSoundControl;


	public:
		virtual seObject *Object();

		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();

		// RXgN^
		seoSoundWork(seElem *pInElem, seoSound *pInObject);
		virtual ~seoSoundWork();

		// [NZbg
		virtual void Reset();

		// `	
		virtual void Draw();

		// XV
		virtual void Update(float fAddTime);


	private:
		// TEh炷
		void PlaySound(bool bLoop);
	};


	// TEh`
	class seoSound : public seObject
	{
	private:
		int iResourceID;
		siResourceSound *pResourceSound;
		float fSoundStart;
		float fSoundTime;

	public:
		seoSound();

		int ResourceID() const { return this->iResourceID; }
		void ResourceID(int value);

		// TEh\[X擾
		siResourceSound *ResourceSound();

		float SoundStart() const { return this->fSoundStart; }
		void SoundStart(float value){ this->fSoundStart = value; }

		float SoundTime() const { return this->fSoundTime; }
		void SoundTime(float value) { this->fSoundTime = value; }


		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const { return emObject::Sound; }

		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *pElem);

		virtual void Load(IseStateInput *pInput, seSceneManager *pManager);

	};
}
#endif //SEOSOUND_H

