/**
 * @file seoTextureSprite.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEOTEXTURESPRITE_H
#define SEOTEXTURESPRITE_H
#pragma once
#include "glb/IGLMatrix.h"
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "evc/common/seDefine.h"
#include "evc/seObject/seObjectWork.h"
#include "evc/seObject/seObject.h"

using namespace glb;
namespace evc
{
	class IseStateInput;
	class siResourceTexture;
	class siObjectTextureSprite;
	class seoTextureSprite;
	class seElem;
	class seSceneManager;
	class seStateSwitchInt1;
	class seStateTextureControl;
	class seStateLoop;
	class seStateFloat2;

	// eNX`[XvCg`掞ɕKvȃ[N
	class seoTextureSpriteWork : public seObjectWork
	{
	private:
		seoTextureSprite *pObject; // `IuWFNg
		seElem *pElem; // Gg
		seoTextureSprite *pDrawTexture;		// ̕`eNX`
		IGLMatrix *pUVMatrix;		// `惏[N
		IGLMatrix* apUV[4];
		glbVector2 sUVOffset; //  = glbVector2::Zero;

		// gXe[^X
		seStateSwitchInt1 *pTexture;
		seStateTextureControl *pTextureControl;
		seStateLoop *pLoop;
		seStateFloat2 *pUV;

		// `悷eNX`IuWFNg擾
		seoTextureSprite *TextureObject();

	public:
		virtual seObject *Object();

		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();

		// RXgN^
		seoTextureSpriteWork(seElem *pInElem, seoTextureSprite *pInObjct);
		virtual ~seoTextureSpriteWork();

		// [ÑZbg
		virtual void Reset();

		// `	
		virtual void Draw();
		// XV
		virtual void Update(float fAddTime);
	};


	// eNX``
	class seoTextureSprite : public seObject
	{
	private:
		siObjectTextureSprite *pSprite;
		glbVector2 sSize;
		glbVector2 sUV;
		int iResourceID;
		siResourceTexture *pResourceTexture;
		glbColor sColor;
		bool bUpdateImage;

	public:

		seoTextureSprite();
		virtual ~seoTextureSprite();

		// TCY
		const glbVector2 *Size() const { return &this->sSize; }
		void Size( const glbVector2 *value);

		// UV
		const glbVector2 *UV() const { return &this->sUV ; }
		void UV( const glbVector2 *value);

		// \[XID
		int ResourceID() const { return this->iResourceID; }
		void ResourceID(int value);

		// eNX`\[X擾
		siResourceTexture *ResourceTexture();


		// J[
		const glbColor *Color() const {return &this->sColor; }
		void Color( const glbColor *value) { this->sColor = *value; }


		// 
		virtual void Init(int iInObjectID, seSceneManager *pInScene);

		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const { return emObject::Texture; }


		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *pElem);


		void Draw(int iElemID, const IGLMatrix *m, const glbColor *sMulColor);
		void Draw(int iElemID, const IGLMatrix *m, const IGLMatrix *pUVMatrix, const glbColor *sMulColor);


		virtual void Load(IseStateInput *pInput, seSceneManager *pManager);

	private:
		// eNX`Ԃ̍XV
		void UpdateImage();


	};
}
#endif //SEOTEXTURESPRITE_H

