#include "glbPch.h"
#include "glb/glbDefine.h"
#include "glb/glbDebug.h"
#include "glb/glbVector.h"
#include "glb/IGLMatrix.h"
#include "evc/common/seMatrixWork.h"
#include "evc/file/IseStateIO.h"
#include "evc/scene/seObjectManager.h"
#include "evc/IO/siObject.h"
#include "evc/IO/siIOManager.h"
#include "evc/seObject/seObject.h"
#include "evc/seObject/ObjectParts/seoFont/seoFont.h"
#include "evc/seObject/ObjectParts/seoColorSprite.h"
#include "evc/seObject/ObjectParts/seoFrame.h"
#include "evc/seObject/ObjectParts/seoNum.h"
#include "evc/seObject/ObjectParts/seoScene.h"
#include "evc/seObject/ObjectParts/seoSound.h"
#include "evc/seObject/ObjectParts/seoTextureSprite.h"
#include "evc/seObject/ObjectParts/seoMesh.h"
#include "evc/seObject/ObjectParts/seoMeshChild.h"
#include "evc/seObject/ObjectParts/seoGrid.h"
#include "evc/seObject/ObjectParts/seoParticles.h"
#include "seObject.h"


using namespace glb;
namespace evc
{
	seObject::seObject()
		: iObjectID( seObjectManager::InvalidID )
		, pSceneManager( null )
	{}

	void seObject::Init(int iInObjectID, seSceneManager *pInScene)
	{
		this->iObjectID = iInObjectID;
		this->pSceneManager = pInScene;
	}

	seObject::~seObject()
	{
	}

	void seObject::Load(IseStateInput *pInput, seSceneManager *pManager)
	{
		this->iObjectID = pInput->ReadShort();
	}

	seObject *seObject::Create(emObject::Type eElemType)
	{
		switch (eElemType)
		{
			// YIuWFNgȂ
			case emObject::Null:
				return 0;
			// J[XvCg
			case emObject::Color:
				return evc_new seoColorSprite();
			// eNX`XvCg
			case emObject::Texture:
				return evc_new seoTextureSprite();
			// V[
			case emObject::Scene:
				return evc_new seoScene();
			// TEh
			case emObject::Sound:
				return evc_new seoSound();
			// 
			case emObject::Font:
				return evc_new seoFont();
			// l
			case emObject::Num:
				return evc_new seoNum();
			// l
			case emObject::Frame:
				return evc_new seoFrame();
			// bV
			case emObject::Mesh:
				return evc_new seoMesh();
			// bV_
			case emObject::MeshChild:
				return evc_new seoMeshChild();
			// Obh
			case emObject::Grid:
				return evc_new seoGrid();
			// p[eBN
			case emObject::Particles:
				return evc_new seoParticles();
			// ̑ȂAT[g
			default:
				break;
		}
		GLB_ASSERT(false);
		return 0;
	}
}
