/**
 * @file seObject.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEOBJECT_H
#define SEOBJECT_H
#pragma once
#include "evc/common/seDefine.h"

using namespace glb;
using namespace evc;
namespace glb
{
	struct glbColor;
	struct glbVector2;
}

namespace evc
{
	class seoTextureSprite;
	class seSceneManager;
	class seElem;
	class seObjectWork;
	class IseStateInput;
	class seResourceScene;
	class siResourceSound;
	class siResourceTexture;


	// lC[WXg
	struct seoNumImage
	{
		enum Type
		{
			NUM_0 = 0,
			NUM_1,
			NUM_2,
			NUM_3,
			NUM_4,
			NUM_5,
			NUM_6,
			NUM_7,
			NUM_8,
			NUM_9,
			Comma,
			Minus,
		};
		
		// Enum̍ől
		static int EnumMax() { return (int)Minus; }
		// Enum̎ސ
		static int EnumCount() { return (int)(Minus - NUM_0); }
	};

	class seObject
	{
	private:
		int iObjectID;
		seSceneManager *pSceneManager;

	public:
		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const = 0;

		// IuWFNghc擾
		int ObjectID() const { return this->iObjectID; }

		// ̐ẽV[}l[W擾
		seSceneManager *Scene() const { return this->pSceneManager; }

		// IuWFNghcm肵ɂPxĂ΂܂B
		virtual void Init(int iInObjectID, seSceneManager *pInScene);

		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *pElem ) = 0;

		seObject();
		virtual ~seObject();

		// [h
		virtual void Load(IseStateInput *pInput, seSceneManager *pManager);


		// vfIuWFNg쐬(IuWFNghcw)
		static seObject *Create(emObject::Type eElemType);

	};
}
#endif //SEOBJECT_H

