/**
 * @file glbColor.h
 * @brief glb pJ[\
 *
 * @author seri
 */
#ifndef INCLUDE_GLBCOLOR_H
#define INCLUDE_GLBCOLOR_H
#include "glb/glbDefine.h"

namespace glb
{
	/** 
	 * @brief glb pJ[\
	 */
	struct glbColor
	{
	public:
		// 
		const static glbColor White;

		glb::Byte R;
		glb::Byte G;
		glb::Byte B;
		glb::Byte A;

		/** 
		 * @brief 32bitARGBz擾
		 * @return ARGBl
		 */
		int ARGB() const
		{
			return (static_cast<int>(this->A) << 24) |
				   (static_cast<int>(this->R) << 16) | 
				   (static_cast<int>(this->G) <<  8) | 
				   (static_cast<int>(this->B) <<  0);
		}

		/** 
		 * @brief 32bitRGBAz擾
		 * @return RGBAl
		 */
		int RGBA() const
		{
			return (static_cast<int>(this->R) << 24) |
				   (static_cast<int>(this->G) << 16) | 
				   (static_cast<int>(this->B) <<  8) | 
				   (static_cast<int>(this->A) <<  0);
		}

		/** 
		 * @brief RXgN^
		 * @param R J[vf
		 * @param G J[vf
		 * @param B J[vf
		 * @param A J[vf
		 */
		glbColor(glb::Byte cR, glb::Byte cG, glb::Byte cB, glb::Byte cA)
			:R(cR), G(cG), B(cB), A(cA){}

		/** 
		 * @brief RXgN^
		 * @param psColor glbJ[\
		 */
		glbColor( const glbColor *c )
			:R(c->R), G(c->G), B(c->B), A(c->A){}

		/** 
		 * @brief RXgN^
		 * @param iRGBA RGBAl
		 */
//		glbColor(int iRGBA);


		/** 
		 * @brief RXgN^(ŏ)
		 */
		glbColor() : R(0), G(0), B(0), A(0) {}


		/** 
		 * @brief J[ݒ
		 * @param R J[vf
		 * @param G J[vf
		 * @param B J[vf
		 * @param A J[vf
		 */
		void Set(glb::Byte R, glb::Byte G, glb::Byte B, glb::Byte A)
		{
			this->R = R;
			this->G = G;
			this->B = B;
			this->A = A;
		}

		/** 
		 * @brief J[ݒ
		 * @param pColor J[vf
		 */
		void Set( const glbColor *c)
		{
			this->R = c->R;
			this->G = c->G;
			this->B = c->B;
			this->A = c->A;
		}

		/** 
		 * @brief J[|Z
		 * @param pColor J[vf
		 */
		void Mul(const glbColor *c)
		{
			this->R = static_cast<glb::Byte>((static_cast<int>(this->R) * c->R) / 255);
			this->G = static_cast<glb::Byte>((static_cast<int>(this->G) * c->G) / 255);
			this->B = static_cast<glb::Byte>((static_cast<int>(this->B) * c->B) / 255);
			this->A = static_cast<glb::Byte>((static_cast<int>(this->A) * c->A) / 255);
		}
	};

}

#endif // INCLUDE_GLBCOLOR_H
