#ifndef GLBDEBUG_H
#define GLBDEBUG_H
#ifdef WIN32
#include <windows.h>
#include <tchar.h>
#include <stdarg.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <cassert>
#include "glb/glbDefine.h"
#pragma once

// ϕfobOo
#ifndef GLB_DB_STRING
	#if defined(_DEBUG)
		#ifdef WIN32
			#define MSG_MAX 256
			inline void dbOutString( const char * fmt, ... )
			{
				char buf[MSG_MAX];
				va_list ap;
				va_start(ap, fmt);
				_vsnprintf_s( buf, MSG_MAX, fmt, ap );
				va_end(ap);
				OutputDebugStringA(buf);
			}
			#define GLB_DB_STRING( fmt, ... ) dbOutString( fmt, __VA_ARGS__ )
		#else
			#define GLB_DB_STRING printf( fmt, __VA_ARGS__ )
		#endif
	#else // _DEBUG
		#define GLB_DB_STRING( fmt, ... )
	#endif // _DEBUG 
#endif // GLB_DB_STRING

// AT[g
#ifndef GLB_ASSERT
	#if defined(_DEBUG)
		#define GLB_ASSERT( op ) assert( op )
	#else
		#define GLB_ASSERT( op )
	#endif
#endif // GLB_ASSERT

#endif // GLBDEBUG_H
