/**
 * @file glbDefine.h
 * @brief pr_playerʐݒ
 *
 * @author seri
 */
#ifndef INCLUDE_GLBDEFINE_H
#define INCLUDE_GLBDEFINE_H

#include "op_mem.h"
#include <algorithm>
#include <iostream>
#include <strstream>
#include <sstream>
#include <fstream>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <stack>
// glbDefineOɒ`̂ꍇGLB_USER_INCLUDE
// LɂglbUser.hpӂĉ
#if defined(GLB_USER_INCLUDE)
#include "glbUser.h"
#endif
#include "glb/IGLMatrix.h"
#include "glb/glbVector.h"

#ifndef est
#define est			std		// gpev[gCu
#endif // est

#ifndef null
#define null		0		// nulll
#endif // null

#ifdef WIN32
#define evc_typename	
#else
#define evc_typename	typename
#endif

// 擾֐
#ifndef GLB_RAND
#define GLB_RAND	rand
#endif // GLB_RAND

// 擾֐(0.0f`1.0f)
#ifndef GLB_RANDF
#define GLB_RANDF()	((float)GLB_RAND() / (float)RAND_MAX)
#endif // GLB_RANDF


// sin擾֐(floatw)
#ifndef GLB_SIN
#define GLB_SIN		est::sin
#endif // GLB_SIN

// cos擾֐(floatw)
#ifndef GLB_COS
#define GLB_COS		est::cos
#endif // GLB_COS


// vf擾
#ifndef GLB_ARRAY_COUNT
#define GLB_ARRAY_COUNT(x)	(int)(sizeof(x)/sizeof(x[0]))
#endif // GLB_ARRAY_COUNT


// vectorSĂɑ΂ď:iteratorƂitgp
#define VECTOR_FOR_EACH( _type, _vector, _func )			\
{															\
	est::vector<_type>::iterator it = _vector.begin();		\
	for(;it != _vector.end(); it++) { _func }				\
}

#define VECTOR_FOR_EACH_CONST( _type, _vector, _func )		\
{															\
	est::vector<_type>::const_iterator it = _vector.begin();\
	for(;it != _vector.end(); it++) { _func }				\
}

// mapSĂɑ΂ď:iteratorƂitgp
#define MAP_FOR_EACH( _key, _type, _map, _func )		\
{														\
	est::map<_key, _type>::iterator it = _map.begin();	\
	for(;it != _map.end(); it++) { _func }				\
}

// mapSĂɑ΂ď:iteratorƂitgp
#define MAP_FOR_EACH_CONST( _key, _type, _map, _func )	\
{														\
	est::map<_key, _type>::const_iterator it = _map.begin();	\
	for(;it != _map.end(); it++) { _func }				\
}

#ifdef WIN32
#define VECTOR_FOR_EACH_TMP			VECTOR_FOR_EACH
#define VECTOR_FOR_EACH_CONST_TMP	VECTOR_FOR_EACH_CONST
#define MAP_FOR_EACH_TMP			MAP_FOR_EACH
#define MAP_FOR_EACH_CONST_TMP		MAP_FOR_EACH_CONST

#else
// vectorSĂɑ΂ď:iteratorƂitgp
#define VECTOR_FOR_EACH_TMP( _type, _vector, _func )			\
{															\
	typename est::vector<_type>::iterator it = _vector.begin();		\
	for(;it != _vector.end(); it++) { _func }				\
}

#define VECTOR_FOR_EACH_CONST_TMP( _type, _vector, _func )		\
{															\
	typename est::vector<_type>::const_iterator it = _vector.begin();\
	for(;it != _vector.end(); it++) { _func }				\
}

// mapSĂɑ΂ď:iteratorƂitgp
#define MAP_FOR_EACH_TMP( _key, _type, _map, _func )		\
{														\
	typename est::map<_key, _type>::iterator it = _map.begin();	\
	for(;it != _map.end(); it++) { _func }				\
}

// mapSĂɑ΂ď:iteratorƂitgp
#define MAP_FOR_EACH_CONST_TMP( _key, _type, _map, _func )	\
{														\
	typename est::map<_key, _type>::const_iterator it = _map.begin();	\
	for(;it != _map.end(); it++) { _func }				\
}
#endif




// NX̃|C^ɑ΂ĈSdelete
#define GLB_SAFE_DELETE( _instance )	\
	if ( _instance != null ){ delete _instance; _instance = null; }


namespace glb
{
	// 1byte`
	typedef unsigned char	Byte;

	// ~
	static const float PI = 3.141592f;

	// EnumTCYp
	// Z[u̕ϐ^̃oCgɍ킹
	// numeric_limits͎g܂B
	static const int EnumByteMax = 0xff; // 1byte̍ő吮
	static const int EnumShortMax = 0x7fff; // 2byte̍ő吮
	static const int EnumIntMax = 0x7fffffff; // 4byte̍ő吮

	/** 
	 * @brief R[obNC^tF[X
	 */
		class deAction { public: virtual void operator ()() = 0; };
	template<class T> 
		class deAction1 { public: virtual void operator ()( T t ) = 0; };
	template<class T, class T2>
		class deAction2 { public: virtual void operator ()( T t, T2 t2 ) = 0; };
	template<class T, class T2, class T3>
		class deAction3 { public: virtual void operator ()( T t, T2 t2, T3 t3 ) = 0; };

	template<class Ret>
		class deFunc { public: virtual Ret operator ()() = 0; };
	template<class T, class Ret>
		class deFunc1 { public: virtual Ret operator ()( T t ) = 0; };
	template<class T, class T2, class Ret>
		class deFunc2 { public: virtual Ret operator ()( T t, T2 t2 ) = 0; };
	template<class T, class T2, class T3, class Ret>
		class deFunc3 { public: virtual Ret operator ()( T t, T2 t2, T3 t3 ) = 0; };


	template<class T>
	inline const T& MaxValue( const T &tData1, const T &tData2 ) { return (tData1 > tData2) ? tData1 : tData2; }

	template<class T>
	inline const T& MinValue( const T &tData1, const T &tData2 ) { return (tData1 < tData2) ? tData1 : tData2; }

	template<class T>
	inline const T AbsValue( const T &tData ) { return (tData < (T)0) ? -tData : tData; }


	// ͈͕t擾
	inline int RandLimit(int iMin, int iMax)
	{
		return (int)(GLB_RANDF() * (float)(iMax - iMin)) + iMin;
	}

	// vector̔z|C^Sč폜
	template <class T>
	inline void DeleteVector( est::vector<T *> &v )
	{
		for( unsigned int i = 0; i < v.size(); i++ )
		{
			delete v[ i ];
		}
		v.clear();
	}

	// map̃|C^Sč폜
	template <class K, class T>
	inline void DeleteMap( est::map<K, T *> &m )
	{
		evc_typename est::map<K, T *>::iterator it = m.begin();
		for(; it != m.end(); it++ )
		{
			delete it->second;
		}
		m.clear();
	}



	
	/** 
	 * @brief [Ugpp
	 */
	union ArbValue
	{
		int i;
		float f;
		void *pv;

		/** 
		 * @brief RXgN^
		 */
		ArbValue():i(0) {}

		/** 
		 * @brief p̐ݒ
		 * @param pValue Rs[
		 */
		void Set( const ArbValue *pValue ) { this->i = pValue->i; }
	};
}
#endif // INCLUDE_GLBDEFINE_H
