#include "glbPch.h"
/**
 * @file glbString.h
 * @brief ǗNX
 * R[hHÂ܂܂̒lŊǗ܂B
 * @author seri
 */
#include "glbString.h"

namespace glb
{

	// f[^ݒ
	glbString::glbString( seTextFormat::Type eType, const char *pBuffer, int iByteSize )
	{
		this->eFormat = eType;
		for( int i = 0; i < iByteSize; i++ )
		{
			this->stvBuffer.push_back( pBuffer[ i ] );
		}
		this->AddEndCode();
	}


	glbString::glbString( GLB_UNICODE *pcString )
	{
		this->eFormat = seTextFormat::Utf16;
		for( int i = 0; pcString[ i ] != L'\0'; i++ )
		{
			const char *pc = (const char *)(&pcString[ i ]);
			this->stvBuffer.push_back( pc[0] );
			this->stvBuffer.push_back( pc[1] );
		}
		this->AddEndCode();
	}

	glbString::glbString( const char *pcString )
	{
		this->eFormat = seTextFormat::Shift_Jis;
		for( int i = 0; pcString[ i ] != '\0'; i++ )
		{
			this->stvBuffer.push_back( pcString[ i ] );
		}
		this->AddEndCode();
	}
	
	// 
	glbString *glbString::Clone() const
	{
		glbString *p = evc_new  glbString();
		*p = *this;
		return p;
	}

	// e̔r
	bool glbString::operator == ( const glbString &str) const
	{
		return ( (this->eFormat == str.eFormat) &&
				 (this->stvBuffer == str.stvBuffer) );
	}

	glbString& glbString::operator = ( const glbString& str)
	{
		this->stvBuffer.assign( str.stvBuffer.begin(), str.stvBuffer.end() );
		this->eFormat = str.Format();
		return *this;
	}


	// IR[hǉ
	void glbString::AddEndCode()
	{
		// ̍ŌɏIR[hȂꍇ݂̂
		int iLastIndex = this->stvBuffer.size() - 1;
		if ( iLastIndex < 0 )
		{
			this->stvBuffer.push_back( '\0' );
			this->stvBuffer.push_back( '\0' );
			return;		
		}

		switch ( this->eFormat )
		{
			case seTextFormat::Shift_Jis:
				if ( this->stvBuffer[ iLastIndex ] != '\0' )
				{
					this->stvBuffer.push_back( '\0' );
				}

				break;
			case seTextFormat::Utf16:
				{
					short s = L'\0';
					const char *pc = (const char *)&s;

					if ( (this->stvBuffer[ iLastIndex - 1 ] != pc[ 0 ]) ||
						 (this->stvBuffer[ iLastIndex     ] != pc[ 1 ]) )
					{
						this->stvBuffer.push_back( pc[0] );
						this->stvBuffer.push_back( pc[1] );
					}
				}
				break;
		}
	}

}

