/**
 * @file glbVector.h
 * @brief xNgǗ
 *
 * @author seri
 */
#ifndef INCLUDE_GLBVECTOR_H
#define INCLUDE_GLBVECTOR_H



namespace glb
{
	/** 
	 * @brief 3DxNg
	 */
	struct glbVector
	{
	public:
		float X;
		float Y;
		float Z;

		/** 
		 * @brief RXgN^
		 * @param fX
		 * @param fY
		 * @param fZ
		 */
		glbVector(float fX, float fY, float fZ)
			:X(fX),Y(fY),Z(fZ){}
	};


	/** 
	 * @brief 2DxNg
	 */
	struct glbVector2
	{
	public:
		float X;
		float Y;

		/** 
		 * @brief RXgN^
		 */
		glbVector2() : X(0.0f), Y(0.0f) {}
		/** 
		 * @brief RXgN^
		 * @param fX
		 * @param fY
		 */
		glbVector2(float fX, float fY) : X(fX),Y(fY){}

		/** 
		 * @brief lݒ
		 * @param fX
		 * @param fY
		 */
		void Set(float fX, float fY)
		{
			this->X = fX;
			this->Y = fY;
		}
		/** 
		 * @brief lݒ
		 * @param sV
		 */
		void Set( const glbVector2 &v)
		{
			this->X = v.X;
			this->Y = v.Y;
		}

		/** 
		 * @brief Z
		 * @param sVector2
		 */
		void Sub( const glbVector2 &v)
		{
			this->X -= v.X;
			this->Y -= v.Y;
		}

		/** 
		 * @brief Z
		 * @param sVector2
		 */
		void Add( const glbVector2 &v)
		{
			this->X += v.X;
			this->Y += v.Y;
		}

		/** 
		 * @brief |Z
		 * @param sVector2
		 */
		void Mul( const glbVector2 &v)
		{
			this->X *= v.X;
			this->Y *= v.Y;
		}

		/** 
		 * @brief Z
		 * @param sVector2
		 */
		void Div( const glbVector2 &v)
		{
			this->X /= v.X;
			this->Y /= v.Y;
		}

		/** 
		 * @brief xNg̊evfgk܂
		 * @param fScale {
		 */
		void Scale(float fScale)
		{
			this->X *= fScale;
			this->Y *= fScale;
		}

		const static glbVector2 Zero;
		const static glbVector2 One;
	};


	/** 
	 * @brief 2DxNg
	 */
	struct glbVector2I
	{
	public:
		int X;
		int Y;

		/** 
		 * @brief RXgN^
		 */
		glbVector2I() : X(0),Y(0){}
		/** 
		 * @brief RXgN^
		 * @param fX
		 * @param fY
		 */
		glbVector2I(int iX, int iY) : X(iX),Y(iY){}

		/** 
		 * @brief lݒ
		 * @param fX
		 * @param fY
		 */
		void Set(int iX, int iY)
		{
			this->X = iX;
			this->Y = iY;
		}

		/** 
		 * @brief lݒ
		 * @param sV
		 */
		void Set( const glbVector2I &v)
		{
			this->X = v.X;
			this->Y = v.Y;
		}

		/** 
		 * @brief Z
		 * @param sVector2
		 */
		void Sub( const glbVector2I &v)
		{
			this->X -= v.X;
			this->Y -= v.Y;
		}

		/** 
		 * @brief Z
		 * @param sVector2
		 */
		void Add( const glbVector2I &v)
		{
			this->X += v.X;
			this->Y += v.Y;
		}

		const static glbVector2I Zero;
	};

}
#endif // INCLUDE_GLBVECTOR_H
